SystemOrganization addCategory: #'SqPlatypus-HW-CodeHolder'!
SystemOrganization addCategory: #'SqPlatypus-HW-GenericTokens'!
SystemOrganization addCategory: #'SqPlatypus-HW-tamaris'!
SystemOrganization addCategory: #'SqPlatypus-HW-unimplemented'!
SystemOrganization addCategory: #'SqPlatypus-VW-Compatibility'!

Notification subclass: #PlatypusExpressDebuggerNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-CodeHolder'!

StringHolder subclass: #PlatypusCodeMorph
	instanceVariableNames: 'mainWindow mainPane contentsMorph codeRow sourceHandler haveBrokenText textCanBeBroken'
	classVariableNames: 'InitialExtent'
	poolDictionaries: ''
	category: 'SqPlatypus-HW-CodeHolder'!

PlatypusCodeMorph subclass: #PlatypusCodeHolder
	instanceVariableNames: 'codeBtnRow codeBtnRowHeight codeButtons messagesBrowserHeight messagesBrowserRow messagesBrowser messagesBrowserLayoutFrame checking errorSplitter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-CodeHolder'!

!PlatypusCodeHolder class methodsFor: 'instance creation' stamp: 'apl 2/16/2006 22:03'!
sourceHandler: aSourceHandler errors: errorsList windowLabel: aLabel 
	| window codeHolder |
	codeHolder := self sourceHandler: aSourceHandler.
	window := codeHolder asMorph.
	aLabel
		ifNotNil: [window setLabel: aLabel].
	codeHolder takeErrors: errorsList.
	window openInWorld.
	^ codeHolder! !

!PlatypusCodeHolder methodsFor: 'ui building' stamp: 'AlainPlantec 10/15/2010 09:45'!
addButtons
	| |
	codeButtons := TamButtonsAlignmentMorph newRow.
	codeButtons vResizing: #shrinkWrap.
	codeBtnRow addMorph: codeButtons.
	self addButtonsinAlignment: codeButtons. 
! !

!PlatypusCodeHolder methodsFor: 'ui building' stamp: 'apl 4/29/2008 14:08'!
addButtonsinAlignment: aButtonsAlignment 
	| btn | 
	{}
		do: [:arr | arr == #spacer
				ifTrue: [aButtonsAlignment addSpacer]
				ifFalse: [btn := TamMaskableButtonMorph
								formName: arr first
								target: arr second
								selector: arr third
								extent: Tamaris buttonExtent
								balloonText: arr fourth.
					btn name: arr third.
					btn showSelector: arr fifth.
					aButtonsAlignment addMorph: btn]]! !

!PlatypusCodeHolder methodsFor: 'ui building' stamp: 'apl 3/23/2006 14:30'!
buildMainWindow
	mainWindow := super buildMainWindow.
	codeBtnRow := TamButtonsAlignmentMorph typicalRowOwner.
	messagesBrowser := TamGenericHierarchicalList new.
	messagesBrowser clientModel: self.
	mainPane
		addMorph: codeBtnRow
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ codeBtnRowHeight)).
	self addButtons.
	codeBtnRow minimumExtent: 1 @ 1.
	^ mainWindow! !

!PlatypusCodeHolder methodsFor: 'ui building' stamp: 'apl 2/15/2006 21:57'!
buildTamarisWindow
	mainWindow := super buildMainWindow.
	codeBtnRow := TamButtonsAlignmentMorph typicalRowOwner.
	messagesBrowser := TamGenericHierarchicalList new.
	messagesBrowser clientModel: self.
	mainPane
		addMorph: codeRow
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	^ mainWindow! !

!PlatypusCodeHolder methodsFor: 'accessing' stamp: 'apl 2/17/2006 11:02'!
checking
	^ checking ifNil: [checking := false]! !

!PlatypusCodeHolder methodsFor: 'code updating' stamp: 'apl 3/22/2007 17:09'!
checks: checkingSelector 
	self
		doChecking: [self sourceHandler isNil
				ifFalse: [self sourceHandler perform: checkingSelector].
			self takeErrors]! !

!PlatypusCodeHolder methodsFor: 'accessing' stamp: 'apl 11/8/2003 15:15'!
codeButtons 
	^ codeButtons! !

!PlatypusCodeHolder methodsFor: 'ui building' stamp: 'apl 6/23/2004 18:00'!
codeRowLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0 corner: 1 @ 1)
		offsets: (0 @ codeBtnRowHeight corner: 0 @ 0)! !

!PlatypusCodeHolder methodsFor: 'initialize/release' stamp: 'apl 3/22/2007 10:52'!
destroy
	codeButtons
		ifNotNil: [codeButtons destroy.
			codeButtons := nil].
	codeBtnRow
		ifNotNil: [codeBtnRow delete.
			codeBtnRow := nil].
	messagesBrowserRow
		ifNotNil: [messagesBrowserRow delete.
			messagesBrowserRow := nil].
	messagesBrowser
		ifNotNil: [messagesBrowser destroy.
			messagesBrowser := nil].
	messagesBrowserLayoutFrame
		ifNotNil: [messagesBrowserLayoutFrame destroy.
			messagesBrowserLayoutFrame := nil].
	super destroy! !

!PlatypusCodeHolder methodsFor: 'code updating' stamp: 'apl 3/20/2006 22:08'!
doChecking: aBlock 
	checking := true.
	aBlock
		ensure: [checking := false]! !

!PlatypusCodeHolder methodsFor: 'code accessing' stamp: 'apl 4/29/2008 14:01'!
getFullText
	self acceptContents: self codeText.
	self changed: #contents! !

!PlatypusCodeHolder methodsFor: 'ui updating' stamp: 'apl 2/21/2006 14:45'!
hideMessagesBrowser
	messagesBrowserRow
		ifNotNil: [(messagesBrowserLayoutFrame := messagesBrowserRow layoutFrame)
				ifNotNil: [self messageBrowserRowTopRow layoutFrame bottomFraction: messagesBrowserLayoutFrame bottomFraction.
					self messageBrowserRowTopRow layoutFrame bottomOffset: messagesBrowserLayoutFrame bottomOffset].
			messagesBrowserRow delete.
			errorSplitter
				ifNotNil: [errorSplitter delete.
					errorSplitter := nil].
			messagesBrowserRow := nil.
			mainPane updatePanesFromSubmorphs]! !

!PlatypusCodeHolder methodsFor: 'ui updating' stamp: 'apl 2/17/2006 10:54'!
hideOrShowMessageBrowser
	| rootsMessages |
	self messagesBrowser
		ifNotNil: [((rootsMessages := self messagesBrowser rootListItems) isNil
					or: [rootsMessages isEmpty])
				ifTrue: [self hideMessagesBrowser]
				ifFalse: [self showMessagesBrowser]].
	self changed: #hideOrShowMessageBrowser! !

!PlatypusCodeHolder methodsFor: 'initialize/release' stamp: 'AlainPlantec 10/14/2010 21:50'!
initialize
	super initialize. 
	codeBtnRowHeight := Tamaris buttonExtent y + 8.
	messagesBrowserHeight := 65! !

!PlatypusCodeHolder methodsFor: 'ui updating' stamp: 'apl 2/21/2006 14:44'!
messageBrowserRowTopRow
	^ codeRow! !

!PlatypusCodeHolder methodsFor: 'accessing' stamp: 'apl 11/8/2003 15:15'!
messagesBrowser
	^ messagesBrowser! !

!PlatypusCodeHolder methodsFor: 'ui building' stamp: 'apl 2/15/2006 21:30'!
messagesBrowserLayoutFrame
	^ messagesBrowserLayoutFrame
		ifNil: [messagesBrowserLayoutFrame := LayoutFrame
						fractions: (0 @ 1 corner: 1 @ 1)
						offsets: (0 @ (messagesBrowserHeight ) negated corner: 0 @ 0)]! !

!PlatypusCodeHolder methodsFor: 'menu' stamp: 'AlainPlantec 1/28/2011 14:22'!
openFile
	| result |
	result := Tamaris
			chooseFilePathMatching:  #('*.exp')
			label: 'Choose EXPRESS file to read' translated.
	result
		ifNotNil: [ | strm |
			[contents := (strm := StandardFileStream oldFileNamed: result) contentsOfEntireFile ]
				ensure: [strm close].
			self acceptContents: contents.
			self changed: #contents.
			self hasUnacceptedEdits: true]! !

!PlatypusCodeHolder methodsFor: 'ui updating' stamp: 'apl 2/21/2006 14:46'!
showMessagesBrowser
	messagesBrowserRow
		ifNil: [messagesBrowserRow := TamListItemReferenceUtil subWindowClass model: self.
			messagesBrowser buildWindow: messagesBrowserRow.
			mainPane
				ifNotNil: [mainPane addMorph: messagesBrowserRow fullFrame: self messagesBrowserLayoutFrame.
					self messageBrowserRowTopRow  layoutFrame bottomFraction: messagesBrowserRow layoutFrame topFraction.
					self messageBrowserRowTopRow  layoutFrame bottomOffset: messagesBrowserRow layoutFrame topOffset - TamListItemReferenceUtil subFrameBorderDelta.
					mainPane addPaneHSplitterBetween: self messageBrowserRowTopRow  and: {messagesBrowserRow}.
					errorSplitter := mainPane submorphs first.
					mainPane updatePanesFromSubmorphs.
					mainPane layoutChanged]]! !

!PlatypusCodeHolder methodsFor: 'accessing' stamp: 'apl 6/23/2004 18:25'!
sourceHandlerSilently: anObject contents: aString 
	super sourceHandlerSilently: anObject contents: aString.
	self updateMessagesBrowser! !

!PlatypusCodeHolder methodsFor: 'code updating' stamp: 'apl 11/8/2003 17:20'!
updateCodePaneIfNeeded
	self codeButtons
		ifNotNil: [self codeButtons updateIfNeeded]! !

!PlatypusCodeHolder methodsFor: 'error handling' stamp: 'apl 3/22/2007 19:29'!
updateMessagesBrowser
	self messagesBrowser
		ifNotNil: [self messagesBrowser
				rootListItems: (self errors
						collect: [:err | TamGenericHierarchicalListItem
								linked: (PlatypusVisitorErrorWrapper wrapped: err)]).
			self hideOrShowMessageBrowser]! !

PlatypusCodeHolder subclass: #PlatypusExpressCodeHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-CodeHolder'!

!PlatypusExpressCodeHolder class methodsFor: 'updating' stamp: 'apl 4/3/2006 17:13'!
changed: anObject 
	super changed: anObject! !

!PlatypusExpressCodeHolder class methodsFor: 'accessing' stamp: 'apl 3/10/2004 00:09'!
evaluatorClass
	^ PlatypusExpressInterpretor! !

!PlatypusExpressCodeHolder class methodsFor: 'instance creation' stamp: 'apl 3/16/2006 11:24'!
new
	| new |
	new := super new.
	PlatypusExpressCodeHolder addDependent: new.
	^ new! !

!PlatypusExpressCodeHolder methodsFor: 'ui building' stamp: 'AlainPlantec 5/2/2012 15:01'!
addButtonsinAlignment: aButtonsAlignment 
	| btn |
	super addButtonsinAlignment: aButtonsAlignment.
	{{'32x32/actions/run'. self. #evaluate. 'evaluate it'. #showEvaluateButton}.{'16x16/actions/blue_ok'. self. #checksAll. 'compile current code'. #showChecksButton}. {'16x16/actions/ok'. self. #accept. 'accept current source'. #showAcceptButton}. {'16x16/actions/smiley'. self. #prettyPrintCode. 'pretty print'. #showPrettyPrintCodeButton}. {'16x16/actions/file_save'. self. #saveAs. 'fileout contents'}. {'16x16/actions/file_read'. self. #openFile. 'filein an Express file'}}
		do: [:arr | arr == #spacer 
				ifTrue: [aButtonsAlignment addSpacer]
				ifFalse: [btn := TamMaskableButtonMorph
								formName: arr first
								target: arr second
								selector: arr third
								extent: Tamaris buttonExtent
								balloonText: arr fourth.
					btn name: arr third.
					aButtonsAlignment addMorph: btn.
					arr size >= 5
						ifTrue: [btn showSelector: arr fifth]]]! !

!PlatypusExpressCodeHolder methodsFor: 'code updating' stamp: 'apl 3/16/2006 11:17'!
broadcastChanged
	^ PlatypusExpressCodeHolder changed: self sourceHandler! !

!PlatypusExpressCodeHolder methodsFor: 'code updating' stamp: 'apl 4/3/2006 14:47'!
checks
		^ self checks: #checks! !

!PlatypusExpressCodeHolder methodsFor: 'code updating' stamp: 'apl 4/3/2006 14:47'!
checksAll
	^ self checks: #checksAll ! !

!PlatypusExpressCodeHolder methodsFor: 'code accessing' stamp: 'AlainPlantec 1/28/2011 06:17'!
codeText
	self haveBrokenText: false.
	^ super codeText! !

!PlatypusExpressCodeHolder methodsFor: 'code updating' stamp: 'AlainPlantec 5/2/2012 15:02'!
contents: input notifying: aRequestor 
	^ (super contents: input notifying: aRequestor) 
		ifTrue: 
			[(self sourceHandler notNil and: [(self sourceHandler isSchemaReference 
				or: [self sourceHandler isSchemaInstanceReference])]) ifTrue: [self checksAll].
			^ true]! !

!PlatypusExpressCodeHolder methodsFor: 'ui building' stamp: 'apl 2/20/2006 09:59'!
contentsMorphLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0 corner: 1 @ 1)
		offsets: (0 @ 0 corner: 0 @ 0)! !

!PlatypusExpressCodeHolder methodsFor: 'evaluation' stamp: 'apl 2/20/2006 17:40'!
debugIt
	| debugger |
	debugger := PlatypusExpressDebugger  sourceHandler: self sourceHandler.
	debugger buildMainWindow openInWorld.
	debugger
		evaluate: (ReadStream on: (self codeText copyFrom: self selectionInterval first to: self selectionInterval last) asString)! !

!PlatypusExpressCodeHolder methodsFor: 'initialize/release' stamp: 'apl 3/16/2006 11:17'!
destroy
	PlatypusExpressCodeHolder removeDependent: self.
	super destroy! !

!PlatypusExpressCodeHolder methodsFor: 'evaluation' stamp: 'apl 3/19/2004 09:55'!
doItContext
	^ self sourceHandler metaData! !

!PlatypusExpressCodeHolder methodsFor: 'evaluation' stamp: 'apl 3/21/2006 15:40'!
doItReceiver
	^ self ! !

!PlatypusExpressCodeHolder methodsFor: 'code evaluating' stamp: 'apl 3/22/2004 15:22'!
evaluate
	^ self sourceHandler evaluate! !

!PlatypusExpressCodeHolder methodsFor: 'code evaluating' stamp: 'apl 3/22/2004 15:23'!
evaluateAndExplore
	^ self sourceHandler evaluateAndExplore ! !

!PlatypusExpressCodeHolder methodsFor: 'code updating' stamp: 'apl 3/16/2006 11:22'!
modelWakeUpIn: aMorph 
	PlatypusExpressCodeHolder addDependent: self.
	super modelWakeUpIn: aMorph! !

!PlatypusExpressCodeHolder methodsFor: 'code updating' stamp: 'apl 4/3/2006 16:37'!
mustBeCheckAll
	| |
	self mustBeChecked
		ifTrue: [^ true].
"
	users := self sourceHandler schemaInstanceReference allUsers.
	users
		do: [:u | u knownAsInvalid
				ifTrue: [^ true]].
	^ false".
^ true! !

!PlatypusExpressCodeHolder methodsFor: 'code updating' stamp: 'apl 4/3/2006 14:27'!
mustBeChecked
	| schemaInstance oldValidationResult |
	^ self sourceHandler notNil
		and: [self sourceHandler knownAsInvalid or: [schemaInstance := self sourceHandler schemaInstance.
			(oldValidationResult := schemaInstance validationResult) isNil
				or: [oldValidationResult not]
				or: [schemaInstance validationDate isNil]
				or: [schemaInstance changeDate isNil]
				or: [(DateAndTime fromString: schemaInstance validationDate)
						< (DateAndTime fromString: schemaInstance changeDate)]]]! !

!PlatypusExpressCodeHolder methodsFor: 'pretty printing' stamp: 'apl 3/9/2006 12:40'!
prettyPrint
	self prettyPrintCode! !

!PlatypusExpressCodeHolder methodsFor: 'pretty printing' stamp: 'apl 2/15/2006 15:40'!
prettyPrintCode
	| ppTokenList |
	self sourceHandler notNil
		ifTrue: [Cursor wait
				showWhile: [ppTokenList := (PlatypusExpressScanner on: self contentsMorph text readStream ) buildTokenList.
					^ self prettyPrintTokenList: ppTokenList]].
	^ ''! !

!PlatypusExpressCodeHolder methodsFor: 'pretty printing' stamp: 'apl 5/22/2006 23:00'!
prettyPrintTokenList: aTokenList 
	| code ppTokenList streamClass |
	Cursor wait
		showWhile: [streamClass := self sourceHandler
						codeStreamClassFor: aTokenList
						from: aTokenList first
						to: aTokenList last.
			ppTokenList := PlatypusStepTokenPrettyPrinter new
						prettyPrint: aTokenList
						from: aTokenList first
						to: aTokenList last
						startLevel: self sourceHandler startLevel
						font: self codeFont
						maxLineWidth: contentsMorph bounds width - 5.
			ppTokenList noEndingEol.
			code := ppTokenList textWithStreamClass: streamClass.
			self acceptContents: code.
			self changed: #contents.
			contentsMorph hasUnacceptedEdits: true.
			^ code]! !

!PlatypusExpressCodeHolder methodsFor: 'pretty printing' stamp: 'apl 3/9/2006 12:40'!
prettyPrintWithColor
	self prettyPrintCode! !

!PlatypusExpressCodeHolder methodsFor: 'pretty printing' stamp: 'AlainPlantec 10/7/2010 13:46'!
reversePrintCode
	| ppTokenList |
	self sourceHandler notNil
		ifTrue: [Cursor wait
				showWhile: [ppTokenList := PlatypusSchemaInstanceTokenizer new tokenize: self sourceHandler metaData.
					^ self prettyPrintTokenList: ppTokenList]].
	^ ''! !

!PlatypusExpressCodeHolder methodsFor: 'menu' stamp: 'apl 6/8/2004 00:11'!
saveAs
	^ self sourceHandler menuSaveAs! !

!PlatypusExpressCodeHolder methodsFor: 'ui building' stamp: 'AlainPlantec 10/15/2010 10:54'!
showAcceptButton
	^ self sourceHandler notNil
				and: [self hasUnacceptedEdits]! !

!PlatypusExpressCodeHolder methodsFor: 'ui building' stamp: 'apl 4/6/2006 11:30'!
showChecksAllButton
	^ self sourceHandler notNil
		and: [self showAcceptButton not
				and: [self haveBrokenText not
						and: [self sourceHandler isEditable
								]]]! !

!PlatypusExpressCodeHolder methodsFor: 'ui building' stamp: 'apl 2/16/2006 21:28'!
showChecksButton
	^ self sourceHandler notNil
		and: [self showAcceptButton not
				and: [self haveBrokenText not
						and: [self sourceHandler isEditable
								and: [self mustBeChecked]]]]! !

!PlatypusExpressCodeHolder methodsFor: 'ui building' stamp: 'apl 4/19/2006 13:31'!
showEvaluateButton
	^ self sourceHandler notNil
		and: [self sourceHandler isEditable
				and: [self sourceHandler knownAsInvalid not
						and: [self sourceHandler metaData isPltStatementsContainer
		and: [self showChecksButton not
		and: [self showAcceptButton not]]]]]! !

!PlatypusExpressCodeHolder methodsFor: 'ui building' stamp: 'apl 2/16/2006 21:28'!
showPrettyPrintCodeButton
	^ self sourceHandler notNil
		and: [self haveBrokenText not
				and: [self sourceHandler isEditable]]! !

!PlatypusExpressCodeHolder methodsFor: 'code accessing' stamp: 'apl 2/9/2004 17:12'!
text
	^ self codeText
! !

!PlatypusExpressCodeHolder methodsFor: 'evaluation' stamp: 'apl 3/30/2006 23:11'!
update: aSymbol 
	(self hasUnacceptedEdits
			or: [self checking])
		ifTrue: [^ false].
	(self sourceHandler isNil
			or: [self sourceHandler isReleased])
		ifTrue: [self acceptContents: ''.
			self changed: #contents. ^ false].
	((aSymbol isKindOf: PlatypusListItemReference)
			and: [(aSymbol isInSubTreeOf: self sourceHandler)
					or: [self sourceHandler isInSubTreeOf: aSymbol]])
		ifTrue: [self acceptContents: self codeText.
			self changed: #contents].
	super update: aSymbol.
	aSymbol = #messagesBrowser
		ifTrue: [self updateMessagesBrowser]! !

PlatypusExpressCodeHolder subclass: #PlatypusExpressDebugger
	instanceVariableNames: 'debuggingContextRow contextsListRow selectedContextDataRow selectedContextValueRow stackValueRow selectedContextValueTextMorph interpreter selectedContextIndex selectedContextDataIndex stackValueTextMorph stackDataListRow stackDataIndex selfStackDataIndex selfStackDataListRow selectedContextsAndStacksListRow stacksRow prevSelectedContextIndex currentInterpreterMetaData overContextDataIndex result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-CodeHolder'!

!PlatypusExpressDebugger class methodsFor: 'instance creation' stamp: 'AlainPlantec 10/7/2010 13:46'!
interpretor: anInterpretor statementOrExpression: aMetaData
	| debugger |
	debugger := PlatypusExpressDebugger sourceHandler: anInterpretor currentSourceHandler.
	anInterpretor debugger: debugger.
	debugger interpreter: anInterpretor.
	debugger buildMainWindow openInWorld.
	debugger beforeAccepting: aMetaData.
	! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/28/2006 09:39'!
aboutToAccept: aMetaData 
	| maybeNewSourceHandler |
	self beforeAccepting.
	overContextDataIndex isNil
		ifTrue: [currentInterpreterMetaData := aMetaData.
			(maybeNewSourceHandler := self getSelectedContext contextInstance referenced ownerTamarisItemRef)
				ifNotNil: [self sourceHandler ~= maybeNewSourceHandler
						ifTrue: [self sourceHandler: maybeNewSourceHandler.
							self
								selectionInterval: (1 to: 0).
							self selectCode: self sourceHandler metaData selectionString startingAt: 1]].
			self selectCode.
			[currentInterpreterMetaData notNil]
				whileTrue: [mainWindow outermostWorldMorph doOneCycle]].
	overContextDataIndex
		ifNotNil: [self contextsList size <= overContextDataIndex
				ifTrue: [overContextDataIndex := nil]]! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'AlainPlantec 10/16/2010 11:03'!
addButtonsinAlignment: aButtonsAlignment 
	| button |
	button := PluggableButtonMorph
				on: self
				getState: #canShowIntoButton
				action: #doInto
				label: #intoButtonLabel.
	button onColor: Color transparent offColor: Color transparent;
		 borderWidth: 2;
		 borderColor: #raised.
	aButtonsAlignment owner addMorphBack: button.
	"Proceed"
	button := PluggableButtonMorph
				on: self
				getState: #canShowProceedButton
				action: #doProceed
				label: #proceedButtonLabel.
	button onColor: Color transparent offColor: Color transparent;
		 borderWidth: 2;
		 borderColor: #raised.
	aButtonsAlignment owner addMorphBack: button.
	"Over"
	button := PluggableButtonMorph
				on: self
				getState: #canShowOverButton
				action: #doOver
				label: #overButtonLabel.
	button onColor: Color transparent offColor: Color transparent;
		 borderWidth: 2;
		 borderColor: #raised.
	aButtonsAlignment owner addMorphBack: button.
	super addButtonsinAlignment: aButtonsAlignment! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 9/26/2006 17:51'!
beforeAccepting
	
	[self changed: #contextsList.
	self changedSelectedContextIndex: self contextsList size.
	self changed: #contextDataList.
	self changed: #stackDataList.
	self changed: #selfStackDataList.
	] 
			on: Error
			do: 
				[:ex | 
				Transcript show: self class name , '>>afterAccepting: "' , ex printString 
							, ' "\ ' withCRs]! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'AlainPlantec 10/7/2010 13:46'!
beforeAccepting: aMetaData
	currentInterpreterMetaData := aMetaData.
	self beforeAccepting! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 14:22'!
buildMainWindow
	mainWindow := super buildMainWindow.
	debuggingContextRow := TamListItemReferenceUtil subWindowClass model: self.
	contextsListRow := TamListItemReferenceUtil subWindowClass model: self.
	selectedContextsAndStacksListRow := TamListItemReferenceUtil subWindowClass model: self.
	selectedContextDataRow := TamListItemReferenceUtil subWindowClass model: self.
	selectedContextValueRow := TamListItemReferenceUtil subWindowClass model: self.
	stackDataListRow := TamListItemReferenceUtil subWindowClass model: self.
	selfStackDataListRow := TamListItemReferenceUtil subWindowClass model: self.
	stacksRow := TamListItemReferenceUtil subWindowClass model: self.
	selectedContextsAndStacksListRow addMorph: selectedContextDataRow fullFrame: self selectedContextDataRowLayoutFrame.
	selectedContextsAndStacksListRow addMorph: selectedContextValueRow fullFrame: self selectedContextValueRowLayoutFrame.
	stacksRow addMorph: stackDataListRow fullFrame: self stackDataRowLayoutFrame.
	stacksRow addMorph: selfStackDataListRow fullFrame: self selfStackDataRowLayoutFrame.
	selectedContextsAndStacksListRow addMorph: stacksRow fullFrame: self stacksRowLayoutFrame.
	debuggingContextRow addMorph: contextsListRow fullFrame: self contextsListRowLayoutFrame.
	debuggingContextRow addMorph: selectedContextsAndStacksListRow fullFrame: self selectedContextsAndStacksLayoutFrame.
	mainPane addMorph: debuggingContextRow fullFrame: self debuggingContextRowLayoutFrame.
	mainPane addPaneHSplitterBetween: codeRow and: {debuggingContextRow}.
	debuggingContextRow addPaneHSplitterBetween: contextsListRow and: {selectedContextsAndStacksListRow}.
	stacksRow addPaneHSplitterBetween: stackDataListRow and: {selfStackDataListRow}.
	selectedContextsAndStacksListRow addPaneVSplitterBetween: selectedContextDataRow and: {selectedContextValueRow}.
	selectedContextsAndStacksListRow addPaneVSplitterBetween: selectedContextValueRow and: {stacksRow}.
	contextsListRow
		addMorph: self contextsListMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	selectedContextDataRow
		addMorph: self contextDataListMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	selectedContextValueRow
		addMorph: self selectedContextValueMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	selfStackDataListRow
		addMorph: self selfStackDataListMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	stackDataListRow
		addMorph: self stackDataListMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	^ mainWindow! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/27/2006 21:27'!
canShowIntoButton
	^ currentInterpreterMetaData notNil! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/27/2006 21:30'!
canShowOverButton
	^ currentInterpreterMetaData notNil! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/27/2006 21:27'!
canShowProceedButton
	^ currentInterpreterMetaData notNil! !

!PlatypusExpressDebugger methodsFor: 'selected context data handling' stamp: 'apl 3/27/2006 18:38'!
changedSelectedContextDataIndex: anInteger 
	| |
	selectedContextDataIndex := anInteger.
	self changed: #selectedContextDataIndex.
	self changed: #selectedContextValueContents.
	selectedContextValueTextMorph update: #selectedContextValueContents.
! !

!PlatypusExpressDebugger methodsFor: 'contexts list handling' stamp: 'AlainPlantec 1/28/2011 11:25'!
changedSelectedContextIndex: anInteger 
	| maybeNewSourceHandler |
	anInteger > 0 ifFalse: [^self].
	selectedContextIndex := anInteger.
	self changed: #selectedContextIndex.
	self changed: #contextDataList.
	self changedSelectedContextDataIndex: 0.
	(maybeNewSourceHandler := (self contextsList at: anInteger) 
				contextInstance referenced 
				ownerTamarisItemRef) ifNotNil: [self sourceHandler: maybeNewSourceHandler].
	self selectCode! !

!PlatypusExpressDebugger methodsFor: 'self stack data handling' stamp: 'apl 2/20/2006 23:50'!
changedSelfStackDataIndex: anInteger 
	selfStackDataIndex := anInteger.
	self changed: #selfStackDataIndex.
! !

!PlatypusExpressDebugger methodsFor: 'satck data handling' stamp: 'apl 2/20/2006 22:34'!
changedStackDataIndex: anInteger 
	stackDataIndex := anInteger.
	self changed: #stackDataIndex.
! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 14:20'!
codeRowLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0 corner: 1 @ 1)
		offsets: (0 @ codeBtnRowHeight corner: 0 @ (self debuggingContextRowHight ) negated)! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 14:19'!
contentsMorphLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0 corner: 1 @ 1)
		offsets: (0 @ 0 corner: 0 @ 0)! !

!PlatypusExpressDebugger methodsFor: 'selected context data handling' stamp: 'apl 2/20/2006 19:53'!
contextDataList
	| interprContext |
	selectedContextIndex > 0 ifFalse: [^#()].
	interprContext := interpreter contextsStack at: selectedContextIndex.
	^interprContext dataIndex keys asOrderedCollection collect: [:e | e name]! !

!PlatypusExpressDebugger methodsFor: 'selected context data handling' stamp: 'apl 2/20/2006 23:34'!
contextDataListMorph
	^ PluggableListMorph
		on: self
		list: #contextDataList
		selected: #selectedContextDataIndex
		changeSelected: #changedSelectedContextDataIndex:
	menu: nil
		keystroke: #arrowKey:from:! !

!PlatypusExpressDebugger methodsFor: 'contexts list handling' stamp: 'apl 2/20/2006 17:52'!
contextsList
	^ interpreter contextsStack! !

!PlatypusExpressDebugger methodsFor: 'contexts list handling' stamp: 'apl 2/20/2006 19:56'!
contextsListMorph
	^ PluggableListMorph
		on: self
		list: #contextsList
		selected: #selectedContextIndex
		changeSelected: #changedSelectedContextIndex:! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 13:56'!
contextsListRowHight
	^ 120! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 12:18'!
contextsListRowLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0 corner: 1 @ 1)
		offsets: (0 @ TamListItemReferenceUtil subFrameBorderDelta corner: 0 @ (TamListItemReferenceUtil subFrameBorderDelta + self contextsListRowHight) negated)! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 13:55'!
debuggingContextRowHight
	^ 200! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 12:35'!
debuggingContextRowLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 1 corner: 1 @ 1)
		offsets: (0 @ (self debuggingContextRowHight) negated corner: 0 @ 0)! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/27/2006 21:27'!
doInto
	currentInterpreterMetaData := nil! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/28/2006 09:29'!
doOver
	overContextDataIndex := selectedContextDataIndex.
	currentInterpreterMetaData := nil! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/27/2006 21:27'!
doProceed
	currentInterpreterMetaData := nil.
	interpreter debugger: nil.
	mainWindow delete! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 2/20/2006 17:21'!
evaluate
	| metaData |
	sourceHandler
		ifNotNil: [metaData := self sourceHandler metaData.
			interpreter
				compute: (Array with: metaData)
				in: self doItContext
				to: self doItReceiver
				notifying: self
				ifFail: []
				logged: false]! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 2/23/2006 22:11'!
evaluate: aStream 
	| metaData |
	sourceHandler
		ifNotNil: [metaData := self sourceHandler metaData.
			interpreter
				evaluate: aStream
				in: metaData
				to: nil
				notifying: self
				ifFail: [].
			self inform: 'Done']! !

!PlatypusExpressDebugger methodsFor: 'contexts list handling' stamp: 'apl 2/20/2006 19:57'!
getSelectedContext
	^ self selectedContextIndex = 0
		ifFalse: [self contextsList at: self selectedContextIndex]! !

!PlatypusExpressDebugger methodsFor: 'selected context data handling' stamp: 'apl 2/20/2006 19:55'!
getSelectedContextData
	self selectedContextDataIndex = 0
		ifTrue: [^ nil].
	^ self contextDataList at: self selectedContextDataIndex! !

!PlatypusExpressDebugger methodsFor: 'initialize/release' stamp: 'apl 2/21/2006 11:04'!
initialize
	super initialize.
	interpreter := PlatypusExpressInterpretor new debugger: self.
prevSelectedContextIndex := 0.! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/27/2006 18:17'!
interpreter: anInterpretor 
	interpreter := anInterpretor! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 3/27/2006 21:26'!
intoButtonLabel
	^ 'Into'! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 14:47'!
messageBrowserRowTopRow
	^ debuggingContextRow! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 3/27/2006 21:30'!
overButtonLabel
	^ 'Over'! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 3/27/2006 21:26'!
proceedButtonLabel
	^ 'Proceed'! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 2/22/2006 12:21'!
result
	^ result! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 2/20/2006 17:02'!
run
	sourceHandler ifNotNil: [
	]
	! !

!PlatypusExpressDebugger methodsFor: 'debugging' stamp: 'apl 3/28/2006 20:22'!
selectCode
	currentInterpreterMetaData
		ifNotNil: [self selectCode: currentInterpreterMetaData selectionString startingAt: self selectionInterval first.
			(currentInterpreterMetaData isPltStatement
					or: [currentInterpreterMetaData isPltContextDefinition])
				ifTrue: [self selectionInterval: self selectionInterval.
					Transcript show: self selectionInterval printString , String cr]]! !

!PlatypusExpressDebugger methodsFor: 'selected context data handling' stamp: 'apl 2/20/2006 19:55'!
selectedContextDataIndex
	^ selectedContextDataIndex
		ifNil: [selectedContextDataIndex := 0]! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 12:47'!
selectedContextDataRowLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0 corner: 0.333 @ 1)
		offsets: (0 @ 0 corner: (TamListItemReferenceUtil subFrameBorderDelta negated) @ 0)! !

!PlatypusExpressDebugger methodsFor: 'contexts list handling' stamp: 'apl 2/20/2006 19:56'!
selectedContextIndex
	^ selectedContextIndex
		ifNil: [selectedContextIndex := 0]! !

!PlatypusExpressDebugger methodsFor: 'selected context value handling' stamp: 'apl 2/20/2006 19:44'!
selectedContextValueContents
	| ident |
	^ (ident := self getSelectedContextData)
		ifNil: ['']
		ifNotNil: [(self getSelectedContext dataNamed: ident) val asClearText]! !

!PlatypusExpressDebugger methodsFor: 'selected context value handling' stamp: 'apl 2/20/2006 20:04'!
selectedContextValueContents: aStringOrText notifying: aRequestor 
	 selectedContextValueTextMorph acceptContents: aStringOrText! !

!PlatypusExpressDebugger methodsFor: 'selected context value handling' stamp: 'apl 2/20/2006 20:03'!
selectedContextValueMorph
	^ selectedContextValueTextMorph ifNil: [selectedContextValueTextMorph := TamTextMorph
		on: self
		text: #selectedContextValueContents
		accept: #selectedContextValueContents:notifying:
		readSelection: nil
		menu: nil]! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 12:48'!
selectedContextValueRowLayoutFrame
	^ LayoutFrame
		fractions: (0.333 @ 0 corner: 0.666 @ 1)
		offsets: (0 @ 0 corner: TamListItemReferenceUtil subFrameBorderDelta negated @ 0)! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 12:17'!
selectedContextsAndStacksLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 1 corner: 1 @ 1)
		offsets: (0 @ self contextsListRowHight negated corner: 0 @ 0)! !

!PlatypusExpressDebugger methodsFor: 'self stack data handling' stamp: 'apl 2/20/2006 22:56'!
selfStackDataIndex
	^ selfStackDataIndex
		ifNil: [selfStackDataIndex := 0]! !

!PlatypusExpressDebugger methodsFor: 'self stack data handling' stamp: 'apl 2/20/2006 23:48'!
selfStackDataList
	^ interpreter selfStack collect: [:s | s printableCode]! !

!PlatypusExpressDebugger methodsFor: 'self stack data handling' stamp: 'apl 2/20/2006 23:33'!
selfStackDataListMorph
	^ PluggableListMorph
		on: self
		list: #selfStackDataList
		selected: #selfStackDataIndex
		changeSelected: #changedSelfStackDataIndex:
menu: nil
		keystroke: #arrowKey:from:! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 13:46'!
selfStackDataRowLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0.5 corner: 1 @ 1)
		offsets: (0 @ TamListItemReferenceUtil subFrameBorderDelta corner: 0 @ 0)! !

!PlatypusExpressDebugger methodsFor: 'satck data handling' stamp: 'apl 2/20/2006 22:11'!
stackDataIndex
	^ stackDataIndex
		ifNil: [stackDataIndex := 0]! !

!PlatypusExpressDebugger methodsFor: 'satck data handling' stamp: 'apl 2/20/2006 22:12'!
stackDataList
	^ interpreter stack! !

!PlatypusExpressDebugger methodsFor: 'satck data handling' stamp: 'apl 2/20/2006 23:33'!
stackDataListMorph
	^ PluggableListMorph
		on: self
		list: #stackDataList
		selected: #stackDataIndex
		changeSelected: #changedStackDataIndex:
	menu: nil
		keystroke: #arrowKey:from:! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 13:45'!
stackDataRowLayoutFrame
	^ LayoutFrame
		fractions: (0 @ 0 corner: 1 @ 0.5)
		offsets: (0 @ 0 corner: 0 @ 0)! !

!PlatypusExpressDebugger methodsFor: 'ui building' stamp: 'apl 2/21/2006 13:48'!
stacksRowLayoutFrame
	^ LayoutFrame
		fractions: (0.666 @ 0 corner: 1 @ 1)
		offsets: (0 @ 0 corner: 0 @ 0)! !

PlatypusCodeHolder subclass: #PlatypusStepModelContentsCodeHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-CodeHolder'!

!PlatypusStepModelContentsCodeHolder class methodsFor: 'instance creation' stamp: 'apl 3/16/2006 11:24'!
new
	| new |
	new := super new.
	PlatypusStepModelContentsCodeHolder addDependent: new.
	^ new! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui building' stamp: 'AlainPlantec 5/10/2012 23:03'!
addButtonsinAlignment: aButtonsAlignment 
	| btn |
	super addButtonsinAlignment: aButtonsAlignment.
	{{'32x32/actions/run'. self. #evaluate. 'evaluate it'. #showEvaluateButton}. {'16x16/actions/p21_syntax'. self. #menuSwitchP21Syntax. 'switch between p21 and alternative syntax'. #showSwitchP21SyntaxButton}. {'16x16/actions/blue_ok'. self. #checks. 'compile current code'. #showChecksButton}. {'16x16/actions/ok'. self. #accept. 'accept current source'. #showAcceptButton}. {'16x16/actions/file_save'. self. #saveAs. 'save contents into a step file'. #showSaveButton}. {'16x16/actions/file_read'. self. #openFile. 'read a file'}}
		do: [:arr | arr == #spacer
				ifTrue: [aButtonsAlignment addSpacer]
				ifFalse: [btn := TamMaskableButtonMorph
								formName: arr first
								target: arr second
								selector: arr third 
								extent: Tamaris buttonExtent
								balloonText: arr fourth.
					btn name: arr third.
					aButtonsAlignment addMorph: btn.
					arr size >= 5
						ifTrue: [btn showSelector: arr fifth]]]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'code updating' stamp: 'apl 3/16/2006 11:21'!
broadcastChanged
	^ PlatypusStepModelContentsCodeHolder changed: self! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'code updating' stamp: 'apl 3/21/2006 22:27'!
checks
	| result |
	self
		doChecking: [Cursor wait
				showWhile: [result := self sourceHandler checks.
					self takeErrors.
					^ result]].
	^ true! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'code accessing' stamp: 'apl 7/27/2004 10:45'!
codeText
	self haveBrokenText: false.
	^ super codeText! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'initialize/release' stamp: 'apl 3/16/2006 11:21'!
destroy
	PlatypusStepModelContentsCodeHolder removeDependent: self.
	super destroy! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'evaluation' stamp: 'apl 12/15/2003 11:51'!
doItContext
	^ self sourceHandler! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'evaluation' stamp: 'apl 12/15/2003 11:51'!
doItReceiver
	^ self ! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'evaluating' stamp: 'apl 6/8/2004 10:20'!
evaluate
	^ self sourceHandler evaluate! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'menu' stamp: 'AlainPlantec 1/28/2011 14:03'!
menuStepWrite
	| stream result fullFilename |
	(self sourceHandler isKindOf: PlatypusModelContentsReference)
		ifTrue: [self sourceHandler menuStepWrite]
		ifFalse: [fullFilename := UITheme current
						fileSaveIn: World
						title: 'File name'
						extensions: #('step' ) 
						path: ''.
			fullFilename
				ifNotNil: [[stream := (Filename named: fullFilename) writeStream.
					stream
						nextPutAll: (String
								readFrom: (ReadStream on: self contentsMorph getText asString))]
						ensure: [stream
								ifNotNil: [stream close]]]]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'menu' stamp: 'apl 6/1/2004 08:40'!
menuSwitchP21Syntax
	self swithP21Syntax.
	self acceptContents: self codeText.
	self changed: #contents! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui opening/closing' stamp: 'apl 3/16/2006 11:21'!
modelWakeUpIn: aMorph 
	PlatypusStepModelContentsCodeHolder addDependent: self.
	super modelWakeUpIn: aMorph! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'code updating' stamp: 'apl 3/20/2006 21:48'!
mustBeChecked
	| modelContents oldValidationResult |
	^ self sourceHandler notNil
		and: [modelContents := self sourceHandler modelContents.
			(oldValidationResult := modelContents validationResult) isNil
				or: [oldValidationResult not
						or: [modelContents validationDate isNil
								or: [modelContents changeDate isNil
										or: [(DateAndTime fromString: modelContents validationDate)
												< (DateAndTime fromString: modelContents changeDate)]]]]]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 4/26/2012 11:18'!
openFile
	| result |
	result := Tamaris
			chooseFilePathMatching:  #('*.step' '*.p21' '*.STEP' '*.P21')
			label: 'Choose a STEP file to read' translated.
	result
		ifNotNil: [ | strm |
			[contents := (strm := StandardFileStream oldFileNamed: result) contentsOfEntireFile ]
				ensure: [strm close].
			self acceptContents: contents.
			self changed: #contents.
			self hasUnacceptedEdits: true]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'menu' stamp: 'apl 7/10/2004 16:44'!
saveAs
	^ self menuStepWrite! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui building' stamp: 'AlainPlantec 10/15/2010 10:54'!
showAcceptButton
	^ self sourceHandler notNil
				and: [self sourceHandler modelContents notNil
						and: [self hasUnacceptedEdits]]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui building' stamp: 'apl 1/19/2005 10:41'!
showChecksButton
	^ self sourceHandler notNil
		and: [self showAcceptButton not and: [self sourceHandler modelContents notNil
				and: [self haveBrokenText not
						and: [self mustBeChecked]]]]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui building' stamp: 'AlainPlantec 10/1/2010 12:36'!
showEvaluateButton
	^( ((self sourceHandler notNil
		and: [self sourceHandler canEvaluate])
and: [self sourceHandler knownAsInvalid not])
		and: [self showChecksButton not])
		and: [self showAcceptButton not]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui building' stamp: 'apl 4/4/2006 14:10'!
showMetaChecksButton
	^ self sourceHandler notNil
		and: [self sourceHandler isModelContentsReference
				and: [self showAcceptButton not
						and: [self sourceHandler modelContents notNil
								and: [self haveBrokenText not
										and: [self mustBeChecked not
												and: [self sourceHandler haveMetaConceptDefinitions]]]]]]! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui building' stamp: 'apl 4/29/2008 14:03'!
showSaveButton
	^ (self sourceHandler isKindOf: PlatypusModelContentsReference)! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'ui building' stamp: 'apl 6/15/2004 13:22'!
showSwitchP21SyntaxButton
	^ self sourceHandler notNil
		"and: [self sourceHandler value isValue not]"! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'menu' stamp: 'apl 6/25/2004 12:25'!
swithP21Syntax
	self useP21Syntax: self useP21Syntax not! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'code updating' stamp: 'apl 2/17/2006 11:03'!
update: aSymbol 
	| doUpdate |
	doUpdate := false.
	(self hasUnacceptedEdits
			or: [self checking])
		ifFalse:  [(aSymbol isKindOf: PlatypusListItemReference)
				ifTrue: [self sourceHandler notNil
						ifTrue: [(self sourceHandler isReleased
									or: [(aSymbol includes: self sourceHandler)
											or: [self sourceHandler includes: aSymbol]])
								ifTrue: [doUpdate := true]]].
			aSymbol == #PlatypusDictionary
				ifTrue: [doUpdate := true].
			doUpdate
				ifTrue: [self sourceHandler isReleased
						ifTrue: [sourceHandler := nil].
					self acceptContents: self codeText.
					self changed: #contents].
			super update: aSymbol].
	self updateMessagesBrowser! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'accessing' stamp: 'apl 6/25/2004 12:30'!
useP21Syntax
	^ self sourceHandler useP21Syntax! !

!PlatypusStepModelContentsCodeHolder methodsFor: 'accessing' stamp: 'apl 6/25/2004 12:26'!
useP21Syntax: aBoolean 
	self sourceHandler useP21Syntax: aBoolean! !

!PlatypusCodeMorph class methodsFor: 'utilities' stamp: 'apl 6/23/2004 17:43'!
cleanCommentsOf: aTextOrString 
	| level loop prevChar inStream outputStream currentCharacter inComment |
	level := 1.
	inStream := ReadStream on: aTextOrString.
	outputStream := WriteStream on: String new.
	currentCharacter := inStream next.
	outputStream nextPut: currentCharacter.
	loop := inStream atEnd not.
	inComment := false.
	[loop]
		whileTrue: [inStream atEnd
				ifTrue: [loop := false]
				ifFalse: [prevChar := currentCharacter.
					currentCharacter := inStream next.
					(prevChar == $(
							and: [currentCharacter == $*])
						ifTrue: [level == 1
								ifTrue: [outputStream position: outputStream position - 1. outputStream nextPut: $ ].
							level := level + 1.
							inComment := true]
						ifFalse: [(prevChar == $*
									and: [currentCharacter == $)])
								ifTrue: [level := level - 1.
									level == 0
										ifTrue: [loop := false]]].
					inComment
						ifTrue: [outputStream nextPut: $ .
							level == 1
								ifTrue: [inComment := false]]
						ifFalse: [outputStream nextPut: currentCharacter]]].
	^ outputStream contents! !

!PlatypusCodeMorph class methodsFor: 'utilities' stamp: 'apl 6/23/2004 17:43'!
code: codeString match: aMatchString 
	^ self
		code: codeString
		match: aMatchString
		startingAt: 1"examples :  
	TamCodeHolder code: 'dqsqsdqsdqsd l := l + 1 ; jmk jmlkjmlj' match: 'l+1;'  
	TamCodeHolder code: 'l:=l+1;' match: 'l:=l+1;'  
	TamCodeHolder code: '	l	:=	l	+	1	;	' match: 'l:=l+1;'  
	TamCodeHolder code: ' l+1;' match: 'l:=l+1;'  
	TamCodeHolder code: ' l+1;' match: 'l+1'  
	"
! !

!PlatypusCodeMorph class methodsFor: 'utilities' stamp: 'AlainPlantec 10/7/2010 13:43'!
code: codeString match: aMatchString startingAt: firstPos 
	| csize msize mpos cpos startCodePos stopCodePos cleanedCode cleanedMatchString |
	cleanedCode := codeString asString asUppercase.
	"self cleanCommentsOf:"
	cleanedMatchString := aMatchString asUppercase.
	"self cleanCommentsOf:"
	csize := cleanedCode size.
	msize := cleanedMatchString size.
	mpos := 1.
	cpos := firstPos.
	startCodePos := 0.
	stopCodePos := 0.
	[mpos <= msize
		and: [cpos <= csize]]
		whileTrue: ["(cleanedCode at: cpos) = $. ifTrue: [self halt]."
			((cleanedCode at: cpos)
						= (cleanedMatchString at: mpos))
				ifTrue: [startCodePos = 0
						ifTrue: [startCodePos := cpos].
					stopCodePos := cpos.
					mpos := mpos + 1.
					cpos := cpos + 1]
				ifFalse: [		mpos = 1
						ifTrue: [cpos := cpos + 1].
					mpos := 1.
					startCodePos := stopCodePos := 0].
			[cpos < csize
				and: [(cleanedCode at: cpos) isSeparator]]
				whileTrue: [cpos := cpos + 1]].
	
	^ Array
		with: mpos > msize
		with: startCodePos
		with: stopCodePos! !

!PlatypusCodeMorph class methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2010 17:47'!
codeFont
	^ StandardFonts codeFont! !

!PlatypusCodeMorph class methodsFor: 'accessing' stamp: 'AlainPlantec 10/15/2010 13:21'!
initialExtent
	^ InitialExtent
		ifNil: [InitialExtent := 800@600]! !

!PlatypusCodeMorph class methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 13:43'!
initialExtent: aPoint 
	InitialExtent := aPoint! !

!PlatypusCodeMorph class methodsFor: 'message handling' stamp: 'apl 6/23/2004 17:43'!
perform: selector orSendTo: otherTarget 
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!PlatypusCodeMorph class methodsFor: 'instance creation' stamp: 'apl 6/23/2004 17:43'!
sourceHandler: aSourceHandler 
	^ self new sourceHandler: aSourceHandler! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 3/10/2005 11:15'!
accept
	^ contentsMorph accept! !

!PlatypusCodeMorph methodsFor: 'menu' stamp: 'apl 6/23/2004 17:43'!
addModelItemsToWindowMenu: aMenu 
	aMenu addLine.
	aMenu
		add: 'remember window size'
		target: self
		action: #rememberWindowSize! !

!PlatypusCodeMorph methodsFor: 'morphic wrapper' stamp: 'apl 6/23/2004 17:43'!
asMorph
	^ self buildMainWindow
! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 6/23/2004 17:43'!
broadcastChanged
	^ self! !

!PlatypusCodeMorph methodsFor: 'ui building' stamp: 'apl 2/20/2006 09:49'!
buildMainWindow
	mainWindow := (SystemWindow labelled: self labelString)
				model: self.
	mainPane := TamListItemReferenceUtil subWindowClass model: self.
	mainWindow
		addMorph: mainPane
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	codeRow := TamListItemReferenceUtil subWindowClass model: self.
	codeRow
		addMorph: self contentsMorph
		fullFrame: self contentsMorphLayoutFrame.
	mainPane addMorph: codeRow fullFrame: self codeRowLayoutFrame.
	mainPane extent: self initialExtent.
	^ mainWindow! !

!PlatypusCodeMorph methodsFor: 'ui building' stamp: 'apl 2/20/2006 09:38'!
buildTamarisWindow
	mainWindow := (SystemWindow labelled: self labelString)
				model: self.
	mainPane := TamListItemReferenceUtil subWindowClass model: self.
	mainPane borderWidth: 0.
	mainWindow
		addMorph: mainPane
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	codeRow := TamListItemReferenceUtil subWindowClass model: self.
	codeRow
		addMorph: self contentsMorph
		fullFrame: (self contentsMorphLayoutFrame
				).
	codeRow borderWidth: 0.
	mainPane addMorph: codeRow fullFrame: self codeRowLayoutFrame.
	mainWindow extent: self initialExtent.
	^ mainWindow! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 3/20/2006 13:28'!
canBeUpdated
	^ mainWindow notNil and: [mainWindow owner notNil]! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 6/23/2004 17:43'!
checks
! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 6/23/2004 17:43'!
codeFont
	^ self class codeFont! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 6/23/2004 17:43'!
codeMatch: aMatchString 
	^ self class code: self contents string match: aMatchString! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 3/1/2005 16:01'!
codeMatch: aMatchString startingAt: pointPos 
	^ self class
		code: self contents
		match: aMatchString
		startingAt: (pointPos > 0 ifTrue: [pointPos] ifFalse: [1])! !

!PlatypusCodeMorph methodsFor: 'ui building' stamp: 'apl 6/23/2004 17:56'!
codeRowLayoutFrame
	^ LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 3/23/2006 16:07'!
codeSelectionInterval: aStringOrText startingAt: startPos 
	| matchResult matchString |
	matchString := aStringOrText
				reject: [:c | c isSeparator].
	(matchResult := self codeMatch: matchString startingAt: startPos) first
		ifTrue: [self
				selectionInterval: (matchResult second to: matchResult third)].
	^ matchResult first! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 3/30/2006 09:56'!
codeString
	^ self sourceHandler
		ifNil: ['']
		ifNotNil: [self sourceHandler codeString]! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 6/23/2004 18:43'!
codeText
	^ self sourceHandler ifNil: ['']
	ifNotNil: [self sourceHandler codeText]
! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 3/31/2006 15:37'!
contents: input notifying: aRequestor 
	"The retrieved information has changed and its source must now 
	be updated. The information can be a variety of things, 
	depending on the list selections. Answer the result of updating 
	the source."
	| code result |
	code := input.
	(self sourceHandler isNil
			or: [self sourceHandler isReleased])
		ifFalse: [(result := self sourceHandler accept: code notifying: aRequestor)
				ifNotNil: [self acceptContents: input.
					self broadcastChanged].
			^ result].
	contentsMorph flash.
	^ false! !

!PlatypusCodeMorph methodsFor: 'menu' stamp: 'AlainPlantec 4/26/2012 09:36'!
contentsMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:,  
	PluggableTextController  
	will respond to all menu items in a text pane"
	| donorMenu |
	donorMenu := shifted
				ifTrue: [TextEditor shiftedYellowButtonMenu]
				ifFalse: [TextEditor yellowButtonMenu].
	aMenu   addAllFrom: donorMenu.
	^ aMenu
! !

!PlatypusCodeMorph methodsFor: 'ui building' stamp: 'AlainPlantec 4/26/2012 09:52'!
contentsMorph
	| txtClass |
	contentsMorph isNil
		ifTrue: [txtClass := TamTextMorph.
			contentsMorph := txtClass
						on: self
						text: #contents
						accept: #contents:notifying:
						readSelection: nil
						menu: #contentsMenu:shifted:].
	contentsMorph addDependent: self.
	^ contentsMorph! !

!PlatypusCodeMorph methodsFor: 'ui building' stamp: 'apl 2/20/2006 09:37'!
contentsMorphLayoutFrame
		^(LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).! !

!PlatypusCodeMorph methodsFor: 'initialize/release' stamp: 'apl 3/28/2006 21:48'!
destroy
	self breakDependents.
	mainWindow
		ifNotNil: [mainWindow stopStepping.
			mainWindow submorphs
				do: [:sm | sm delete].
			mainWindow := nil].
	sourceHandler := nil.
	mainPane ifNotNil: [mainPane delete. mainPane := nil].
	codeRow
		ifNotNil: [codeRow delete.
			codeRow := nil].
	contentsMorph
		ifNotNil: [contentsMorph model: nil.
			contentsMorph delete.
			contentsMorph := nil].
	contents := nil.
	super destroy! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 3/8/2006 11:13'!
errors
	| errs testste result |
	errs := self sourceHandler
				ifNil: [^ #()]
				ifNotNil: [self rootSourceHandler rootMessages].
	testste := Set new.
	result := OrderedCollection new.
	errs
		do: [:er | (testste includes: er asString)
				ifFalse: [testste add: er asString.
					result add: er]].
	^ result! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 6/23/2004 17:43'!
hasUnacceptedEdits: aBoolean 
	^ contentsMorph hasUnacceptedEdits: aBoolean! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 6/23/2004 17:43'!
haveBrokenText: aBoolean
	haveBrokenText := aBoolean! !

!PlatypusCodeMorph methodsFor: 'ui building' stamp: 'apl 6/23/2004 17:43'!
initialExtent
	^ self class initialExtent! !

!PlatypusCodeMorph methodsFor: 'initialize/release' stamp: 'apl 3/9/2006 12:39'!
initialize
	super initialize.
	haveBrokenText := false.
	textCanBeBroken := true! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 6/16/2005 09:39'!
keystrokeInContentsMorph
! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 6/23/2004 17:43'!
labelString
	^ self sourceHandler notNil
		ifTrue: [self class name , ' on: ' , self sourceHandler labelString]
		ifFalse: [self class name]! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 6/23/2004 17:43'!
mainWindow
	^ mainWindow! !

!PlatypusCodeMorph methodsFor: 'error handling' stamp: 'apl 6/23/2004 17:43'!
notify: errorMessage at: location
	| repl |
	self contentsMorph selectFrom: location to: location - 1.
	self contentsMorph scrollSelectionIntoView.
	repl := Text string: errorMessage , '->' attribute: TextEmphasis bold.
	self contentsMorph replaceSelectionWith: repl.
	self contentsMorph
		setSelection: (location to: location + errorMessage size + 1).
! !

!PlatypusCodeMorph methodsFor: 'morphic wrapper' stamp: 'apl 6/23/2004 17:43'!
openAsMorph
	^ self asMorph openInWorld.
! !

!PlatypusCodeMorph methodsFor: 'message handling' stamp: 'apl 6/23/2004 17:43'!
perform: selector orSendTo: otherTarget 
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!PlatypusCodeMorph methodsFor: 'menu' stamp: 'apl 6/23/2004 17:43'!
rememberWindowSize
	self class initialExtent: mainWindow bounds extent! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 3/8/2006 11:13'!
rootSourceHandler
	^ self sourceHandler rootSourceHandler! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 6/23/2004 17:43'!
selectCode: aStringOrText 
	^ self selectCode: aStringOrText startingAt: 1 

! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'AlainPlantec 10/7/2010 13:42'!
selectCode: aStringOrText startingAt: startPos 
	| matchResult matchString |
	matchString := aStringOrText
				reject: [:c | c isSeparator].
	(matchResult := self codeMatch: matchString startingAt: startPos) first
		ifTrue: [self selectFrom: matchResult second to: matchResult third].
	^ matchResult first
! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 6/23/2004 17:43'!
selectCodeFromPoint: aStringOrText 
	| |
	^ self selectCode: aStringOrText startingAt: self selectionInterval first
! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'AlainPlantec 12/2/2010 18:17'!
selectFrom: startPos to: stopPos 
	self contentsMorph
		selectionInterval: (startPos to: stopPos).
	self contentsMorph setSearchString.
	self contentsMorph scrollSelectionIntoView.
	self contentsMorph selectFrom: startPos to: stopPos.
	self contentsMorph scrollSelectionIntoView! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 6/23/2004 17:43'!
selectionInterval
	^ self contentsMorph selectionInterval! !

!PlatypusCodeMorph methodsFor: 'code accessing' stamp: 'apl 6/23/2004 17:43'!
selectionInterval: anInterval
	self contentsMorph selectionInterval: anInterval.
! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 6/23/2004 17:43'!
sourceHandler
	^sourceHandler! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 4/29/2008 14:08'!
sourceHandler: anObject 
	sourceHandler == anObject 
		ifFalse: 
			[
			sourceHandler := anObject.
			self acceptContents: self codeText.
			self changed: #contents]! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 2/16/2006 21:28'!
sourceHandlerSilently: anObject contents: aString 
	sourceHandler := anObject.
	self acceptContents: aString.
	self changed: #contents! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 3/22/2007 19:00'!
takeErrors
	self checking
		ifTrue: [self updateMessagesBrowser].
	! !

!PlatypusCodeMorph methodsFor: 'accessing' stamp: 'apl 3/21/2006 22:06'!
takeErrors: errorsList 
	self rootSourceHandler rootMessages: errorsList.
	self takeErrors! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 6/16/2005 09:39'!
update: aSymbol 
	super update: aSymbol! !

!PlatypusCodeMorph methodsFor: 'code updating' stamp: 'apl 6/23/2004 18:02'!
updateCodePaneIfNeeded
	! !

!PlatypusCodeMorph methodsFor: 'ui opening/closing' stamp: 'apl 2/20/2007 15:36'!
windowIsClosing
	self destroy.
	super windowIsClosing! !

TamListItemHardLinkReference subclass: #PlatypusExpressLinkReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusExpressLinkReference subclass: #PlatypusDomainReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusDomainReference methodsFor: 'testing' stamp: 'apl 9/27/2007 05:44'!
isMoveable 
	"can be moved"
	^ false ! !

!PlatypusDomainReference methodsFor: 'testing' stamp: 'apl 9/8/2003 18:56'!
isRemoveable ^ false ! !

!PlatypusExpressLinkReference methodsFor: 'checking' stamp: 'apl 9/27/2007 06:19'!
doInternalChecking
	self assert: self metaData notNil.
	self assert: self metaData tamarisItemRef notNil.
	self metaData tamarisItemRef doInternalChecking! !

!PlatypusExpressLinkReference methodsFor: 'accessing' stamp: 'apl 5/11/2004 23:32'!
findExpressReferenceDeeplySuchThat: aBlock ^ self linked findExpressReferenceDeeplySuchThat: aBlock ! !

!PlatypusExpressLinkReference methodsFor: 'accessing' stamp: 'apl 3/15/2004 11:33'!
metaData ^ self linked metaData ! !

!PlatypusExpressLinkReference methodsFor: 'tam taxonomy browser' stamp: 'apl 3/29/2006 12:54'!
selectingFrom: aTamarisBrowser ^ super selectingFrom: aTamarisBrowser ! !

PlatypusExpressLinkReference subclass: #PlatypusSchemaInterfaceReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusSchemaInterfaceReference methodsFor: 'to be classified' stamp: 'apl 4/26/2007 10:23'!
asStringOrText
	^ self linkPrefix , self linked  name! !

!PlatypusSchemaInterfaceReference methodsFor: 'icon accessing' stamp: 'apl 4/26/2007 10:11'!
children
	| lnk |
	^ (lnk := self linked)
		ifNil: [#()]
		ifNotNil: [lnk nativeSchema isNil
				ifTrue: [#()]
				ifFalse: [lnk nativeSchema tamarisItemRef isNil ifTrue: [#()] ifFalse: [lnk nativeSchema tamarisItemRef children]]]! !

!PlatypusSchemaInterfaceReference methodsFor: 'icon accessing' stamp: 'apl 4/26/2007 10:54'!
icon
	| lnk |
	^ ((lnk := self linked) isNil
			or: [lnk nativeSchema isNil])
		ifTrue: [TamIcons mimeIcon: '10x10/mimetypes/question']
		ifFalse: [lnk nativeSchema tamarisItemRef isNil
				ifTrue: [TamIcons mimeIcon: '10x10/mimetypes/question']
				ifFalse: [lnk nativeSchema tamarisItemRef icon]]! !

!PlatypusSchemaInterfaceReference methodsFor: 'to be classified' stamp: 'apl 4/26/2007 10:28'!
linkPrefix
	^ self linked isNil ifTrue: [''] ifFalse: [self linked  isPltUsedSchema ifTrue: ['use from '] ifFalse: [self linked isPltReferencedSchema ifTrue: ['reference from '] ifFalse: ['meta from ']]]! !

!PlatypusSchemaInterfaceReference methodsFor: 'icon accessing' stamp: 'apl 4/26/2007 10:12'!
selectingFrom: aTaxonomyBrowser 
	| lnk |
	((lnk := self linked) isNil
			or: [lnk nativeSchema isNil or: [lnk nativeSchema tamarisItemRef isNil]])
		ifTrue: [^ nil].
	^ lnk nativeSchema tamarisItemRef selectingFrom: aTaxonomyBrowser! !

!PlatypusSchemaInterfaceReference methodsFor: 'to be classified' stamp: 'apl 4/26/2007 10:21'!
shortName
	^ self linked name! !

!PlatypusSchemaInterfaceReference methodsFor: 'icon accessing' stamp: 'apl 4/26/2007 10:11'!
unSelectingFrom: aTaxonomyBrowser 
	| lnk |
	((lnk := self linked) isNil
			or: [lnk nativeSchema isNil or: [lnk nativeSchema tamarisItemRef isNil]])
		ifFalse: [lnk nativeSchema tamarisItemRef unSelectingFrom: aTaxonomyBrowser]! !

PlatypusExpressLinkReference subclass: #PlatypusSchemaLinkReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusSchemaLinkReference methodsFor: 'testing' stamp: 'apl 3/3/2006 08:43'!
canBeMovedDown "true if self can be moved up (in my owner children
	collection) "^ self isMoveable and: [ self owner subReferences size > 1 and: [ ( self owner subReferences indexOf: self ) < self owner subReferences size ] ] ! !

!PlatypusSchemaLinkReference methodsFor: 'testing' stamp: 'apl 3/3/2006 08:42'!
canBeMovedUp "true if self can be moved up (in my owner children
	collection)"^ self isMoveable and: [ owner subReferences size > 1 and: [ ( self owner subReferences indexOf: self ) > 1 ] ] ! !

!PlatypusSchemaLinkReference methodsFor: 'accessing' stamp: 'apl 4/7/2006 16:23'!
contents ^ self linked contents ! !

!PlatypusSchemaLinkReference methodsFor: 'accessing' stamp: 'apl 4/7/2006 16:35'!
emphasisModel ^ self linked emphasisModel ! !

!PlatypusSchemaLinkReference methodsFor: 'testing' stamp: 'apl 4/7/2006 16:32'!
isLinkTo: anItem ^ self linked linked = anItem linked ! !

!PlatypusSchemaLinkReference methodsFor: 'testing' stamp: 'apl 3/3/2006 08:25'!
isMoveable ^ true ! !

!PlatypusSchemaLinkReference methodsFor: 'testing' stamp: 'apl 3/29/2006 19:41'!
isPlatypusPrimitiveSchema ^ self linked notNil and: [ self linked isPlatypusPrimitiveSchema ] ! !

!PlatypusSchemaLinkReference methodsFor: 'updating' stamp: 'apl 5/12/2004 11:42'!
moveDown ^ self owner moveDownSchemaReference: self ! !

!PlatypusSchemaLinkReference methodsFor: 'updating' stamp: 'apl 5/12/2004 11:42'!
moveUp ^ self owner moveUpSchemaReference: self ! !

PlatypusExpressLinkReference subclass: #PlatypusSubtypeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusSubtypeReference methodsFor: 'testing' stamp: 'apl 7/17/2003 12:46'!
isMoveable ^ false ! !

!PlatypusSubtypeReference methodsFor: 'testing' stamp: 'apl 7/17/2003 11:51'!
isRemoveable ^ false ! !

!TamManager class methodsFor: '*sqplatypus-hw-accessing' stamp: 'apl 1/4/2006 14:21'!
platypusMetaDefaultTaxon
	^ TamManagerItem platypusMetaDefaultTaxon! !

TamListItemReference subclass: #PlatypusListItemReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusListItemReference subclass: #PlatypusExpressReference
	instanceVariableNames: 'subReferences interactiveCallArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusExpressReference subclass: #PlatypusExpressElementReference
	instanceVariableNames: 'startNode stopNode name metaData generatedClassRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusExpressElementReference methodsFor: 'initialize/release' stamp: 'apl 3/22/2006 14:59'!
destroy
	metaData ifNotNil: [metaData deepDestroy. metaData := nil].
	startNode := nil.
	stopNode := nil.
	super destroy! !

!PlatypusExpressElementReference methodsFor: 'checking' stamp: 'apl 4/3/2006 13:35'!
doInternalChecking
	self knownAsInvalid
		ifFalse: [super doInternalChecking.
			self assert: self metaData owner = self owner metaData.
			self assert: self name asUppercase = self metaData name asUppercase]! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 4/3/2006 10:10'!
emphasisModel
	^ self schemaInstanceReference emphasisModel! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:56'!
generatedClassRef
	| n cls |
	n := self metaData generatedClassName asSymbol.
	(cls := PlatypusPharoSmalltalk at: n) isNil 
		ifTrue: 
			[generatedClassRef isNil 
				ifFalse: 
					[generatedClassRef destroy.
					generatedClassRef := nil]]
		ifFalse: 
			[(generatedClassRef isNil or: [generatedClassRef itemClass ~= cls]) 
				ifTrue: 
					[generatedClassRef isNil ifFalse: [generatedClassRef itemClass ~= cls ifTrue: [generatedClassRef destroy]].
					generatedClassRef := TamClassReference classReferenceOf: cls owner: self]].
	^ generatedClassRef! !

!PlatypusExpressElementReference methodsFor: 'testing' stamp: 'apl 4/3/2006 15:18'!
knownAsInvalid
	^ self schemaInstanceReference knownAsInvalid! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 9/29/2003 10:49'!
metaData
	^ metaData! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 9/29/2003 10:49'!
metaData: aMetaData
	metaData := aMetaData! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 3/19/2003 16:37'!
name
	^ name! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 21:03'!
name: aString
	 name := aString! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 3/23/2006 11:12'!
nameNode
	^ self tokenList nextNonBlankFrom: self subReferencesScanStart! !

!PlatypusExpressElementReference methodsFor: 'code updating' stamp: 'apl 3/23/2006 09:18'!
relabelWith: newName 
	| metaDataOwner code oldOwner parserResult oldName |
	metaDataOwner := self metaData owner.
	oldName := self name.
	self nameNode lexicalElement: newName.
	code := self codeString.
	oldOwner := self owner.
	parserResult := self expressParserClass
				parse: code
				startingAt: self smaCCStartingState
				owner: metaDataOwner
				onError: [:d :p | 
					self nameNode lexicalElement: oldName.
					nil].
	parserResult
		ifNotNil: [self replaceWithParserResult: parserResult.
			self name: newName.
			PlatypusExpressCodeHolder changed: oldOwner]! !

!PlatypusExpressElementReference methodsFor: 'code updating' stamp: 'apl 3/1/2006 11:16'!
removeSilently
	self owner
		ifNotNil: [self tokenList
				ifNotNil: [	self logToChangesRemoving: self oldCodeText: self codeText.
self tokenList
						removeFrom: (self tokenList beginningOfLineFrom: self startNode)
						to: (self tokenList endOfLineFrom: self stopNode)]].
	super removeSilently! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 09:21'!
schemaInstanceReference
	^ (self owner isKindOf: PlatypusExpressReference)
		ifTrue: [self owner schemaInstanceReference]! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 2/10/2004 15:36'!
shortName
	^ self name 
! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 3/19/2003 11:13'!
startNode
	^ startNode! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 20:40'!
startNode: aNode
	startNode := aNode! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 3/19/2003 11:13'!
stopNode
	^ stopNode ! !

!PlatypusExpressElementReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 19:48'!
stopNode: aNode
	stopNode := aNode! !

!PlatypusExpressElementReference methodsFor: 'code updating' stamp: 'apl 4/6/2006 11:09'!
takeParserResult: aParserResult 
	aParserResult metaData name asUppercase = self name asUppercase
		ifTrue: [^ self replaceWithParserResult: aParserResult]
		ifFalse: [self owner addWithParserResult: aParserResult.
			TamBrowser reloadEditorFor: self.
			TamManager changed: self.
			^ true]! !

PlatypusExpressElementReference subclass: #PlatypusSchemaElementReference
	instanceVariableNames: 'subContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusSchemaElementReference subclass: #PlatypusEntityReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusEntityReference class methodsFor: 'accessing' stamp: 'apl 10/1/2003 15:46'!
lexicalElement
	^ #entity! !

!PlatypusEntityReference methodsFor: 'accessing' stamp: 'apl 3/15/2007 19:45'!
children
	^ self isReleased
	ifTrue: [#()]
		ifFalse: [self collectedSubtypes , super contents].
! !

!PlatypusEntityReference methodsFor: 'accessing' stamp: 'apl 4/10/2006 17:49'!
collectedSubtypes
	| subtypes subTypesReferences newLink toBeRemove |
	self metaData checksHierarchy
		ifNotNil: [^ #()].
	subtypes := (self metaData subtypes
				collect: [:st | st referenced]) select: [:st | st notNil].
	subTypesReferences := ((subtypes asArray
				select: [:st | st tamarisItemRef notNil])
				collect: [:st | st tamarisItemRef])
				sort: [:a :b | a name < b name].
	toBeRemove := self subContents
				select: [:l | (subTypesReferences
						anySatisfy: [:str | str = l linked]) not].
	self subContents removeAll: toBeRemove.
	toBeRemove
		do: [:l | l destroy].
	subTypesReferences
		do: [:str | (self subContents
					anySatisfy: [:l | l linked = str])
				ifFalse: [newLink := PlatypusSubtypeReference from: str.
					newLink owner: self.
					self subContents add: newLink]].
	^ self subContents! !

!PlatypusEntityReference methodsFor: 'accessing' stamp: 'apl 4/1/2006 08:59'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/blue_e'! !

PlatypusSchemaElementReference subclass: #PlatypusFunctionReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusFunctionReference class methodsFor: 'accessing' stamp: 'apl 10/1/2003 15:47'!
lexicalElement
	^ #function! !

!PlatypusFunctionReference methodsFor: 'accessing' stamp: 'apl 2/16/2006 11:58'!
children
	^ self subContents
! !

!PlatypusFunctionReference methodsFor: 'accessing' stamp: 'apl 4/1/2006 09:00'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/blue_f'
! !

PlatypusSchemaElementReference subclass: #PlatypusProcedureReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusProcedureReference class methodsFor: 'accessing' stamp: 'apl 10/1/2003 15:47'!
lexicalElement
	^ #procedure! !

!PlatypusProcedureReference methodsFor: 'accessing' stamp: 'apl 4/1/2006 09:01'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/blue_p'! !

PlatypusSchemaElementReference subclass: #PlatypusRuleReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusRuleReference class methodsFor: 'accessing' stamp: 'apl 10/1/2003 15:47'!
lexicalElement
	^ #rule! !

!PlatypusRuleReference methodsFor: 'accessing' stamp: 'apl 6/8/2004 10:55'!
children
	^ self subContents! !

!PlatypusRuleReference methodsFor: 'accessing' stamp: 'apl 4/1/2006 09:00'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/blue_r'! !

!PlatypusSchemaElementReference methodsFor: 'testing' stamp: 'apl 4/6/2006 11:37'!
canHaveCachedEditor
	^ false! !

!PlatypusSchemaElementReference methodsFor: 'copying' stamp: 'apl 7/5/2004 12:01'!
copy
	| cpy |
	cpy := super copy.
	cpy subContents: nil.
	^ cpy! !

!PlatypusSchemaElementReference methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:49'!
destroy
	self reinitialize.
	super destroy! !

!PlatypusSchemaElementReference methodsFor: 'evaluating' stamp: 'apl 4/3/2006 13:45'!
evaluate
	| result value position |
	result := false.
	self  knownAsInvalid
		ifTrue: [self inform: 'Express model must checked']
		ifFalse: [(result := self metaData evaluate)
				ifNotNil: [(result isKindOf: PlatypusExpressInterpretor)
						ifFalse: [position := self subContents size + 1.
							value := result val.
							(value isPltAggregateInstance
									and: [value size = 1])
								ifTrue: [self subContents
										add: ((value at: 1) tamarisStepValueReferenceClass
												owner: self
												position: position
												value: (value at: 1))]
								ifFalse: [self subContents
										add: (value tamarisStepValueReferenceClass
												owner: self
												position: position
												value: value)].
							TamManager changed: self]]].
	^ result! !

!PlatypusSchemaElementReference methodsFor: 'evaluating' stamp: 'apl 3/19/2004 16:34'!
evaluateAndExplore 
	^ self metaData evaluateAndExplore ! !

!PlatypusSchemaElementReference methodsFor: 'testing' stamp: ''!
isSchemaElement
	^ true! !

!PlatypusSchemaElementReference methodsFor: 'menus' stamp: 'apl 3/2/2005 11:18'!
keyStroke: aCharacter from: aListMorph 
	super keyStroke: aCharacter from: aListMorph.
! !

!PlatypusSchemaElementReference methodsFor: 'accessing' stamp: 'apl 10/30/2003 18:17'!
lexicalElement
	^ self class lexicalElement! !

!PlatypusSchemaElementReference methodsFor: 'menus' stamp: 'apl 3/2/2005 10:40'!
menuTranslationParameters	! !

!PlatypusSchemaElementReference methodsFor: 'accessing' stamp: 'apl 9/7/2006 14:22'!
modelContentsReference
	^ nil! !

!PlatypusSchemaElementReference methodsFor: 'initialize/release' stamp: 'apl 6/8/2004 17:20'!
reinitialize
	self reinitializeEvaluatedContents.
	super reinitialize! !

!PlatypusSchemaElementReference methodsFor: 'updating' stamp: 'apl 2/16/2006 11:35'!
reinitializeEditor
	self reinitialize.
	^ super reinitializeEditor! !

!PlatypusSchemaElementReference methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:53'!
reinitializeEvaluatedContents
	subContents ifNotNil: [subContents do: [:s | s destroy]].
	subContents := nil.
	super reinitializeEvaluatedContents! !

!PlatypusSchemaElementReference methodsFor: 'updating' stamp: 'apl 6/3/2005 16:53'!
removeAt: aPosition 
	| sr |
	(self subContents removeAt: aPosition) destroy.
	aPosition to: self subContents size
		do: [:p | (sr := self subContents at: p) pos: sr pos - 1]! !

!PlatypusSchemaElementReference methodsFor: 'accessing' stamp: 'apl 3/22/2006 23:00'!
smaCCStartingState
	| openkw |
	openkw := self lexicalElement.
	^ self expressParserClass perform: ('startingStateFor' , openkw
	capitalized , 'Entry') asSymbol
! !

!PlatypusSchemaElementReference methodsFor: 'menus' stamp: 'AlainPlantec 4/27/2012 09:08'!
specificMenu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring 
	the #shifted boolean"
	| menuExpress |
	super specificMenu: menu shifted: b.
	menu addLine.
	menuExpress := MenuMorph new.
	#(#- #('save as... (S)' #menuSaveAs) #- #('code pane (p)' #menuCodePane) #- #('translate here (t)' #menuTranslate2Pharo) #('translate to VisualWorks' #menuTranslate2VisualWorks) )
		do: [:item | item == #-
				ifTrue: [menuExpress addLine]
				ifFalse: [menuExpress
						add: item first
						target: self
						selector: item second]].
	menu
		add: 'express ...'
		subMenu: menuExpress
		target: self
		selector: nil
		argumentList: #().
	self metaData isPltStatementsContainer
		ifTrue: [menu addLine.
			menu
				add: 'evaluate'
				target: self
				selector: #evaluate.
			menu
				add: 'evaluate and explore'
				target: self
				selector: #evaluateAndExplore.
			menu addLine].
	^ menu! !

!PlatypusSchemaElementReference methodsFor: 'accessing' stamp: ''!
startLevel
	^1! !

!PlatypusSchemaElementReference methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 15:58'!
subContents
	^ subContents
		ifNil: [subContents := OrderedCollection new].
! !

!PlatypusSchemaElementReference methodsFor: 'accessing' stamp: 'apl 7/5/2004 12:00'!
subContents: aCollectionOrNil 
	subContents := aCollectionOrNil! !

!PlatypusSchemaElementReference methodsFor: 'menus' stamp: 'apl 2/15/2007 16:05'!
translateWithTranslator: aTranslator 
	^ aTranslator localTranslate: self metaData ! !

PlatypusSchemaElementReference subclass: #PlatypusTypeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusTypeReference class methodsFor: 'accessing' stamp: 'apl 10/1/2003 15:46'!
lexicalElement
	^ #type! !

!PlatypusTypeReference methodsFor: 'accessing' stamp: 'AlainPlantec 10/7/2010 16:04'!
children
	| children |
	children := #().
	self isReleased
		ifFalse: [children := self collectedDomains, super contents].
	^ children ! !

!PlatypusTypeReference methodsFor: 'accessing' stamp: 'apl 9/19/2007 06:06'!
collectedDomains
	| newLink toBeRemove domains domainsReferences |
	self metaData ifNil: [^ #()].
	self metaData checksDomainPath
		ifNotNil: [^ #()].
	domains := self metaData domainsSet
				select: [:d | d isPltNamedType].
	domainsReferences := ((domains asArray
				select: [:st | st tamarisItemRef notNil])
				collect: [:st | st tamarisItemRef])
				sort: [:a :b | a name < b name].
	toBeRemove := self subContents
				select: [:l | (domainsReferences
						anySatisfy: [:str | str = l linked]) not].
	self subContents removeAll: toBeRemove.
	toBeRemove
		do: [:l | l destroy].
	domainsReferences
		do: [:str | (self subContents
					anySatisfy: [:l | l linked = str])
				ifFalse: [newLink := PlatypusDomainReference from: str.
					newLink owner: self.
					self subContents add: newLink]].
	^ self subContents! !

!PlatypusTypeReference methodsFor: 'accessing' stamp: 'apl 4/1/2006 09:00'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/blue_t'! !

PlatypusExpressElementReference subclass: #PlatypusSchemaReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusSchemaReference class methodsFor: 'accessing' stamp: 'apl 2/14/2006 20:58'!
lexicalElement
	^#'schema'! !

!PlatypusSchemaReference methodsFor: 'drag and drop' stamp: 'apl 5/10/2005 14:44'!
acceptDroppingMorph: aTransfertMorph copy: shouldCopy 
	(aTransfertMorph respondsTo: #passenger) ifFalse: [^false].
	(aTransfertMorph passenger isKindOf: PlatypusSchemaElementReference) 
		ifTrue: 
			[(self copyListItemHereFromTransfertMorph: aTransfertMorph) 
				ifTrue: [shouldCopy ifFalse: [aTransfertMorph passenger remove]. ^ true]].

^ false! !

!PlatypusSchemaReference methodsFor: 'code updating' stamp: 'apl 4/26/2007 10:08'!
buildSubReferencesFrom: start to: stop addingOrReplacing: addingReplacingOrReplacingAllSymbol 
	| newLink |
	super
		buildSubReferencesFrom: start
		to: stop
		addingOrReplacing: addingReplacingOrReplacingAllSymbol.
		self subReferences removeAllSuchThat: [:e | e isKindOf: PlatypusSchemaInterfaceReference].
	self metaData interface
		do: [:str | 
			newLink := PlatypusSchemaInterfaceReference from: str .
			newLink owner: self.
			self subReferences add: newLink]! !

!PlatypusSchemaReference methodsFor: 'testing' stamp: 'apl 3/3/2006 08:43'!
canBeMovedDown
	"true if self can be moved up (in my owner children
	collection) "
	^ self isMoveable
		and: [self owner subReferences size > 1
		and: [(self owner subReferences indexOf: self)
				< self owner subReferences size]]! !

!PlatypusSchemaReference methodsFor: 'testing' stamp: 'apl 3/3/2006 08:42'!
canBeMovedUp
	"true if self can be moved up (in my owner children
	collection)"
	^ self isMoveable 
		and: [self owner subReferences size > 1
				and: [(self owner subReferences indexOf: self)
						> 1]]! !

!PlatypusSchemaReference methodsFor: 'code accessing' stamp: 'apl 4/6/2006 11:32'!
codeStreamClassFor: aTokenList from: aStartNode to: aSopNode 
	^ super codeStreamClassFor: aTokenList from: aStartNode to: aSopNode ! !

!PlatypusSchemaReference methodsFor: 'checking' stamp: 'apl 4/3/2006 13:36'!
doInternalChecking
	super doInternalChecking.
	self knownAsInvalid
		ifFalse: [self assert: self metaData owner notNil.
			self metaData interfaceSchemata
				do: [:sch | sch
						ifNotNil: [self assert: sch owner notNil]]]! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 3/23/2006 09:37'!
elementKindStartContentsFor: elementKindSymbol name: aName 
	elementKindSymbol == #type
		ifTrue: [^ ('	type ' , aName , ' = string; \	end_type;') withCRs].
	elementKindSymbol == #entity
		ifTrue: [^ ('	entity ' , aName , ';\	end_entity;') withCRs].
	elementKindSymbol == #rule
		ifTrue: [^ ('	rule ' , aName , ' for ( at_least_an_entity_name );\	where\		wr1 : true; -- obviously something else\	end_rule;') withCRs].
	elementKindSymbol == #procedure
		ifTrue: [^ ('	procedure ' , aName , ';\		local\		end_local;\\	end_procedure;') withCRs].
	elementKindSymbol == #function
		ifTrue: [^ ('	function ' , aName , ' : integer;\		local\		end_local;\\		return (0);\	end_function;') withCRs].
	^ ('	' , elementKindSymbol , ' ' , aName , ';\	end_' , elementKindSymbol , ' ;') withCRs! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 5/26/2005 14:22'!
entitiesReferences
	^self subReferencesOfKind: PlatypusEntityReference! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 5/26/2005 14:22'!
functionsReferences
	^self subReferencesOfKind: PlatypusFunctionReference! !

!PlatypusSchemaReference methodsFor: 'testing' stamp: 'apl 3/29/2006 19:36'!
haveMetaSchemata
	^ self metaData notNil and: [self metaData haveMetaSchemata]! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 3/29/2006 19:52'!
icon
	^ (self isPlatypusPrimitiveSchema
			or: [self usePlatypusPrimitiveSchemata])
		ifTrue: [TamIcons mimeIcon: '10x10/mimetypes/meta_schema']
		ifFalse: [self haveMetaSchemata
				ifTrue: [TamIcons mimeIcon: '10x10/mimetypes/meta_schema_instancier']
				ifFalse: [TamIcons mimeIcon: '10x10/mimetypes/schema']]! !

!PlatypusSchemaReference methodsFor: 'code updating' stamp: 'apl 3/23/2006 09:34'!
insertReference: anotherReference 
	| parserResult code |
	((anotherReference isKindOf: PlatypusExpressReference)
			and: [anotherReference isSchemaElement])
		ifFalse: [^ super insertReference: anotherReference].
	anotherReference owner == self
		ifTrue: [^ false].
	code := anotherReference codeString.
	parserResult := self expressParserClass
				parseStream: code readStream
				startingAt: anotherReference smaCCStartingState
				owner: self metaData.
	self addWithParserResult: parserResult.
	PlatypusExpressCodeHolder changed: self.
	^ true! !

!PlatypusSchemaReference methodsFor: 'testing' stamp: 'apl 3/3/2006 08:13'!
isMoveable
	^ true! !

!PlatypusSchemaReference methodsFor: 'testing' stamp: 'apl 3/29/2006 19:44'!
isPlatypusPrimitiveSchema
	^ self metaData notNil
		and: [self metaData isPlatypusPrimitiveSchema]! !

!PlatypusSchemaReference methodsFor: 'testing' stamp: 'apl 10/26/2006 19:05'!
isSchemaReference
	^ true! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 6/8/2004 19:14'!
menuCleanAllEvaluations
	self cleanAllEvaluations.
	TamManager changed: self! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 6/7/2004 14:39'!
menuEvaluateAllRules
	self rules
		do: [:r | 
			Transcript show: r metaData name , '\' withCRs.
			r evaluate]! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'AlainPlantec 10/7/2010 16:00'!
menuExpress2SqlOracle
	| visiteur ws functionsVisitor |
	visiteur := PlatypusExpress2SqlOracleVisitor
				outStream: (WriteStream on: String new).
	visiteur createTypeBoolean.
	visiteur createTypeLogical.
	"Execute la generation du code SQL"
	self metaData acceptTry: visiteur.
	"visiteur allSqlContainer inspect."
	"visiteur allSqlContainer  
	do: [:item | Transcript show: item contents].  
	visiteur allSqlContainer keys inspect."
	"ws := Workspace new.  
	ws contents: visiteur outStream contents.  
	ws openLabel: 'Fichier SQL (Oracle)'."
	visiteur sortMsgSql.
	"functionsVisitor := PlatypusAccesFunctionsVisitor
				new: visiteur allSqlContainer
				outStream: visiteur outStream
				dict: visiteur dicoOfName.
	self metaData acceptTry: functionsVisitor."
	ws := Workspace new.
	ws contents: visiteur outStream contents.
	ws openLabel: self metaData name , '.SQL (Oracle)'.
	Transcript show: 'Traitement termine';
		 cr! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'AlainPlantec 10/7/2010 16:00'!
menuExpress2SqlPostgres
	| visiteur ws functionsVisitor |
	visiteur := PlatypusExpress2SqlPostgresVisitor
				outStream: (WriteStream on: String new).
	visiteur createTypeBoolean.
	visiteur createTypeLogical.
	"Execute la generation du code SQL"
	self metaData acceptTry: visiteur.
	"visiteur allSqlContainer inspect."
	"ws := Workspace new.  
	ws contents: visiteur outStream contents.  
	ws openLabel: 'Fichier SQL (PostgreSQL)'."
	visiteur sortMsgSql.
	functionsVisitor := PlatypusAccesFunctionsPosgresVisitor
				new: visiteur allSqlContainer
				outStream: visiteur outStream
				dict: visiteur dicoOfName.
	self metaData acceptTry: functionsVisitor.
	ws := Workspace new.
	ws contents: visiteur outStream contents.
	ws openLabel: self metaData name , '.SQL (PostgreSQL)'.
	Transcript show: 'Traitement termine';
		 cr! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'AlainPlantec 5/10/2012 12:05'!
menuNewElement: elementKind 
	| key startContents startingStateSelector parserResult |
	(key := UIManager default request: 'new ' , elementKind , ' name' initialAnswer: '')
		ifNotNil: [:e | 
			startContents := self elementKindStartContentsFor: elementKind name: key.
			startingStateSelector := (#startingStateFor , elementKind capitalized , 'Entry') asSymbol.
			parserResult := self expressParserClass
						parseStream: startContents readStream
						startingAt: (PlatypusExpressParser perform: startingStateSelector)
						owner: self metaData.
			self addWithParserResult: parserResult.
			PlatypusExpressCodeHolder changed: self]! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 3/21/2003 16:15'!
menuNewEntity
	^ self menuNewElement: #entity! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 3/21/2003 16:15'!
menuNewFunction
	^ self menuNewElement: #function! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 3/21/2003 16:15'!
menuNewProcedure
	^ self menuNewElement: #procedure! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 3/21/2003 16:15'!
menuNewRule
	^ self menuNewElement: #rule! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'apl 3/21/2003 16:15'!
menuNewType
	^ self menuNewElement: #type! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 6/10/2004 23:47'!
moveDown
	^ self owner moveDownSchemaReference: self! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 6/10/2004 23:46'!
moveUp
	^ self owner moveUpSchemaReference: self! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 5/26/2005 14:22'!
proceduresReferences
	^self subReferencesOfKind: PlatypusProcedureReference! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 6/7/2004 14:36'!
rules
	^ self subReferences select: [:sr | sr isKindOf: PlatypusRuleReference]! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 5/26/2005 14:23'!
rulesReferences
	^self subReferencesOfKind: PlatypusRuleReference! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 4/25/2007 16:24'!
schemaInterfacesReferences
	^ self subReferencesOfKind: PlatypusSchemaInterfaceReference! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 3/22/2006 23:23'!
smaCCStartingState
	^ self expressParserClass startingStateForSchemaEntry! !

!PlatypusSchemaReference methodsFor: 'menus' stamp: 'AlainPlantec 4/27/2012 09:08'!
specificMenu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring 
	the #shifted boolean"
	| newMenu menuExpress |
	super specificMenu: menu shifted: b.
	menu addLine.
	newMenu := MenuMorph new.
	newMenu defaultTarget: self.
	newMenu addList: #(#('type' #menuNewType) #('entity' #menuNewEntity) #('procedure' #menuNewProcedure) #('function' #menuNewFunction) #('rule' #menuNewRule) ).
	menuExpress := MenuMorph new.
	menuExpress add: 'new ...' subMenu: newMenu.
	{#-. #('save... (s)' #menuSave). #('save as... (S)' #menuSaveAs) . #-. #('code pane (p)' #menuCodePane ). #-. #('evaluate all rules' #menuEvaluateAllRules ). #('clean all evaluation results' #menuCleanAllEvaluations ). #-. #('translate here (t)' #menuTranslate2Pharo ). #('translate to VisualWorks' #menuTranslate2VisualWorks )}
		do: [:item | item == #-
				ifTrue: [menuExpress addLine]
				ifFalse: [menuExpress
						add: item first
						target: self
						selector: item second]].
	menu
		add: 'express ...'
		subMenu: menuExpress
		target: self
		selector: nil
		argumentList: #().
	menu addLine.
	^ menu! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 10/1/2003 15:49'!
subElementSymbols
	^ PlatypusSchemaElementReference allSubclasses collect: [ :c | c lexicalElement]! !

!PlatypusSchemaReference methodsFor: 'sublists handling' stamp: 'apl 4/25/2007 16:06'!
subListsDefsArray
	"return an array of array. Each element array is for one
	sublist and 
	contains first a selector for sublist accessing and second a label
	for the sublist"
	| subs |
	subs := OrderedCollection new.
	subs addAll: super subListsDefsArray.
	subs addAll: #(#(#schemaInterfacesReferences #interface) #(#typesReferences #types) #(#entitiesReferences #entities) #(#functionsReferences #functions) #(#proceduresReferences #procedures) #(#rulesReferences #rules) ).
	^ subs! !

!PlatypusSchemaReference methodsFor: 'sublists handling' stamp: 'apl 5/26/2005 16:56'!
subListsReferenceClassName
	^#PlatypusExpressSubListReference! !

!PlatypusSchemaReference methodsFor: 'accessing' stamp: 'apl 5/26/2005 14:21'!
typesReferences
	^self subReferencesOfKind: PlatypusTypeReference! !

!PlatypusSchemaReference methodsFor: 'testing' stamp: 'apl 3/29/2006 19:51'!
usePlatypusPrimitiveSchemata
	^ self metaData notNil and: [self metaData usePlatypusPrimitiveSchemata]! !

!PlatypusExpressReference class methodsFor: 'accessing' stamp: 'apl 2/14/2006 21:02'!
elementClassFromSyntaxicSymbol: aSymbol 
	aSymbol == #schema
		ifTrue: [^ PlatypusSchemaReference].
	aSymbol == #entity
		ifTrue: [^ PlatypusEntityReference].
	aSymbol == #type
		ifTrue: [^ PlatypusTypeReference].
	aSymbol == #procedure
		ifTrue: [^ PlatypusProcedureReference].
	aSymbol == #function
		ifTrue: [^ PlatypusFunctionReference].
	aSymbol == #rule
		ifTrue: [^ PlatypusRuleReference]! !

!PlatypusExpressReference class methodsFor: 'accessing' stamp: 'apl 2/2/2007 11:26'!
saveOutputDirectoryName
	^ 'Platypus-schemata'! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 9/18/2007 16:19'!
accept: input notifying: aRequestor 
	| result |
	Cursor wait
		showWhile: [result := self expressParserClass
						parse: input
						startingAt: self smaCCStartingState
						owner: (self metaData owner
								ifNil: [PltSchemaInstance new namesBuilder: self metaData namesBuilder])
						onError: [:aString :position | 
							(PlatypusParserResultAcceptAbort
								requestor: aRequestor
								metaData: self metaData
								message: aString
								position: position) signal.
							nil].
			result
				ifNil: [^ false].
			[self updateWithParserResult: result]
				on: PlatypusParserResultAcceptingError
				do: [:ex | 
					(PlatypusParserResultAcceptAbort
						requestor: aRequestor
						metaData: self metaData
						message: ex messageText
						position: 1) signal.
					^ false].
			self schemaInstance changeDate: DateAndTime now asString].
	^ true! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 3/23/2006 14:07'!
addWithParserResult: aParserResult 
	| start stop |
	aParserResult tokenList addFirst: PlatypusEolToken new;
		 add: PlatypusEolToken new.
	start := self addingStartNode.
	stop := start
				ifNotNil: [start previous].
	self tokenList
		replaceFromNode: start
		toNode: stop
		with: aParserResult tokenList.
	self
		buildSubReferencesFrom: aParserResult tokenList first
		to: aParserResult tokenList last
		addingOrReplacing: #adding.
	self tokenList updateAllTokensPositions.
	self metaData mySchemaInstance validationResult: false.
	^ true! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:50'!
addingStartNode
	^ self tokenList beginningOfLineFrom: (self tokenList previousPrimaryElementCloseKeywordFrom: self stopNode)! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 4/3/2006 16:10'!
allUsers
	| allUsers |
	allUsers := self usersInto: Set new.
	allUsers remove: self ifAbsent: [].
	^ allUsers! !

!PlatypusExpressReference methodsFor: 'morphic wrapper' stamp: 'apl 3/27/2003 16:28'!
asMorph
	^ self newEditor asMorph! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 9/19/2007 06:04'!
buildSubReferencesFrom: start to: stop addingOrReplacing: addingReplacingOrReplacingAllSymbol 
	| oldContentsByClassIndexes key curr currNameNode newElementClass oldReference elementReference currKeyOldsReferencesList adding |
	oldContentsByClassIndexes := IdentityDictionary new.
	self subElementSymbols
		do: [:s | oldContentsByClassIndexes
				at: (self elementClassFromSyntaxicSymbol: s)
				put: Dictionary new].
	(addingReplacingOrReplacingAllSymbol = #replacing
			or: [addingReplacingOrReplacingAllSymbol = #replacingAll])
		ifTrue: [self subReferences
				do: [:sr | sr isLink
						ifFalse: [key := sr metaData name asUppercase.
							(oldContentsByClassIndexes at: sr class)
								at: key
								ifAbsentPut: OrderedCollection new.
							((oldContentsByClassIndexes at: sr class)
								at: key)
								add: sr]]].
	curr := start.
	[curr ~= stop]
		whileTrue: [(curr isPrimaryElementOpenKeyword
					and: [self subElementSymbols includes: curr lexicalElement])
				ifTrue: [currNameNode := self tokenList nextNonBlankFrom: curr next.
					key := currNameNode lexicalElement asUppercase.
					newElementClass := self elementClassFromSyntaxicSymbol: curr lexicalElement.
					oldReference := (oldContentsByClassIndexes at: newElementClass)
								at: key
								ifPresent: [:v | v first].
					oldReference
						ifNil: [adding := true.
							elementReference := newElementClass new owner: self.
							self subReferences add: elementReference]
						ifNotNil: [adding := false.
							elementReference := oldReference.
							currKeyOldsReferencesList := (oldContentsByClassIndexes at: newElementClass)
										at: key.
							currKeyOldsReferencesList removeFirst.
							currKeyOldsReferencesList isEmpty
								ifTrue: [(oldContentsByClassIndexes at: newElementClass)
										removeKey: key]].
					elementReference name: currNameNode lexicalElement.
					elementReference metaData: curr metaData.
					elementReference startNode: curr.
					elementReference
						stopNode: (self tokenList nextNonBlankFrom: (self tokenList closeTokenFrom: curr) next).
					curr metaData isNil ifFalse: [ curr metaData tamarisItemRef: elementReference.
					adding
						ifTrue: [self logToChangesAdding: elementReference]
						ifFalse: [addingReplacingOrReplacingAllSymbol ~= #replacingAll
								ifTrue: [self logToChangesUpdating: elementReference]].
					elementReference
						buildSubReferencesFrom: elementReference subReferencesScanStart
						to: elementReference stopNode
						addingOrReplacing: #replacingAll].
					curr := elementReference stopNode]
				ifFalse: [curr := curr next]].
	addingReplacingOrReplacingAllSymbol = #replacingAll
		ifTrue: [oldContentsByClassIndexes
				do: [:c | c
						do: [:srl | srl
								do: [:sr | 
									self logToChangesRemoving: sr oldCodeText: sr codeText.
									sr destroy.
									sr owner removeChildSilently: sr]]]]! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 12/20/2006 11:22'!
canHaveCachedEditor
	^ self tokenList notNil 
		! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/26/2007 15:09'!
checks
	| result |
	self verifyUsedModelsBeforeChecking
		ifFalse: [^ false].
	result := self checksSilently.
	PlatypusExpressCodeHolder changed: self.
	^ result! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/6/2006 08:53'!
checksAll
	| result |
	(result := self checksAllSilently).
	PlatypusExpressCodeHolder changed: self.
	^ result! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 9/26/2006 13:18'!
checksAllSilently
	| result sorted withErrs |
	self verifyUsedModelsBeforeChecking ifFalse: [^ false].
	(result := self checksSilently) 
		ifTrue: 
			[self showsAsChecked.
			sorted := self allUsers asArray sort: [:a :b | b usesSchemataOf: a].
			withErrs := OrderedCollection new.
			sorted do: [:u | [u checksSilently] on: Error do: [withErrs add: u]].
			withErrs do: [:u | u checksSilently]].
	^ result! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/29/2008 13:52'!
checksSilently
	| result res |
	result := (res := self resolves)
				and: [self namesChecks
						and: [self semanticChecks]].
	res
		ifTrue: [self showsAsChecked].
	self validationResult: res.
	^ result! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 4/6/2006 11:20'!
codeStreamClass
	^ self
												codeStreamClassFor: self tokenList
												from: self startNode
												to: self stopNode
! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 3/30/2006 13:42'!
codeStreamClassFor: tokenList from: startNode to: stopNode 
	| currNode count |
	tokenList notNil
		ifTrue: [currNode := startNode isNil
						ifTrue: [tokenList first]
						ifFalse: [startNode].
			count := 0.
			[currNode notNil
				and: [currNode ~~ stopNode
						and: [count < self decorationMaxSize]]]
				whileTrue: [count := count + 1.
					currNode := currNode next].
			count < self decorationMaxSize
				ifTrue: [^ PlatypusStepCodeStream]].
	^ WriteStream! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 3/30/2006 10:31'!
codeString
	^ self isReleased
		ifTrue: ['']
		ifFalse: [
	self
		codeTextFrom: self startNode
		to: self stopNode
		stream: String new writeStream]! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 4/6/2006 11:22'!
codeText
	^ self isReleased ifTrue: ['']
		ifFalse: [self codeTextWithStreamClass: self codeStreamClass].
! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 3/30/2006 11:52'!
codeTextFrom: startNode to: stopNode stream: aStream 
	^ self tokenList
		writeOn: aStream
		from: (self tokenList beginningOfLineFrom: startNode)
		to: (self tokenList endOfLineFrom: stopNode)! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 3/30/2006 13:45'!
codeTextFrom: startNode to: stopNode streamClass: aStreamClass 
	^ self tokenList
		textWithStreamClass: aStreamClass
		from: (self tokenList beginningOfLineFrom: startNode)
		to: (self tokenList endOfLineFrom: stopNode)! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 3/13/2003 20:16'!
codeTextWithStream: aStream 
	^ self
		codeTextFrom: self startNode
		to: self stopNode
		stream: aStream! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 3/30/2006 13:45'!
codeTextWithStreamClass: aStreamClass
	^ self
		codeTextFrom: self startNode
		to: self stopNode
		streamClass: aStreamClass! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/22/2006 14:53'!
contents
	^ self subReferences ifNil: [#()]! !

!PlatypusExpressReference methodsFor: 'drag and drop' stamp: 'apl 3/22/2006 18:59'!
copyListItemHereFromTransfertMorph: aTransfertMorph 
	| aSchemaReference |
	aSchemaReference := aTransfertMorph passenger.
	^ self insertReference: aSchemaReference! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 4/7/2006 13:10'!
decorationMaxSize
	^ 7000! !

!PlatypusExpressReference methodsFor: 'initialize/release' stamp: 'apl 3/22/2006 14:53'!
destroy
	self subReferences
				do: [:r | r destroy].
	subReferences := nil.
	super destroy! !

!PlatypusExpressReference methodsFor: 'checking' stamp: 'apl 3/28/2006 22:02'!
doInternalChecking
	self assert: self metaData notNil.
	self assert: self metaData tamarisItemRef = self! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/19/2004 10:21'!
doItContext
	^ self metaData! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 9/14/2007 07:55'!
editorClass
	^ PlatypusExpressCodeHolder! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 21:01'!
elementClassFromSyntaxicSymbol: aSymbol 
	^ self class elementClassFromSyntaxicSymbol: aSymbol! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 3/16/2006 11:18'!
empty
	self subReferences: OrderedCollection new.
	PlatypusExpressCodeHolder changed: self! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/3/2006 15:42'!
emptyModelContentsSubReferences
	self schemaInstanceReference modelContentsReferences
		do: [:mcr | mcr removeSubReferencesSilently]! !

!PlatypusExpressReference methodsFor: 'evaluating' stamp: 'apl 4/14/2006 08:49'!
evaluate
	^ nil! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 4/3/2006 15:29'!
externalSchemaInstances
	^ self schemaInstanceReference metaData externalSchemaInstances
! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 4/3/2006 14:16'!
externalSchemaInstancesReferences
	^ self externalSchemaInstances
		collect: [:e | e tamarisItemRef]! !

!PlatypusExpressReference methodsFor: 'searching' stamp: 'apl 5/11/2004 23:31'!
findExpressReferenceDeeplySuchThat: aBlock 
	| res |
	self isReleased
		ifFalse: [(aBlock value: self)
				ifTrue: [^ self].
			self subReferences
				do: [:sr | (res := sr findExpressReferenceDeeplySuchThat: aBlock)
						ifNotNil: [^ res]]].
	^ nil! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 2/16/2006 11:54'!
forceOkToChange
	^ true! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 5/28/2004 11:08'!
fullCodeString
	^ self codeString! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'apl 3/20/2007 10:03'!
generatedCodeTaxonLabel
^ self schemaInstanceReference listLabel , ' generated code'.
! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'apl 3/8/2007 15:32'!
generatedRootClassSystemCategory
	^ self metaData rootClassSystemCategory asSymbol! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'apl 3/8/2007 15:32'!
generatedRootClassSystemCategoryExists
	^ (Smalltalk organization listAtCategoryNamed: self generatedRootClassSystemCategory) notEmpty! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'apl 3/8/2007 15:32'!
generatedRootClassSystemCategoryReference
	^ self generatedRootClassSystemCategoryExists
		ifTrue: [TamSystemCategoryReference sysCatSymbol: self metaData rootClassSystemCategory]! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'apl 4/8/2006 08:06'!
generatedSystemCategory
	^ self metaData generatedSystemCategory asSymbol! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'apl 4/8/2006 08:06'!
generatedSystemCategoryExists
	^ (Smalltalk organization listAtCategoryNamed: self generatedSystemCategory) notEmpty! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'AlainPlantec 1/28/2011 09:55'!
generatedSystemCategoryReference
	^ self generatedSystemCategoryExists
		ifTrue: [TamSystemCategoryReference sysCatSymbol: self generatedSystemCategory]! !

!PlatypusExpressReference methodsFor: 'initialize/release' stamp: 'apl 9/26/2003 12:45'!
initialize
	super initialize.
	subReferences := OrderedCollection new! !

!PlatypusExpressReference methodsFor: 'generated code' stamp: 'AlainPlantec 1/28/2011 09:57'!
insertGeneratedCodeTaxon
	| taxonRef rscr founds |
	founds := self taxonomyRoot
				selectDeeplySuchThat: [:e | e shortName = self generatedCodeTaxonLabel].
	founds size = 0
		ifTrue: [taxonRef := TamTaxonReference taxonLabel: self generatedCodeTaxonLabel.
			taxonRef emphasisModel: TamListItemMorphEmphasisModel greenStandard.
			self parentTaxon insertReferenceSilently: taxonRef]
		ifFalse: [taxonRef := founds first].
	taxonRef empty.
	(rscr := self generatedRootClassSystemCategoryReference)
		ifNotNil: [taxonRef insertReferenceSilently: rscr].
	taxonRef insertReferenceSilently: self schemaInstanceReference generatedSystemCategoryReference.
	self schemaInstanceReference metaData internalSchemata
		do: [:isch | | sub |
			sub := isch tamarisItemRef generatedSystemCategoryReference.
			sub ifNotNil: [taxonRef insertReferenceSilently: sub]].
	taxonRef children
		do: [:chld | chld emphasisModel: TamListItemMorphEmphasisModel greenStandard].
		TamManager changed: taxonRef! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/28/2006 09:51'!
interactiveCallArguments
	^ interactiveCallArguments! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/28/2006 09:51'!
interactiveCallArguments: aString
	 interactiveCallArguments := aString! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 11/14/2003 11:42'!
isCopyable
	^ false! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 3/25/2003 14:31'!
isEditable
	^true! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 11/14/2003 11:42'!
isMoveable
	^ false! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 9/26/2003 15:05'!
isRemoveable
	^ true! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 3/13/2003 20:11'!
isSchema
	^ false! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 3/13/2003 20:11'!
isSchemaElement
	^false! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 10/26/2006 19:02'!
isSchemaInstanceReference
	^ false! !

!PlatypusExpressReference methodsFor: 'testing' stamp: 'apl 10/26/2006 19:05'!
isSchemaReference
	^ false! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 5/2/2012 12:55'!
keyStroke: aCharacter from: aListMorph 
	super keyStroke: aCharacter from: aListMorph.
	aCharacter = $B
		ifTrue: [^ self menuBrowseGenerated].
	aCharacter = $s
		ifTrue: [^ self menuSave].
	aCharacter = $S
		ifTrue: [^ self menuSaveAs].
	aCharacter = $t
		ifTrue: [^ self menuTranslate2Pharo].
	aCharacter = $T
		ifTrue: [^ self translateAndFileItIn]! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 20:58'!
lexicalElement
	^ self class lexicalElement! !

!PlatypusExpressReference methodsFor: 'smalltalk changes logging' stamp: 'apl 3/1/2006 10:14'!
logToChangesAdding: aReference 
	self logToChangesKey: 'Adding'  element: aReference longName codeText: aReference codeText  
! !

!PlatypusExpressReference methodsFor: 'smalltalk changes logging' stamp: 'apl 3/1/2006 11:33'!
logToChangesKey: aChangeKey element: elementName codeText: aStringOrText 
	SmalltalkImage current logChange: '----Platypus: ' , aChangeKey , String cr , elementName , String cr , aStringOrText ,String cr,  '----'! !

!PlatypusExpressReference methodsFor: 'smalltalk changes logging' stamp: 'apl 3/1/2006 10:25'!
logToChangesRemoving: aReference oldCodeText: aStringOrText 
	self
		logToChangesKey: 'Removing'
		element: aReference longName
		codeText: aStringOrText! !

!PlatypusExpressReference methodsFor: 'smalltalk changes logging' stamp: 'apl 3/30/2006 09:52'!
logToChangesUpdating: aReference 
	self
		logToChangesKey: 'Updating'
		element: aReference longName
		codeText: aReference codeString! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 7/14/2011 16:57'!
menuBrowseGenerated
	| genClassName cls |
	genClassName := self metaData generatedClassName.
	cls := PlatypusPharoSmalltalk at: genClassName asSymbol ifAbsent: [^ self inform: (genClassName , ' is not generated')].
	cls browse! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 10:50'!
menuRelabel
	| oldname newname |
	oldname := self metaData name.
	(newname := UIManager default
				request: 'new name ?'
				initialAnswer: (oldname
						ifNil: [''])) trimBoth
		ifEmpty: [^ false]
		ifNotEmpty: [:v | newname ~= oldname
				ifTrue: [
					^ self relabelWith: newname]]! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 09:28'!
menuSave
	| fileName fileStream |
	fileName := self saveFullPath, '.exp'.
	(FileDirectory default
		directoryNamed: (FileDirectory dirPathFor: fileName)) assureExistence.
	(fileStream := StandardFileStream forceNewFileNamed: fileName)
		ifNotNil: [Cursor write
				showWhile: [[fileStream nextPutAll: self codeString]
						ensure: [fileStream close]]]! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 12/2/2010 18:11'!
menuSaveAs
	| result |
	result := UITheme current 
		fileSaveIn: World
		title: 'File name'
		extensions: #('exp')
		path: ''.
	result ifNotNil: [[result nextPutAll: self codeString] ensure: [result close]]! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 5/2/2012 12:56'!
menuTranslate2Pharo
	| result fileName fileStream |
	Transcript show: 'Translating ' , self listLabel , '...'.
	result := self translated2Pharo.
	fileName := self saveFullPath , '-pharo.st'.
	(FileDirectory default
		directoryNamed: (FileDirectory dirPathFor: fileName)) assureExistence.
	(fileStream := StandardFileStream forceNewFileNamed: fileName)
		ifNotNil: [Cursor write
				showWhile: [[fileStream nextPutAll: result]
						ensure: [fileStream close]]].
	
	(Workspace new contents: result)
		openLabel: 'Translation of ''' , self listLabel , ''''.
	Transcript show: String cr! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 09:25'!
menuTranslate2VisualWorks
	| result fileName fileStream |
	Transcript show: 'Translating ' , self listLabel , '...'.
	result := self translateWithTranslator: self translaterForVisualWorks.
	fileName := self saveFullPath , '-vw.st'.
	(FileDirectory default
		directoryNamed: (FileDirectory dirPathFor: fileName)) assureExistence.
	(fileStream := StandardFileStream forceNewFileNamed: fileName)
		ifNotNil: [Cursor write
				showWhile: [[fileStream nextPutAll: result]
						ensure: [fileStream close]]].
	(Workspace new contents: result)
		openLabel: 'Translation of ''' , self listLabel , ''''.
	Transcript show: String cr! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 5/27/2003 02:14'!
metaData
	^ nil! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 6/8/2004 11:03'!
modelContents
	^ nil! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 4/26/2007 15:15'!
modelContentsReferences
	^ self rootSourceHandler modelContentsReferences! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 2/15/2007 15:52'!
namesBuilder
	^ self metaData mySchemaInstance namesBuilder! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 1/25/2007 16:30'!
namesChecks
	^ self metaData namesChecks.
! !

!PlatypusExpressReference methodsFor: 'morphic wrapper' stamp: 'apl 3/12/2007 13:29'!
newEditor
	| editor |
	editor := self editorClass new.
	editor buildTamarisWindow.
	editor sourceHandler: self.
	editor messagesBrowser
		ifNotNil: [editor updateMessagesBrowser].
	^ editor mainWindow ! !

!PlatypusExpressReference methodsFor: 'code accessing' stamp: 'apl 3/16/2004 09:45'!
prettyPrintedExpressCode
	^ self metaData prettyPrintedExpressCode! !

!PlatypusExpressReference methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:53'!
reinitialize
	self subReferences do: [:r | r destroy].
	self subReferences: OrderedCollection new! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 6/4/2004 11:20'!
relabelWith: aName 
	self metaData renameWith: aName.
	super relabelWith: aName.
! !

!PlatypusExpressReference methodsFor: 'updating' stamp: 'apl 11/2/2006 10:38'!
remove
	| oldOwner |
	self schemaInstanceReference showsUsersAsToBeChecked.
	oldOwner := self owner.
	self metaData ifNotNil: [ 
		self metaData mySchemaInstance validationResult: false].
	self removeSilently.
	PlatypusExpressCodeHolder changed: oldOwner! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 2/15/2006 10:53'!
removeChildSilently: aReference 
	aReference isLink
		ifTrue: [(self metaData respondsTo: #removeElement:)
				ifTrue: [self metaData removeElement: aReference linked].
			self subReferences
				remove: aReference
				ifAbsent: []]
		ifFalse: [(aReference isKindOf: PlatypusExpressReference)
				ifTrue: [aReference metaData
						ifNotNil: [(self metaData respondsTo: #removeElement:)
								ifTrue: [self metaData removeElement: aReference metaData]].
					self subReferences
						remove: aReference
						ifAbsent: []]].
	super removeChildSilently: aReference! !

!PlatypusExpressReference methodsFor: 'updating' stamp: 'apl 3/23/2006 09:51'!
removeSilently
	super removeSilently! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 3/27/2006 18:28'!
replaceMetaDataWith: aMetaData 
	self metaData owner removeElement: self metaData.
	self metaData deepDestroy.
	self metaData: aMetaData.
	self metaData tamarisItemRef: self! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 3/23/2006 14:07'!
replaceWithParserResult: aParserResult 
	| start stop |
	self replaceMetaDataWith: aParserResult metaData.
	start := self tokenList beginningOfLineFrom: self startNode.
	stop := self tokenList endOfLineFrom: self stopNode.
	self tokenList
		replaceFromNode: start
		toNode: stop
		with: aParserResult tokenList.
	self startNode: aParserResult tokenList first.
	self stopNode: aParserResult tokenList last.
	self
		buildSubReferencesFrom: self subReferencesScanStart
		to: self stopNode
		addingOrReplacing: #replacingAll.
	self tokenList updateAllTokensPositions.
	self metaData mySchemaInstance validationResult: false.
	self logToChangesUpdating: self.
	^ true! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 3/22/2007 19:26'!
resolves
	^ self metaData resolves! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'apl 2/2/2007 11:33'!
saveFullPath
	| path odirName |
	path := WriteStream on: String new.
	odirName := self class saveOutputDirectoryName.
	path nextPutAll: odirName;
		 nextPutAll: FileDirectory pathNameDelimiter asString.
	self parentsChain
		do: [:p | path nextPutAll: p listLabel;
				 nextPutAll: FileDirectory pathNameDelimiter asString].
	^ path contents , self name ! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 09:24'!
schemaInstance
	^ self schemaInstanceReference schemaInstance! !

!PlatypusExpressReference methodsFor: 'tam taxonomy browser' stamp: 'apl 3/29/2006 12:54'!
selectingFrom: aTamarisBrowser 
	| editor |
	editor := super selectingFrom: aTamarisBrowser.
	PlatypusExpressCodeHolder addDependent: aTamarisBrowser.
	^ editor! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 6/10/2004 09:38'!
selectionString
	^ self codeString! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 1/25/2007 16:32'!
semanticChecks
	
	^ self metaData semanticChecks! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/3/2006 10:23'!
showsAsChecked
	self schemaInstanceReference showsAsChecked! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/3/2006 10:22'!
showsAsToBeChecked
	self schemaInstanceReference showsAsToBeChecked! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/13/2003 20:09'!
smaCCStartingState
	^ self subclassResponsibility! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 5/13/2005 11:58'!
specificButtonsColumn: aTaxonomyBrowser inAlignment: aButtonsAlignment 
	aTaxonomyBrowser editorModel ifNotNil: [aTaxonomyBrowser editorModel  addButtonsinAlignment: aButtonsAlignment.
	aButtonsAlignment addSpacer].
	^aButtonsAlignment! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/13/2003 20:19'!
startLevel
	^ 0! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/13/2003 20:08'!
startNode
	^ self subclassResponsibility! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/13/2003 20:08'!
stopNode
	^ self subclassResponsibility! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 20:54'!
subElementSymbols
	^ PlatypusSchemaElementReference allSubclasses
		collect: [:c | c lexicalElement]! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/2/2007 11:41'!
subReferences
	^ subReferences
		ifNil: [OrderedCollection new]! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/19/2003 17:47'!
subReferences: anObject
	subReferences := anObject! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 2/15/2006 09:16'!
subReferencesScanStart
	^  (self tokenList nextOpenKeywordFrom: self startNode) next! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 3/23/2006 09:24'!
takeParserResult: aParserResult 
	^ self subclassResponsibility! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 5/12/2004 10:30'!
tamarisItemRef
	^ self! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/17/2006 15:53'!
tokenList
	^ self schemaInstanceReference ifNotNil: [self schemaInstanceReference tokenList]! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 7/14/2011 17:50'!
translateAndFileItIn
	| src |
	src := self translated2Pharo.
	(ReadWriteStream
		on: src
		from: 1
		to: src size) fileIn; close.
	self insertGeneratedCodeTaxon! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'apl 2/15/2007 16:04'!
translateWithTranslator: aTranslator 
	^ aTranslator translate: self metaData ! !

!PlatypusExpressReference methodsFor: 'menus' stamp: 'AlainPlantec 7/14/2011 17:50'!
translated2Pharo
	^ self translateWithTranslator: self translaterForPharo .
! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 17:50'!
translaterForPharo
	^ self rootDictionaryReference translaterForPharo! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 3/8/2006 11:14'!
translaterForVisualWorks
	^ self rootDictionaryReference translaterForVisualWorks! !

!PlatypusExpressReference methodsFor: 'tam taxonomy browser' stamp: 'apl 3/16/2006 11:18'!
unSelectingFrom: aTamarisBrowser 
	PlatypusExpressCodeHolder removeDependent: aTamarisBrowser.
	super unSelectingFrom: aTamarisBrowser! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/6/2006 08:58'!
updateWithParserResult: aParserResult 
	aParserResult tokenList noEndingEol.
	self showsAsToBeChecked.
	self emptyModelContentsSubReferences.
	self takeParserResult: aParserResult! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 10/26/2006 18:52'!
users
	| allSchemaInstanceRefs |
	allSchemaInstanceRefs := PlatypusSchemaInstanceReference 
				allSchemaInstancesReferences.
	allSchemaInstanceRefs remove: self schemaInstanceReference.
	^ allSchemaInstanceRefs select: 
			[:schir | 
			(schir schemaInstance externalSchemataNames 
				intersection: self schemaInstanceReference schemaInstance 
						internalSchemataNames) 
					notEmpty]! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 10/26/2006 18:52'!
usersAsMeta
	| allSchemaInstanceRefs |
	allSchemaInstanceRefs := PlatypusSchemaInstanceReference 
				allSchemaInstancesReferences.
	allSchemaInstanceRefs remove: self schemaInstanceReference.
	^ allSchemaInstanceRefs select: 
			[:schir | 
			(schir schemaInstance metaSchemataNames 
				intersection: self schemaInstanceReference schemaInstance 
						internalSchemataNames) 
					notEmpty]! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'AlainPlantec 10/14/2010 18:56'!
usersInto: aSet 
	| locals |
	(aSet includes: self)
		ifFalse: [aSet addAll: (locals := PlatypusSchemaInstanceReference allSchemaInstancesReferences
							select: [:schir | self schemaInstanceReference schemaInstance notNil and: [(schir schemaInstance externalSchemataNames intersection: self schemaInstanceReference schemaInstance internalSchemataNames) notEmpty]]).
			locals
				do: [:u | u usersInto: aSet]].
	^ aSet! !

!PlatypusExpressReference methodsFor: 'accessing' stamp: 'apl 4/3/2006 16:11'!
usesSchemataOf: otherSchemaInstanceReference 
	^ (self schemaInstanceReference schemaInstance externalSchemataNames intersection: otherSchemaInstanceReference schemaInstance internalSchemataNames) notEmpty! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/26/2007 15:08'!
validationResult: aBoolean 
	self metaData mySchemaInstance validationDate: DateAndTime now asString.
	self metaData mySchemaInstance changeDate isNil
		ifTrue: [self metaData mySchemaInstance changeDate: self metaData mySchemaInstance validationDate].
	self metaData mySchemaInstance validationResult: aBoolean.
	self modelContentsReferences
		do: [:r | r validationResult: false]! !

!PlatypusExpressReference methodsFor: 'code updating' stamp: 'apl 4/3/2006 14:51'!
verifyUsedModelsBeforeChecking
	| invalidRefsStr |
	(self externalSchemaInstancesReferences
		select: [:ext | ext knownAsInvalid])
		ifNotEmpty: [:invalidRefs | 
			invalidRefsStr := String cr.
			invalidRefs
				do: [:ir | invalidRefsStr := invalidRefsStr , ('"' , ir name , '"' , String cr)].
			self inform: 'Some used models must be checked before.' , String cr , 'These models are: ' , invalidRefsStr , String cr.
			^ false].
^ true! !

PlatypusExpressReference subclass: #PlatypusSchemaInstanceReference
	instanceVariableNames: 'schemaInstance tokenList modelContentsReferences'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusSchemaInstanceReference subclass: #PlatypusInternalMetaSchemaInstanceReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusInternalMetaSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 12/16/2005 13:00'!
expressMetaDictionary ^ self initializeExpressMetaDictionaryIfNeeded ! !

!PlatypusInternalMetaSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 12/16/2005 13:00'!
expressMetaDictionaryName ^ 'Platypus_meta_schemas' ! !

!PlatypusInternalMetaSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 12/20/2005 17:28'!
expressMetaSchemasCode ^ PltPlatypusMetaSchemasSchemaInstance singleton expressSchemaCode ! !

!PlatypusInternalMetaSchemaInstanceReference class methodsFor: 'initializing' stamp: 'apl 11/2/2006 13:14'!
initializeExpressMetaDictionary
	"self initializeExpressMetaDictionary"

	| newref |
	newref := self schemaInstanceNamed: self expressMetaDictionaryName.
	TamManager platypusMetaDefaultTaxon insertReference: newref.
	newref accept: self expressMetaSchemasCode notifying: nil.
	newref checks.
	^ newref! !

!PlatypusInternalMetaSchemaInstanceReference class methodsFor: 'initializing' stamp: 'AlainPlantec 10/16/2010 12:14'!
initializeExpressMetaDictionaryIfNeeded
	"self initializeExpressMetaDictionaryIfNeeded"
	| candidats |
	(candidats := self allSchemaInstanceReferencesNamed: self expressMetaDictionaryName) size > 1
		ifTrue: [self error: 'Several meta schemas ??'].
	candidats isEmpty
		ifTrue: [^ self initializeExpressMetaDictionary]
		ifFalse: [^ candidats first] ! !

!PlatypusInternalMetaSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/26/2006 19:04'!
lookUpExpressMetaDictionary
	^ self allInstances copy detect: [:epd | epd isMetaSchemaInstanceReference]
		ifNone: []! !

!PlatypusInternalMetaSchemaInstanceReference methodsFor: 'copying' stamp: 'apl 12/16/2005 13:06'!
copy ^ self error: 'can''t copy a meta dictionary reference' ! !

!PlatypusInternalMetaSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/31/2006 08:25'!
expressParserClassName ^ #PlatypusExpressPrimitiveParser ! !

!PlatypusInternalMetaSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 3/14/2006 09:22'!
isExpressMetaDictionary ^ self isReleased not and: [ self name = self class expressMetaDictionaryName ] ! !

!PlatypusInternalMetaSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/14/2007 16:17'!
namesBuilder
	^ PlatypusNamesBuilder meta! !

PlatypusSchemaInstanceReference subclass: #PlatypusInternalPrimitiveSchemaInstanceReference
	instanceVariableNames: 'identifiersCache namedTypesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-VW-Compatibility'!

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'private accessing' stamp: 'AlainPlantec 7/14/2011 16:57'!
classBlackList
	"self classBlackList"
	| blackList |
	blackList := Set new.
	SystemOrganization categories
		do: [:cat | blackList
				addAll: ((SystemOrganization listAtCategoryNamed: cat)
						select: [:cls | (PlatypusPharoSmalltalk at: cls) class includesSelector: #translatedFromISO10303P11])].
	^ blackList! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 6/10/2004 22:10'!
expressPrimitiveDictionary
	^ self initializeExpressPrimitiveDictionaryIfNeeded! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 2/2/2006 14:45'!
expressPrimitiveDictionaryName
	^ 'Platypus_Express_primitives'! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 3/1/2006 22:28'!
expressPrimitiveSchemasCode
 ^ PltPlatypusExpressPrimitivesSchemaInstance singleton expressSchemaCode! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'initializing' stamp: 'apl 11/2/2006 13:14'!
initializeExpressPrimitiveDictionary
	"self initializeExpressPrimitiveDictionary"

	| newref |
	newref := self schemaInstanceNamed: self expressPrimitiveDictionaryName.
	TamManager platypusMetaDefaultTaxon insertReference: newref.
	newref accept: self expressPrimitiveSchemasCode notifying: nil.
	newref checks.
	^ newref! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'initializing' stamp: 'apl 11/2/2006 13:12'!
initializeExpressPrimitiveDictionaryIfNeeded
	"self initializeExpressPrimitiveDictionaryIfNeeded"

	| candidats |
	(candidats := self 
				allSchemaInstanceReferencesNamed: self expressPrimitiveDictionaryName) size 
		> 1 ifTrue: [self error: 'Several meta schemas ??'].
	candidats isEmpty 
		ifTrue: [^ self initializeExpressPrimitiveDictionary]
		ifFalse: [^ candidats first]! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'initializing' stamp: 'AlainPlantec 7/14/2011 18:00'!
initializePharoPrimitiveDictionary
	"self initializePharoPrimitiveDictionary"

	| newref |
	self halt.
	newref := self schemaInstanceNamed: self pharoPrimitiveDictionaryName.
	TamManager platypusMetaDefaultTaxon insertReference: newref.
	newref accept: self pharoPrimitiveSchemasCode notifying: nil.
	newref checks.
	^  newref
! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'initializing' stamp: 'AlainPlantec 7/14/2011 17:53'!
initializePharoPrimitiveDictionaryIfNeeded
	"self initializePharoPrimitiveDictionaryIfNeeded"

	| candidats |
	(candidats := self 
				allSchemaInstanceReferencesNamed: self pharoPrimitiveDictionaryName) size 
		> 1 ifTrue: [self error: 'Several meta schemas ??'].
	candidats isEmpty 
		ifTrue: [^ self initializePharoPrimitiveDictionary]
		ifFalse: [^ candidats first]
		
	! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 6/23/2005 12:28'!
lookUpExpressPrimitiveDictionary
	^ self allInstances copy
		detect: [:epd | epd isExpressPrimitiveDictionary]
		ifNone: []! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 17:56'!
lookUpPharoPrimitiveDictionary
	^ self allInstances copy
		detect: [:epd | epd isPharoPrimitiveDictionary]
		ifNone: []! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 7/21/2004 10:52'!
lookUpPrimitiveIdentifierBN: anIdent 
	| |
	^ self expressPrimitiveDictionary lookUpIdentifierBN: anIdent ! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 3/17/2006 23:01'!
lookUpPrimitiveNamedTypeBN: anIdent 
	^ (self expressPrimitiveDictionary lookUpNamedTypeBN: anIdent)
		! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 16:58'!
pharoPrimitiveDictionaryName
	^ 'Platypus_Pharo_primitives'.! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 17:59'!
pharoPrimitiveSchemasCode
	"self pharoPrimitiveSchemasCode"
	| res outCat nameClassifier outN clsName clsSupName usedCat usedOutCat addedCat classBlackList |
	res := WriteStream on: String new.
	classBlackList := self classBlackList.
	nameClassifier := PlatypusExpressTokenClassifier new.
	(SystemOrganization categories asSet difference: self systemCategoryBlackList)
		do: [:cat | 
			usedCat := Set
						with: (SystemOrganization categoryOfElement: #Object).
			(SystemOrganization superclassOrder: cat)
				do: [:cls | cls superclass
						ifNotNil: [(addedCat := SystemOrganization categoryOfElement: cls superclass name asSymbol)
								ifNotNil: [usedCat add: addedCat]]].
			usedCat
				remove: cat
				ifAbsent: [].
			outCat := cat
						copyReplaceAll: '-'
						with: '_'
						asTokens: false.
			outCat := outCat
						copyReplaceAll: ' '
						with: '_'
						asTokens: false.
			res nextPutAll: 'SCHEMA ' , outCat , ';' , String cr.
			usedCat
				do: [:ucat | 
					usedOutCat := ucat
								copyReplaceAll: '-'
								with: '_'
								asTokens: false.
					usedOutCat := usedOutCat
								copyReplaceAll: ' '
								with: '_'
								asTokens: false.
					res nextPutAll: '	USE FROM ' , usedOutCat , ';']
				separatedBy: [res nextPutAll: String cr].
			res nextPutAll: String cr.
			res nextPutAll: String cr.
			((SystemOrganization superclassOrder: cat) difference: classBlackList)
				do: [:cls | 
					(nameClassifier
						tokenClassFromString: cls name
						ifAbsent: [])
						ifNil: [clsName := cls name]
						ifNotNil: [clsName := cls name , '_'].
					(nameClassifier
						tokenClassFromString: cls superclass name
						ifAbsent: [])
						ifNil: [clsSupName := cls superclass name]
						ifNotNil: [clsSupName := cls superclass name , '_'].
					res nextPutAll: '	ENTITY ' , clsName.
					cls superclass
						ifNotNil: [res nextPutAll: ' subtype of (' , clsSupName , ')'].
					res nextPutAll: ';' , String cr.
					cls instVarNames
						do: [:n | 
							(nameClassifier
								tokenClassFromString: n
								ifAbsent: [])
								ifNil: [outN := n]
								ifNotNil: [outN := n , '_'].
							res nextPutAll: '		' , outN , ' : Object;' , String cr].
					res nextPutAll: '	END_ENTITY;' , String cr , String cr].
			res nextPutAll: 'END_SCHEMA; -- ' , outCat , String cr , String cr].
	^ res contents! !

!PlatypusInternalPrimitiveSchemaInstanceReference class methodsFor: 'private accessing' stamp: 'AlainPlantec 7/14/2011 16:57'!
systemCategoryBlackList
	"self systemCategoryBlackList"
	| blackList |
	blackList := Set with: #''.
	SystemOrganization categories
		do: [:cat | ((SystemOrganization listAtCategoryNamed: cat)
					select: [:cls | ((PlatypusPharoSmalltalk at: cls) class includesSelector: #translatedFromISO10303P11) not]) isEmpty
				ifTrue: [blackList add: cat]].
	^ blackList! !

!PlatypusInternalPrimitiveSchemaInstanceReference methodsFor: 'copying' stamp: 'apl 7/7/2004 19:40'!
copy
	^ self error: 'can''t copy a primitive dictionary reference'! !

!PlatypusInternalPrimitiveSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/31/2006 08:53'!
expressParserClassName
	^ #PlatypusExpressPrimitiveParser! !

!PlatypusInternalPrimitiveSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 3/14/2006 09:22'!
isExpressPrimitiveDictionary
	^ self isReleased not
		and: [self  name = self class expressPrimitiveDictionaryName]! !

!PlatypusInternalPrimitiveSchemaInstanceReference methodsFor: 'testing' stamp: 'AlainPlantec 7/14/2011 17:55'!
isPharoPrimitiveDictionary
	^ self isReleased not
		and: [self  name = self class pharoPrimitiveDictionaryName]! !

!PlatypusInternalPrimitiveSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/14/2007 16:17'!
namesBuilder
	^ PlatypusNamesBuilder meta! !

!PlatypusInternalPrimitiveSchemaInstanceReference methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 17:58'!
translaterForPharo
	^ PlatypusExpressMetaStructure2PharoTranslater 
		namesBuilder: self namesBuilder! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 09:29'!
addReferenceFromFilenamed: aFilename intoOwner: aReference 
	| initial strm |
	initial := FileDirectory default localNameFor: aFilename.
	(initial indexOf: $.)
			> 0
		ifTrue: [initial := initial copyFrom: 1 to: (initial indexOf: $.)
							- 1].
	(UIManager default request: 'Model name: ' initialAnswer: initial)
		ifNotEmpty: [:key | (strm := StandardFileStream readOnlyFileNamed: aFilename)
				ifNotNil: [[self
						addReferenceFromStream: strm
						intoOwner: aReference
						modelName: key]
						ensure: [strm close]]]
! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'apl 3/1/2007 19:28'!
addReferenceFromStream: aStream intoOwner: aReference modelName: anIdent 
	| fileContents parsingResult codeHolder window newSchi |
	fileContents := aStream contents.
	parsingResult := PlatypusExpressParser
				parse: fileContents
				owner: self schemaInstanceClass new
				onError: [:aString :position | 
					codeHolder := TamStringHolder new.
					codeHolder contents: fileContents.
					window := codeHolder embeddedInMorphicWindowLabeled: anIdent , ' parse error'.
					codeHolder textMorph selectFrom: position to: position - 1.
					codeHolder textMorph replaceSelectionWith: aString , '->'.
					codeHolder textMorph selectFrom: position to: position + aString size + 1.
					window openInWorld.
					^ nil].
	(newSchi := self owner: aReference schemaInstanceNamed: anIdent) replaceWithParserResult: parsingResult.
	newSchi checks.
	PlatypusExpressCodeHolder changed: self! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'apl 2/19/2006 22:14'!
addReferenceMenuItemToMenu: aMenu owner: anotherReference 
	| menuAddReference |
	(menuAddReference := self subMenuLabelSubMenu: aMenu)
		add: 'from scratch'
		subMenu: nil
		target: self
		selector: #menuAddReferenceIntoOwner:
		argumentList: {anotherReference}.
	menuAddReference
		add: 'from file ...'
		subMenu: nil
		target: self
		selector: #menuAddReferenceFromFileIntoOwner:
		argumentList: {anotherReference}! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'apl 3/2/2007 11:56'!
addReferenceToFromFileListTaxonFromFilenamed: aFilename 
	self addReferenceFromFilenamed: aFilename intoOwner: TamManager fromFileListTaxonomy! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 3/15/2006 19:08'!
allExpressTranslaters
	^ PlatypusSchemaInstanceReference allSubInstances
		select: [:d | d isReleased not
				and: [d canBeExpressTranslater]]! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 11/2/2006 13:03'!
allSchemaInstanceReferencesNamed: aName 
	^ self allSchemaInstancesReferences 
		select: [:r | r name asUppercase = aName asUppercase]! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 1/26/2007 09:56'!
allSchemaInstancesReferences
	^ PlatypusSchemaInstanceReference allSubInstances
		select: [:d | d isReleased not and: [d schemaInstance notNil]]! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/26/2006 19:10'!
allSchemaReferences
	^ self allSchemaInstancesReferences inject: OrderedCollection new into: [:all :schir | all 
				addAll:  schir internalSchemaReferences;
				yourself]! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/27/2006 10:28'!
allSchemaReferencesNamed: aName
	^ self allSchemaReferences select: [:r | r name asUppercase = aName asUppercase]! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'apl 5/11/2004 17:24'!
canBeCreatedInteractively
	^ true! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/27/2006 10:40'!
chooseExpressTranslaterForClient: aClient selectingBlock: aBlock 
	| aghl |
	Cursor normal showWhile: 
			[aghl := TamGenericHierarchicalList 
						fromRootListItems: (self allExpressTranslaters 
								collect: [:n | TamGenericHierarchicalListItem linked: n])
						title: 'EXPRESS Translaters'
						client: aClient.
			aghl 
				doDeeply: [:el | el selectingBlock: [:e | aBlock value: aghl value: e linked]].
			aghl doDeeply: [:el | el unSelectingBlock: [:e | ]].
			aghl openModal]! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/27/2006 10:44'!
chooseSchemaForClient: aClient selectingBlock: aBlock candidats: aListOfSchemaRef 
	^ self 
		chooseSchemaForClient: aClient
		selectingBlock: aBlock
		candidats: aListOfSchemaRef
		title: 'EXPRESS schemata'! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/27/2006 11:45'!
chooseSchemaForClient: aClient selectingBlock: aBlock candidats: aListOfSchemaRef title: aTitle 
	| aghl flatten |
	Cursor normal showWhile: 
			[flatten := aListOfSchemaRef 
						collect: [:schref | Array with: schref owner with: schref].
			aghl := TamGenericHierarchicalList 
						fromFlatCollection: flatten
						title: aTitle
						client: aClient.
			aghl doDeeply: 
					[:el | 
					
					el selectingBlock: [:e | aBlock value: aghl value: e linked]].
			aghl doDeeply: [:el | el unSelectingBlock: [:e | ]].
			aghl openModalAndExpand]! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/27/2006 10:40'!
chooseSchemaInstanceForClient: aClient selectingBlock: aBlock 
	| aghl |
	Cursor normal showWhile: 
			[aghl := TamGenericHierarchicalList 
						fromRootListItems: (self allSchemaInstancesReferences 
								collect: [:n | TamGenericHierarchicalListItem linked: n])
						title: 'EXPRESS models'
						client: aClient.
			aghl 
				doDeeply: [:el | el selectingBlock: [:e | aBlock value: aghl value: e linked]].
			aghl 
				doDeeply: [:el | el unSelectingBlock: [:e | ]].
			aghl openModal]! !

!PlatypusSchemaInstanceReference class methodsFor: 'file list services' stamp: 'apl 3/2/2007 11:55'!
fileReaderServicesForFile: fullName suffix: suffix 
	^ suffix = 'exp'
		ifTrue: [Array with: self serviceNewPlatypusModelFromFile]
		ifFalse: [#()]! !

!PlatypusSchemaInstanceReference class methodsFor: 'class initialization' stamp: 'apl 3/1/2007 20:20'!
initialize
	"register the receiver in the global registries"
	self environment
		at: #FileList
		ifPresent: [:cl | cl registerFileReader: self]! !

!PlatypusSchemaInstanceReference class methodsFor: 'instance creation' stamp: 'apl 11/2/2006 12:46'!
initializePlatypusMetaSchemataIfNeeded
	PlatypusInternalMetaSchemaInstanceReference 
		initializeExpressMetaDictionaryIfNeeded.
	PlatypusInternalPrimitiveSchemaInstanceReference 
		initializeExpressPrimitiveDictionaryIfNeeded! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'AlainPlantec 5/2/2012 14:19'!
interactivelyResolvedSchemaSatisfying: aBlock message: aMessage
	| chosen candidats |
	candidats := self selectSchemaReferences: aBlock.
	candidats isEmpty ifTrue: [^ nil].
	candidats size = 1 ifTrue: [^ candidats first].
	self 
		chooseSchemaForClient: nil
		selectingBlock: 
			[:l :e | 
			chosen := e linked.
			l close]
		candidats: candidats
		title: aMessage.
	^ chosen! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'AlainPlantec 1/28/2011 13:51'!
menuAddReferenceFromFileIntoOwner: aReference 
	| result fullFilename |
	result := Tamaris
			chooseFilePathMatching: #('*.exp')
			label: 'Choose file to read' translated.
	result
		ifNotNil: [ 
			(FileDirectory default fileExists: result)
				ifFalse: [^ UIManager default inform: ' ' , result , ' not found '].
			self addReferenceFromFilenamed: result intoOwner: aReference]! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'AlainPlantec 5/4/2012 11:13'!
menuAddReferenceIntoOwner: aReference 
	(UIManager default request: 'Model name' initialAnswer: '')
		ifNotNil: [:key | self owner: aReference schemaInstanceNamed: key ]
! !

!PlatypusSchemaInstanceReference class methodsFor: 'instance creation' stamp: 'apl 3/14/2006 08:59'!
owner: aReference schemaInstance: aSchemaInstance 
	| newRef |
	newRef := self schemaInstance: aSchemaInstance.
	aReference insertReference: newRef.
	^ newRef! !

!PlatypusSchemaInstanceReference class methodsFor: 'instance creation' stamp: 'apl 3/14/2006 08:59'!
owner: aReference schemaInstanceNamed: key 
	| newRef |
	newRef := self schemaInstanceNamed: key.
	aReference insertReference: newRef.
	^ newRef! !

!PlatypusSchemaInstanceReference class methodsFor: 'instance creation' stamp: 'apl 3/14/2006 08:37'!
schemaInstance: aSchemaInstance 
	^ self new schemaInstance: aSchemaInstance! !

!PlatypusSchemaInstanceReference class methodsFor: 'instance creation' stamp: 'apl 3/15/2006 10:59'!
schemaInstanceClass
	^ PltSchemaInstance! !

!PlatypusSchemaInstanceReference class methodsFor: 'instance creation' stamp: 'apl 3/26/2007 17:40'!
schemaInstanceNamed: aString 
	| schemaInstance |
	schemaInstance := self schemaInstanceClass new.
	schemaInstance setName: aString.
	^ self schemaInstance: schemaInstance! !

!PlatypusSchemaInstanceReference class methodsFor: 'scripting' stamp: 'apl 3/12/2007 11:52'!
schemaInstanceReferenceNamed: anIdent acceptFromFileNamed: aFileName 
	| candidats schi str |
	candidats := PlatypusSchemaInstanceReference allSchemaInstanceReferencesNamed: anIdent.
	candidats size ~= 1
		ifTrue: [candidats size > 1
				ifTrue: [self inform: 'More than one schema instance named <<' , anIdent , '>> are present. Sorry'.
					^ nil]
				ifFalse: [self inform: 'No schema instance named <<' , anIdent , '>> is present. Sorry'. ^ nil]].
	schi := candidats anyOne.
	[str := StandardFileStream readOnlyFileNamed: aFileName]
		on: FileStreamException
		do: [self inform: 'No file named <<' , aFileName , '>>. Sorry'. ^ nil].
	[schi
		accept: (PlatypusStepTokenPrettyPrinter prettyPrint: str contents)
		notifying: nil]
		ensure: [str close].
	schi checksAll.
	^ schi! !

!PlatypusSchemaInstanceReference class methodsFor: 'accessing' stamp: 'apl 10/27/2006 10:29'!
selectSchemaReferences: aBlock 
	^ self allSchemaReferences 
		select: aBlock! !

!PlatypusSchemaInstanceReference class methodsFor: 'file list services' stamp: 'apl 3/2/2007 12:14'!
serviceNewPlatypusModelFromFile
	^ (SimpleServiceEntry
		provider: self
		label: 'import into Platypus'
		selector: #addReferenceToFromFileListTaxonFromFilenamed:
		description: 'import the express model into Platypus'
		buttonLabel: 'import into Platypus')
		argumentGetter: [:fileList | fileList fullName]! !

!PlatypusSchemaInstanceReference class methodsFor: 'menus' stamp: 'apl 3/14/2006 14:20'!
subMenuLabel
	^ 'an Express model  '! !

!PlatypusSchemaInstanceReference methodsFor: 'drag and drop' stamp: 'apl 11/2/2006 09:22'!
acceptDroppingMorph: aTransfertMorph copy: shouldCopy 
	(aTransfertMorph respondsTo: #passenger) ifFalse: [^ false].
	((aTransfertMorph passenger isKindOf: PlatypusSchemaReference) 
		or: [aTransfertMorph passenger isKindOf: PlatypusSchemaInstanceReference]) 
			ifFalse: [^ false].
	^ self insertLinkableListItemFromTransfertMorph: aTransfertMorph
		copy: shouldCopy! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 3/23/2006 11:49'!
addModelContentsReference: newRef 
	| modelContents |
	modelContents := newRef modelContents.
	self schemaInstance addModelContents: modelContents.
	newRef owner: self.
	modelContents tamarisItemRef: newRef.
	self modelContentsReferences add: newRef.
	TamManager changed: self.
	^ newRef! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/1/2006 15:43'!
addingStartNode
	^ nil! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 4/10/2006 17:10'!
canBeExpressTranslater
	^ self platypusInternalMetaSchemaInstanceReference metaData schemata
		anySatisfy: [:sch | self metaData externalSchemata
				anySatisfy: [:mySch| mySch  = sch ]]! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'AlainPlantec 5/2/2012 14:59'!
checks
	self class initializePlatypusMetaSchemataIfNeeded.
	^ super checks! !

!PlatypusSchemaInstanceReference methodsFor: 'data checking' stamp: 'apl 7/22/2004 04:02'!
checksMetaData
	^ self schemaInstance checksMetaData! !

!PlatypusSchemaInstanceReference methodsFor: 'data checking' stamp: 'apl 7/22/2004 04:03'!
checksMetaDataAndExplore
	(self checksMetaData) explore! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 4/8/2006 10:36'!
children
	| schemata superChildren |
	((superChildren := super children)
	 anySatisfy: [:ref | ref  isKindOf: PlatypusSchemaReference]) ifFalse: [
	schemata := self subReferences
				select: [:sr | sr isKindOf: PlatypusSchemaReference]]
	ifTrue: [schemata := OrderedCollection new].
	^ schemata , superChildren
		, (self modelContentsReferences
				ifNil: [#()])! !

!PlatypusSchemaInstanceReference methodsFor: 'code accessing' stamp: 'apl 4/6/2006 19:42'!
codeStreamClassFor: aTokenList from: aStartNode to: aSopNode 
	^ super
		codeStreamClassFor: aTokenList
		from: aStartNode
		to: aSopNode! !

!PlatypusSchemaInstanceReference methodsFor: 'copying' stamp: 'apl 3/14/2006 09:29'!
copy
	| copy codeText |
	copy := super copy.
	self isReleased
		ifFalse: [copy := self class schemaInstanceNamed: self schemaInstance name.
			codeText := self tokenList writeOn: '' writeStream.
			copy tokenList: (PlatypusExpressScanner on: codeText readStream) buildTokenList.
			copy
				subReferences: ((self subReferences
						select: [:sr | sr isLink])
						collect: [:sr | sr copy]).
			copy subReferences
				do: [:sr | sr isLink
						ifTrue: [sr owner: copy.
							copy  schemaInstance schemata add: sr linked]].
			copy accept: self codeText notifying: nil.
			copy modelContentsReferences: OrderedCollection new.
			copy resolves.
			self modelContentsReferences
				do: [:m | m copyInside: copy]].
	^ copy! !

!PlatypusSchemaInstanceReference methodsFor: 'initialize/release' stamp: 'apl 1/25/2007 15:41'!
destroy
	self tokenList
		ifNotNil: [self tokenList destroy].
	tokenList := nil.
	schemaInstance := nil.
	modelContentsReferences
		ifNotNil: [modelContentsReferences
				do: [:mcr | mcr destroy].
			modelContentsReferences := nil].
	super destroy! !

!PlatypusSchemaInstanceReference methodsFor: 'checking' stamp: 'apl 4/3/2006 13:35'!
doInternalChecking
	super doInternalChecking.
	self assert: modelContentsReferences notNil.
	self knownAsInvalid
		ifFalse: [self subReferences
				do: [:sr | 
					self
						assert: (self metaData schemataLinkedMetaData
								anySatisfy: [:lmd | lmd = sr metaData]).
					sr doInternalChecking].
			self metaData schemataLinkedMetaData
				do: [:lmd | self
						assert: (self subReferences
								anySatisfy: [:sr | lmd = sr metaData])]].
	modelContentsReferences
		do: [:mcr | self assert: mcr metaData owner = self metaData].
	modelContentsReferences
		do: [:mcr | 
			self assert: mcr owner = self.
			mcr doInternalChecking]! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/31/2006 08:23'!
expressParserClassName
	^ #PlatypusExpressParser! !

!PlatypusSchemaInstanceReference methodsFor: 'code accessing' stamp: 'apl 5/28/2004 11:09'!
fullCodeString
	| stream |
	stream := String new writeStream.
	self subReferences
		do: [:ref | ref linked codeTextWithStream: stream].
	^ stream contents! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 3/29/2006 19:24'!
haveMetaSchemata
	^ self metaData notNil
					and: [self metaData haveMetaSchemata]! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 9/20/2007 13:33'!
icon
	^ self usePlatypusPrimitiveSchema
		ifTrue: [TamIcons mimeIcon: '10x10/mimetypes/package_yellow']
		ifFalse: [self haveMetaSchemata
				ifTrue: [TamIcons mimeIcon: '10x10/mimetypes/package_mapping']
				ifFalse: [TamIcons mimeIcon: '10x10/mimetypes/package_blue']]! !

!PlatypusSchemaInstanceReference methodsFor: 'initialize/release' stamp: 'apl 4/8/2006 10:42'!
initialize
	tokenList := PlatypusTokenList new.
	modelContentsReferences := OrderedCollection new.
	self showSubLists: #always.
	super initialize! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 11/2/2006 09:16'!
insertLinkReferenceFrom: aReference 
	| link linkRef |
	(aReference isKindOf: PlatypusExpressReference) ifFalse: [^ false].
	aReference isSchemaInstanceReference 
		ifTrue: 
			[aReference internalSchemaReferences 
				do: [:sr | self insertLinkReferenceFrom: sr ]]
		ifFalse: 
			[aReference isSchemaReference 
				ifTrue: 
					[self metaData 
						insertElement: (link := PlatypusSchemaWrapper linked: aReference).
					self subReferences 
						add: (linkRef := PlatypusSchemaLinkReference from: link).
					linkRef owner: self.
					PlatypusExpressCodeHolder changed: self]]! !

!PlatypusSchemaInstanceReference methodsFor: 'drag and drop' stamp: 'apl 11/2/2006 09:19'!
insertLinkableListItemFromTransfertMorph: aTransfertMorph copy: shouldCopy 
	| |
	shouldCopy ifTrue: [self copyListItemHereFromTransfertMorph: aTransfertMorph]
	ifFalse: [self linkListItemHereFromTransfertMorph: aTransfertMorph]
! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 10/26/2006 19:06'!
insertReference: anotherReference 
	| parserResult code |
	((anotherReference isKindOf: PlatypusExpressReference) 
		and: [anotherReference isSchemaReference]) 
			ifFalse: [^ super insertReference: anotherReference].
	anotherReference schemaInstance == self schemaInstance ifTrue: [^ false].
	code := anotherReference codeString.
	parserResult := anotherReference expressParserClass 
				parse: code
				startingAt: anotherReference smaCCStartingState
				owner: self metaData
				onError: [:aString :position | position].
	self addWithParserResult: parserResult.
	PlatypusExpressCodeHolder changed: self.
	^ true! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 10/26/2006 19:07'!
internalSchemaReferences
	^ self schemaReferences select: [:chld | chld metaData isLink not]! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 10/26/2006 18:55'!
internalSchemata
	^ self metaData internalSchemata! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 11/14/2003 11:41'!
isCopyable 
	^ true! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 10/26/2006 19:03'!
isMetaSchemaInstanceReference
	^ self owner = TamManager platypusMetaDefaultTaxon! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 11/14/2003 11:42'!
isMoveable
	^ true! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 10/26/2006 19:02'!
isSchemaInstanceReference
	^ true! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 5/2/2012 12:55'!
keyStroke: aCharacter from: aListMorph 
	super keyStroke: aCharacter from: aListMorph.
	aCharacter = $n
		ifTrue: [^ self menuNewSchema].
	aCharacter = $m
		ifTrue: [^ self storeAsMetaData].
! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'AlainPlantec 3/11/2010 16:11'!
knownAsInvalid 
	| oldValidationResult |
	^ super knownAsInvalid
				or: [
					(oldValidationResult := self metaData validationResult) isNil
						or: [oldValidationResult not
						or: [self metaData validationDate isNil
						or: [self metaData changeDate isNil
						or: [(DateAndTime fromString: self metaData validationDate)
								< (DateAndTime fromString: self metaData changeDate)]]]]]! !

!PlatypusSchemaInstanceReference methodsFor: 'drag and drop' stamp: 'apl 7/5/2004 15:07'!
linkListItemHereFromTransfertMorph: aTransfertMorph 
	self insertLinkReferenceFrom: aTransfertMorph passenger! !

!PlatypusSchemaInstanceReference methodsFor: 'sublists handling' stamp: 'apl 4/6/2006 20:33'!
linksReferences
	^ self subReferencesOfKind: PlatypusSchemaLinkReference! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/31/2006 08:39'!
lookUpIdentifierBN: anIdent 
	^ self metaData lookUpIdentifierBN: anIdent ! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/31/2006 08:40'!
lookUpNamedTypeBN: anIdent 
	^ self metaData lookUpNamedTypeBN: anIdent! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'AlainPlantec 4/12/2011 12:59'!
masterModelAsStepStream
	^ self schemaInstance masterModelAsStepStream! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 09:30'!
menuCopyAs
	| parsingResult key newRef code |
	key := UIManager default request: 'internal key ' initialAnswer: self shortName.
	key > ''
		ifTrue: [newRef := self class schemaInstanceNamed: self name.
			code := self codeString.
			parsingResult := self expressParserClass parseStream: code readStream owner: self metaData.
			newRef takeParserResult: parsingResult.
			self owner insertReference: newRef]! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 09:10'!
menuForceTranslaterPrefix
	(UIManager default request: 'class and system category prefix ?' initialAnswer: self metaData translaterClassPrefix)
		ifNotNil: [:prefix | self metaData mySchemaInstance namesBuilderPrefixedBy: prefix trimBoth] ! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 12/2/2010 18:10'!
menuMetaDataToStepFile
	| result |
	result := UITheme current 
		fileSaveIn: World
		title: 'Meta data file name'
		extensions: #('step')
		path: ''.
	result ifNotNil: [[self metaDataToStream: result] ensure: [result close]]! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'apl 11/7/2003 13:10'!
menuNewModelContents
	self newModelContents! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 9/8/2010 11:46'!
menuNewSchema
	| key parsingResult source |
	(key := UIManager default  request: 'Schema name?' initialAnswer: '')
		ifNotEmpty: [:e | 
			source := ('schema ' , key , ';\\end_schema;') withCRs.
			parsingResult := self expressParserClass
						parse: source
						startingAt: self expressParserClass startingStateForSchemaEntry
						owner: self metaData
						onError: [:aString :position | position].
			self addWithParserResult: parsingResult.
			PlatypusExpressCodeHolder changed: self]! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 10:50'!
menuSetTranslaterClassPrefix
	(UIManager default request: 'Translated class prefix?' initialAnswer: self metaData translaterClassPrefix)
		ifNotNil: [:prefix | self metaData translaterClassPrefix: prefix trimBoth] ! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 10:50'!
menuSetTranslaterRootClassName
	| name |
	(name := UIManager default request: 'Translated root class name?'
				initialAnswer: self metaData translaterRootClassName) 
			ifNotEmpty: [:e | self metaData translaterRootClassName: name trimBoth]! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 10:50'!
menuSetTranslaterRootClassSystemCategory
	| name |
	(name := UIManager default request: 'Translated root class system category?'
				initialAnswer: self metaData translaterRootClassSystemCategory) 
			ifNotEmpty: [:e | self metaData translaterRootClassSystemCategory: name trimBoth]! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 10:50'!
menuSetTranslaterSystemCategoryPrefix
	| prefix |
	(prefix := UIManager default request: 'Translated system categories prefix?'
				initialAnswer: self metaData translaterSystemCategoryPrefix) 
			ifNotEmpty: [:e | self metaData translaterSystemCategoryPrefix: prefix trimBoth]! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 09:30'!
metaData
	^ self schemaInstance! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'MrCleaner 1/17/2011 22:21'!
metaDataStream
	^ self metaData metaDataStream! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'apl 3/10/2007 09:23'!
metaDataToStepFile: aFileName 
	self metaData metaDataToStepFile: aFileName! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'apl 3/10/2007 09:27'!
metaDataToStream: aStream 
	self metaData metaDataToStream: aStream! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 11/7/2003 12:14'!
modelContentsReferences
	^ modelContentsReferences! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 11/14/2003 11:08'!
modelContentsReferences: aCollection
	modelContentsReferences := aCollection! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 5/12/2004 11:23'!
moveDownReference: aReference 
	^ aReference moveDown! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 7/5/2004 16:53'!
moveDownSchemaReference: aReference 
	| index |
	index := self subReferences indexOf: aReference.
	index < self subReferences size
		ifTrue: [self subReferences swap: index with: index + 1.
			TamManager changed: self.
			^ true].
	^ false! !

!PlatypusSchemaInstanceReference methodsFor: 'drag and drop' stamp: 'apl 3/12/2004 17:26'!
moveListItemHereFromTransfertMorph: aTransfertMorph 
	(self copyListItemHereFromTransfertMorph: aTransfertMorph)
		ifTrue: [aTransfertMorph passenger remove.
			^ true].
	^ false! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 5/12/2004 11:22'!
moveUpReference: aReference 
	| |
	^ aReference moveUp
! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 7/5/2004 16:53'!
moveUpSchemaReference: aReference 
	| index |
	index := self subReferences indexOf: aReference.
	index > 1
		ifTrue: [self subReferences swap: index with: index - 1.
			TamManager changed: self.
			^ true].
	^ false! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 08:47'!
name
	^ schemaInstance name! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'AlainPlantec 5/10/2012 22:11'!
newModelContents
	| modelContents newRef |
	modelContents := PltModelContents new owner: self schemaInstance.
	newRef := PlatypusModelContentsReference new modelContents: modelContents.
	^ self addModelContentsReference: newRef! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/13/2006 14:56'!
platypusInternalMetaSchemaInstanceReference
	^ PlatypusInternalMetaSchemaInstanceReference expressMetaDictionary! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 1/28/2011 13:08'!
promote: aMetaModelSchemaInstanceReference 
	aMetaModelSchemaInstanceReference storeAsMetaDataOf: self! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 3/16/2006 11:20'!
relabelWith: newName 
	| metaData |
	metaData := self metaData.
	metaData renameWith: newName.
	PlatypusExpressCodeHolder changed: self! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 3/12/2007 14:38'!
removeAllModelContents
self 
removeAllModelContentsOf: self modelContentsReferences 
! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 9/7/2006 14:40'!
removeAllModelContentsOf: aListOfModelContentsRef 
	| modelContents |
	aListOfModelContentsRef
		do: [:modelContentsRef | 
			modelContents := modelContentsRef modelContents.
			modelContents
				ifNotNil: [modelContents removeFromOwner].
			self modelContentsReferences
				ifNotNil: [self modelContentsReferences remove: modelContentsRef ifAbsent: []].
			modelContentsRef destroy.
			modelContents
				ifNotNil: [modelContents deepDestroy]]! !

!PlatypusSchemaInstanceReference methodsFor: 'updating' stamp: 'apl 3/22/2006 14:36'!
removeSilently
	| |
	self logToChangesRemoving: self oldCodeText: self codeText.
	super removeSilently! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 3/29/2006 14:11'!
replaceMetaDataWith: aMetaData 
	| keptName keptExternalLinks keptModelContentsReferences |
	keptModelContentsReferences := self modelContentsReferences.
	self modelContentsReferences: OrderedCollection new.
	keptName := self metaData name.
	keptExternalLinks := self metaData externalSchemaLinks.
	self metaData fastSetAssociatedModels: nil.
	self metaData deepDestroy.
	self metaData stepInitialize.
	self metaData name: keptName.
	keptModelContentsReferences
		do: [:ref | self addModelContentsReference: ref].
	aMetaData moveInto: self metaData.
	self metaData externalSchemaLinks: keptExternalLinks.
	self metaData tamarisItemRef: self! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/25/2007 15:42'!
rootMessages
	^ self metaData mySchemaInstance rootMessages! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/25/2007 15:42'!
rootMessages: aListOfErrorMessages 
		self metaData mySchemaInstance rootMessages: aListOfErrorMessages! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/20/2007 15:50'!
rootSourceHandler
	^ self ! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 08:52'!
schemaInstance
	^ schemaInstance! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/23/2006 12:16'!
schemaInstance: anObject 
	schemaInstance := anObject.
	self accept: '' notifying: nil! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 09:37'!
schemaInstanceReference
	^ self! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 10/26/2006 19:11'!
schemaReferences
	^ self children select: [:chld | chld isLink not and: [chld isSchemaReference]]! !

!PlatypusSchemaInstanceReference methodsFor: 'sublists handling' stamp: 'apl 4/6/2006 20:33'!
schemataReferences
	^ self subReferencesOfKind: PlatypusSchemaReference! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/15/2004 12:12'!
shortName
	| mdt |
	^ (mdt := self metaData) ifNil: ['???'] ifNotNil: [mdt name]
! !

!PlatypusSchemaInstanceReference methodsFor: 'sublists handling' stamp: 'apl 4/8/2006 10:36'!
showSubLists
	^  super showSubLists! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'AlainPlantec 1/28/2011 06:18'!
showsAsChecked
	self emphasisModel: nil.
	self changed: #contents! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 2/5/2007 10:19'!
showsAsToBeChecked
	self emphasisModel: TamListItemMorphEmphasisModel redStandard.
	PlatypusExpressResolver new unresolves: self metaData.
	self showsUsersAsToBeChecked! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 2/5/2007 10:19'!
showsUsersAsToBeChecked
	self allUsers
		do: [:u | u emphasisModel: TamListItemMorphEmphasisModel redStandard]! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 1/31/2006 08:27'!
smaCCStartingState
	^ self expressParserClass startingStateForSchemaInstanceEntry! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/27/2012 09:06'!
specificMenu: menu shifted: b 
	| menuExpress arr |
	super specificMenu: menu shifted: b.
	menu addLine.
	menuExpress := MenuMorph new.
	arr := #(#- #('new schema (n)' #menuNewSchema) #('copy as...' #menuCopyAs) #- #('save... (s)' #menuSave) #('save as... (S)' #menuSaveAs) #- #('code pane (p)' #menuCodePane) #- #('new model contents' #menuNewModelContents) #- #('write meta-data to file' #menuMetaDataToStepFile) #('promote (m)' #storeAsMetaData) #('checks meta data' #checksMetaDataAndExplore) #- ) asOrderedCollection.
	self isMetaSchemaInstanceReference
		ifFalse: [arr addAll: #(#- #('force translater prefix' #menuForceTranslaterPrefix) #- #('set translater class prefix' #menuSetTranslaterClassPrefix) #('set translater system categories prefix' #menuSetTranslaterSystemCategoryPrefix) #('set translater root class name' #menuSetTranslaterRootClassName) #('set translater root class system category' #menuSetTranslaterRootClassSystemCategory) #- )].
	arr addAll: #(#('translate here (t)' #menuTranslate2Pharo)  #('translate and compile (T)' #translateAndFileItIn) #- #('translate to VisualWorks' #menuTranslate2VisualWorks) ).
	arr
		do: [:item | item == #-
				ifTrue: [menuExpress addLine]
				ifFalse: [menuExpress
						add: item first
						target: self
						selector: item second]].
	self generatedSystemCategoryExists
		ifTrue: [menuExpress
				add: 'generated code'
				target: self
				selector: #insertGeneratedCodeTaxon].
	menu
		add: 'express ...'
		subMenu: menuExpress
		target: self
		selector: nil
		argumentList: #().
	^ menu! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/19/2003 15:49'!
startNode
	^ self tokenList first! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 21:28'!
startNode: aNode 
	^ self! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/15/2006 15:12'!
stopNode
	^ self tokenList last! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 21:07'!
stopNode: aNode! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/14/2011 09:58'!
storeAsMetaData
	Cursor wait
		showWhile: [self class
				chooseExpressTranslaterForClient: nil
				selectingBlock: [:hierarList :chosen | 
					hierarList close.
					chosen promote: self]]! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'apl 3/12/2007 13:39'!
storeAsMetaDataHere
	Cursor wait
		showWhile: [self storeAsMetaDataOf: self]! !

!PlatypusSchemaInstanceReference methodsFor: 'menus' stamp: 'AlainPlantec 4/14/2011 09:58'!
storeAsMetaDataOf: aMetaModelSchemaInstanceReference 
	| newModelContents |
	Cursor wait
		showWhile: [ 
			aMetaModelSchemaInstanceReference removeAllModelContents.
			newModelContents := aMetaModelSchemaInstanceReference newModelContents.
			newModelContents parseMetaStepStream: self metaDataStream.
			newModelContents resolvesMetaConceptDefinitions.
			newModelContents resolvesMetaMappingDefinitions.
			aMetaModelSchemaInstanceReference checks ]! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/14/2006 20:54'!
subElementSymbols
	^ Array with: PlatypusSchemaReference lexicalElement! !

!PlatypusSchemaInstanceReference methodsFor: 'sublists handling' stamp: 'apl 4/6/2006 20:58'!
subListsDefsArray
	"return an array of array. Each element array is for one sublist and 
	contains first a selector for sublist accessing and second a label
	for the sublist"
	| subs |
	subs := OrderedCollection new.
	subs addAll: super subListsDefsArray.
	subs addAll: #(#(#linksReferences #externals) ).
	^ subs! !

!PlatypusSchemaInstanceReference methodsFor: 'sublists handling' stamp: 'apl 4/6/2006 20:32'!
subListsReferenceClassName
	^ #PlatypusExpressSubListReference! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 2/14/2006 22:11'!
subReferencesScanStart
	^ self startNode! !

!PlatypusSchemaInstanceReference methodsFor: 'code updating' stamp: 'apl 3/23/2006 09:24'!
takeParserResult: aParserResult 
	^ self replaceWithParserResult: aParserResult! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 08:52'!
tokenList
	^ tokenList! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 08:51'!
tokenList: aTokenList
	tokenList := aTokenList! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'AlainPlantec 7/14/2011 17:50'!
translaterForPharo
	^ PlatypusToPharoTranslater new! !

!PlatypusSchemaInstanceReference methodsFor: 'accessing' stamp: 'apl 2/15/2007 15:56'!
translaterForVisualWorks
	^ PlatypusToVisualWorksTranslater new! !

!PlatypusSchemaInstanceReference methodsFor: 'testing' stamp: 'apl 3/29/2006 19:23'!
usePlatypusPrimitiveSchema
	^ self metaData notNil
			and: [self metaData usePlatypusPrimitiveSchema]! !

!PlatypusListItemReference class methodsFor: 'menu' stamp: 'apl 2/19/2006 21:56'!
subMenuLabel
	^nil! !

!PlatypusListItemReference methodsFor: 'updating' stamp: 'AlainPlantec 5/8/2012 21:12'!
cleanAllEvaluations
	self children
		do: [:chl | chl  cleanAllEvaluations].
	self linked reinitializeEvaluatedContents! !

!PlatypusListItemReference methodsFor: 'accessing' stamp: 'apl 6/23/2004 18:44'!
codeText
	^ self codeString! !

!PlatypusListItemReference methodsFor: 'accessing' stamp: 'AlainPlantec 4/26/2012 09:00'!
expressParserClass
	^ SmalltalkImage  current classNamed: self expressParserClassName asSymbol! !

!PlatypusListItemReference methodsFor: 'accessing' stamp: 'apl 1/31/2006 08:23'!
expressParserClassName
	^ self rootDictionaryReference expressParserClassName! !

!PlatypusListItemReference methodsFor: 'updating' stamp: 'apl 3/24/2006 09:24'!
isInSubTreeOf: anotherReference
	self = anotherReference ifTrue: [^ true].(self owner isKindOf: PlatypusListItemReference) ifFalse: [^ false].
	^ self owner  isInSubTreeOf: anotherReference.
! !

!PlatypusListItemReference methodsFor: 'menus' stamp: 'apl 4/5/2006 18:52'!
keyStroke: aCharacter from: aListMorph 
	super keyStroke: aCharacter from: aListMorph.
	aCharacter = $p
		ifTrue: [^ self menuCodePane].
! !

!PlatypusListItemReference methodsFor: 'testing' stamp: 'apl 4/3/2006 13:35'!
knownAsInvalid
	^ self emphasisModel notNil! !

!PlatypusListItemReference methodsFor: 'menus' stamp: 'apl 4/5/2006 18:52'!
menuCodePane
	| codePane |
	codePane := self editorClass new sourceHandler: self.
	codePane buildMainWindow.
	^ codePane openAsMorph! !

!PlatypusListItemReference methodsFor: 'initialize/release' stamp: 'apl 6/8/2004 16:36'!
reinitialize
! !

!PlatypusListItemReference methodsFor: 'updating' stamp: 'apl 6/8/2004 19:13'!
reinitializeEvaluatedContents
! !

!PlatypusListItemReference methodsFor: 'accessing' stamp: 'apl 3/8/2006 11:15'!
rootDictionaryReference
	^ self rootSourceHandler! !

!PlatypusListItemReference methodsFor: 'accessing' stamp: 'apl 3/20/2007 15:49'!
rootSourceHandler
	^ self owner rootSourceHandler! !

PlatypusListItemReference subclass: #PlatypusStepReference
	instanceVariableNames: 'pos subReferences useP21Syntax attrOrRuleOrValue codeCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusStepReference subclass: #PlatypusModelContentsReference
	instanceVariableNames: 'modelContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusModelContentsReference class methodsFor: 'menus' stamp: 'apl 3/2/2007 12:05'!
addPlatypusModelContentsFromFilenamed: aFilename 
	PlatypusSchemaInstanceReference
		chooseSchemaInstanceForClient: nil
		selectingBlock: [:hierarList :chosen | 
			hierarList close.
			chosen newModelContents  listLabel: aFilename; stepFileIn: aFilename]! !

!PlatypusModelContentsReference class methodsFor: 'menus' stamp: 'apl 4/8/2004 17:39'!
canBeCreatedInteractively
	^ false! !

!PlatypusModelContentsReference class methodsFor: 'accessing' stamp: 'apl 11/7/2003 09:47'!
externalLabel
	^ 'a STEP model content'! !

!PlatypusModelContentsReference class methodsFor: 'file list services' stamp: 'apl 3/2/2007 12:10'!
fileReaderServicesForFile: fullName suffix: suffix 
	^ (suffix = 'step'
			or: [suffix = 'p21' or: [suffix = 'stp']])
		ifTrue: [Array with: self serviceNewPlatypusModelContentsFromFile]
		ifFalse: [#()]! !

!PlatypusModelContentsReference class methodsFor: 'class initialization' stamp: 'apl 3/2/2007 12:01'!
initialize
	"register the receiver in the global registries"
	self environment
		at: #FileList
		ifPresent: [:cl | cl registerFileReader: self]! !

!PlatypusModelContentsReference class methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 09:30'!
menuAddReferenceIntoOwner: aReference 
	| key oldDict |
	key := UIManager default request: 'schema instance name' initialAnswer: ''.
	key notEmpty
		ifTrue: [oldDict := aReference taxonomyRoot
						findDeeplySuchThat: [:r | (r isKindOf: PlatypusSchemaInstanceReference)
								and: [r  schemaInstance name asUppercase = key asUppercase]].
			oldDict
				ifNotNil: [oldDict menuNewModelContents]]! !

!PlatypusModelContentsReference class methodsFor: 'file list services' stamp: 'apl 3/2/2007 12:13'!
serviceNewPlatypusModelContentsFromFile
	^ (SimpleServiceEntry
		provider: self
		label: 'import into Platypus'
		selector: #addPlatypusModelContentsFromFilenamed:
		description: 'import the step data into a Platypus model contents'
		buttonLabel: 'import into Platypus')
		argumentGetter: [:fileList | fileList fullName]! !

!PlatypusModelContentsReference class methodsFor: 'menus' stamp: 'apl 3/17/2004 17:25'!
subMenuLabel
	^ 'STEP/EXPRESS'! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'AlainPlantec 5/10/2012 22:52'!
accept: input notifying: aRequestor 
	| stream |
	stream := ReadStream on: input.
			self
				parseStepStream: stream
				startingAt: self parserStartingState
				onError: [:d :l | 
					aRequestor
						ifNil: [self notify: d at: l]
						ifNotNil: [aRequestor notify: d at: l].
					^ false].
	^ true! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/11/2006 09:33'!
add: new 
	self modelContents add: new.
	self addReferenceFor: new! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'AlainPlantec 5/8/2012 16:29'!
addReferenceFor: anEntityInstance 
	self subReferences
		add: (anEntityInstance tamarisStepValueReferenceClass
				owner: self
				position: (self modelContents indexOf: anEntityInstance))! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 6/25/2004 23:13'!
at: position
	^self modelContents at: position! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/11/2006 09:33'!
at: position put: new 
	| old |
	new isPltGenericInstance
		ifTrue: [old := self at: position.
			new persistentLabel = old persistentLabel
				ifTrue: [self modelContents at: position put: new.
					self checks]
				ifFalse: [self add: new]]! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 12/22/2006 15:50'!
buildDataInstancesIndexes
	^ self modelContents buildDataInstancesIndexes! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/31/2006 17:22'!
buildSubReferences
	| instances inst |
	self removeSubReferences.
	subReferences := OrderedCollection new.
	(instances := self modelContents dataInstances)
		ifNotNil: [1
				to: instances size
				do: [:p | (inst := instances at: p)
						ifNotNil: [subReferences
								add: (inst tamarisStepValueReferenceClass owner: self position: p)]].
			TamManager changed: self]! !

!PlatypusModelContentsReference methodsFor: 'testing' stamp: 'apl 3/17/2006 22:45'!
canHaveCachedEditor
	"if true, my editor will be cached by the browser so that next editing 
	will reuse cached editor"
	^ true! !

!PlatypusModelContentsReference methodsFor: 'checking' stamp: 'AlainPlantec 1/28/2011 06:09'!
checks
	| r |
	r := self modelContents checks.
	r
		ifTrue: [self showsAsChecked]
		ifFalse: [self showsAsToBeChecked].
	^ r ! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'AlainPlantec 5/10/2012 22:31'!
codeText: p21Syntax 
	| stream |
	Cursor wait
		showWhile: [stream := WriteStream on: String new.
			PlatypusModelContentsStepWriter new
				stream: stream
				modelContents: self modelContents
				values: self modelContents dataInstances 
				p21Syntax: p21Syntax].
	^ stream contents! !

!PlatypusModelContentsReference methodsFor: 'copying' stamp: 'AlainPlantec 5/3/2012 09:38'!
copyInside: aSchemaInstanceReference 
	| cpy refCpy tmpFileName tmpStream |
	cpy := PltModelContents new owner: aSchemaInstanceReference schemaInstance.
	refCpy := self class new modelContents: cpy.
	aSchemaInstanceReference addModelContentsReference: refCpy.
	tmpFileName := FileDirectory default fullNameFor: 'platypus_tmp.step'.
	[FileDirectory deleteFilePath: tmpFileName]
		on: Error
		do: [:ex | ex].
	[tmpStream := (Filename named: tmpFileName) writeStream.
	self stepWriteIntoStream: tmpStream]
		ensure: [tmpStream close].
	refCpy stepFileIn: tmpFileName.
	refCpy checks.
	^ refCpy! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 11/13/2003 17:04'!
dataInstances
	^ self modelContents dataInstances! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 17:13'!
dataInstances: aCollection 
	self modelContents dataInstances: aCollection.
	self removeSubReferences! !

!PlatypusModelContentsReference methodsFor: 'initialize/release' stamp: 'apl 6/3/2005 16:48'!
destroy
	modelContents := nil.
	super destroy! !

!PlatypusModelContentsReference methodsFor: 'checking' stamp: 'apl 3/28/2006 21:39'!
doInternalChecking
	super doInternalChecking.
	self assert: self metaData owner = self owner metaData! !

!PlatypusModelContentsReference methodsFor: 'testing' stamp: 'apl 4/4/2006 13:18'!
haveMetaConceptDefinitions
	^ self modelContents notNil and: [self modelContents haveMetaConceptDefinitions]! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 11/13/2003 17:04'!
headerInstances
	^ self modelContents headerInstances! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 11/13/2003 17:01'!
headerInstances: aCollection 
	self modelContents headerInstances: aCollection! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 5/8/2005 08:29'!
icon
	^TamIcons mimeIcon: '10x10/mimetypes/blue_file'! !

!PlatypusModelContentsReference methodsFor: 'testing' stamp: 'apl 11/14/2003 11:43'!
isCopyable
	^ false! !

!PlatypusModelContentsReference methodsFor: 'testing' stamp: 'apl 4/4/2006 14:03'!
isModelContentsReference
	^ true! !

!PlatypusModelContentsReference methodsFor: 'testing' stamp: 'apl 3/21/2006 15:57'!
isPltValue
	^ false! !

!PlatypusModelContentsReference methodsFor: 'testing' stamp: 'apl 3/31/2006 13:13'!
isRemoveable
	^ true! !

!PlatypusModelContentsReference methodsFor: 'testing' stamp: 'apl 10/26/2006 19:12'!
isSchemaReference 
^ false! !

!PlatypusModelContentsReference methodsFor: 'menus' stamp: 'AlainPlantec 5/8/2012 12:40'!
menuDoNotRecordComputedInstances
	self recordComputedInstances: false! !

!PlatypusModelContentsReference methodsFor: 'menus' stamp: 'AlainPlantec 4/26/2012 11:14'!
menuParseStepFile
	| result |
	(result := UIManager default
		chooseFullFileNameMatching: nil
		label: 'Choose a STEP file')
		ifNotNil: [self stepFileIn: result.
			self listLabel: result name.
			TamManager changed: self.
			].
	^ false! !

!PlatypusModelContentsReference methodsFor: 'menus' stamp: 'AlainPlantec 5/8/2012 12:40'!
menuRecordComputedInstances
	self recordComputedInstances: true! !

!PlatypusModelContentsReference methodsFor: 'menus' stamp: 'AlainPlantec 1/28/2011 14:09'!
menuStepWrite
	| stream result  |
	stream := UITheme current 
		fileSaveIn: World
		title: 'File name'
		extensions: #('step')
		path: ''.
	stream
		ifNotNil: [
			[result := self stepWriteIntoStream: stream useP21Syntax: useP21Syntax]
				ensure: [stream close].
			self listLabel: stream name.
			TamManager changed: self].
	^ result! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 7/22/2004 12:43'!
metaData
	^ self modelContents! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 11/7/2003 09:55'!
modelContents
	^ modelContents! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 11/7/2003 09:56'!
modelContents: aModelContents
	modelContents := aModelContents! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 6/3/2004 13:10'!
modelContentsReference
	^ self! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 3/12/2007 14:14'!
newEditor
	| editor |
	editor := self editorClass new.
	editor buildTamarisWindow.
		editor sourceHandler: nil.
	editor sourceHandler: self.

	editor messagesBrowser
		ifNotNil: [editor updateMessagesBrowser].
	^ editor mainWindow! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 5/29/2004 10:26'!
notify: error at: location in: stream 
	| window model |
	window := self newEditor.
	model := window model.
	model sourceHandlerSilently: self contents: stream contents.
	model notify: error at: location.
	window openInWorld! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'AlainPlantec 1/21/2011 12:53'!
parseMetaStepStream: aStream 
	self
		parseMetaStepStream: aStream
		onError: [:d :l | 
			self
				notify: d
				at: l
				in: aStream.
			^ false].
	^ true! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 4/4/2006 14:07'!
parseMetaStepStream: aStream onError: aBlock 
	self parseStepStream: aStream onError: aBlock.
! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/10/2005 11:23'!
parseStepStream: aStream 
	^ self parseStepStream: aStream onError:  [:d :l | 
					self
						notify: d
						at: l
						in: aStream].
! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'AlainPlantec 5/4/2012 21:54'!
parseStepStream: aStream onError: aBlock 
	| folder instancier |
	Cursor read showWhile: 
			[folder := StepGenericRepository new.
			folder parseStream: aStream
				onError: 
					[:d :l | 
					aBlock value: d value: l.
					^ nil].
			self modelContents empty.
			instancier := PlatypusRepositoryBuilder folder: folder modelContents: self modelContents.
			instancier doFolder.
			self modelContents changeDate: DateAndTime now asString.
			self buildSubReferences.
			self buildDataInstancesIndexes.
			self checks.
			PlatypusStepModelContentsCodeHolder changed: self]! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'AlainPlantec 5/10/2012 22:57'!
parseStepStream: aStream startingAt: startingState onError: aBlock 
	| folder instancier |
	Cursor read showWhile: 
			[folder := StepGenericRepository new.
			folder 
				parseDataStream: aStream
				onError: 
					[:d :l | 
					aBlock value: d value: l.
					^ nil].
			self modelContents empty.
			instancier := PlatypusRepositoryBuilder folder: folder modelContents: self modelContents.
			instancier doFolder.
			self modelContents changeDate: DateAndTime now asString.
			self buildSubReferences.
			self buildDataInstancesIndexes.
			self checks.
			PlatypusStepModelContentsCodeHolder changed: self]! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'AlainPlantec 5/10/2012 22:48'!
parserStartingState
	^ StepParser startingStateForDataEntities! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'AlainPlantec 5/8/2012 14:03'!
recordComputedInstances
	^ self modelContents recordComputedInstances ! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'AlainPlantec 5/8/2012 14:03'!
recordComputedInstances: aBoolean
	self modelContents recordComputedInstances: aBoolean! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/31/2006 15:31'!
reinitializeLabel
	codeCache := nil.
	TamManager changed: self.
	PlatypusStepModelContentsCodeHolder changed: self! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 2/23/2005 21:59'!
relabelWith: newName 
	| fileName |
	fileName := self modelContents headerInstances
				ifNotNil: [self modelContents headerInstances
						detect: [:hi | hi isPltFileName]
						ifNone: [].
					fileName
						ifNil: [fileName := PltFileName new.
							self modelContents headerInstances add: fileName.
							fileName owningModel: self modelContents].
					fileName name: newName.
					self updateModel].
	super relabelWith: newName! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/16/2006 11:20'!
removeAt: position 
	self modelContents at: position put: nil.
	self buildSubReferences.
	PlatypusStepModelContentsCodeHolder changed: self! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'AlainPlantec 5/8/2012 18:43'!
removeComputedInstances 
	Cursor wait
		showWhile: [
				self modelContents removeComputedInstances.
				self reinitializeEditor.
				PlatypusStepModelContentsCodeHolder changed: self].! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/22/2006 14:40'!
removeSilently
	self owner
		removeAllModelContentsOf: (Array with: self).
	^ super removeSilently! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 12/22/2006 15:51'!
replaceWithParserResult: result 
	result ifNotNil: 
			[self headerInstances: result first.
			self dataInstances: result second.
			self buildDataInstancesIndexes.
			self checks.
			self buildSubReferences.
			TamManager changed: self.
			^ true].
	^ false! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 9/19/2007 12:53'!
resolvesMetaConceptDefinitions
	modelContents resolvesMetaConceptDefinitions.
	self reinitializeLabel.
	self buildSubReferences! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'AlainPlantec 1/21/2011 21:38'!
resolvesMetaMappingDefinitions
	modelContents resolvesMetaMappingRules.
	self reinitializeLabel.
	self buildSubReferences! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 11/9/2003 10:04'!
shortName
	^ listLabel
		ifNil: ['a ''' , self owner listLabel , ''' model contents']! !

!PlatypusModelContentsReference methodsFor: 'checking' stamp: 'AlainPlantec 1/28/2011 06:18'!
showsAsChecked
	self emphasisModel: nil.
	self changed: #contents
	
! !

!PlatypusModelContentsReference methodsFor: 'checking' stamp: 'AlainPlantec 1/28/2011 10:00'!
showsAsToBeChecked
	self emphasisModel: TamListItemMorphEmphasisModel redStandard.
	
! !

!PlatypusModelContentsReference methodsFor: 'menus' stamp: 'AlainPlantec 5/8/2012 17:36'!
specificMenu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring  
			the #shifted boolean"
	| myMenu |
	super specificMenu: menu shifted: b.
	menu addLine.
	myMenu := MenuMorph new.
	#(#- #('parse a step file' #menuParseStepFile) #- #('write to a step file' #menuStepWrite) #- #('remove computed instances' #removeComputedInstances))
		do: [:item | item == #-
				ifTrue: [myMenu addLine]
				ifFalse: [myMenu
						add: item first
						target: self
						selector: item second]].
	(self recordComputedInstances
		ifTrue: [#(#('do not record computed instances' #menuDoNotRecordComputedInstances) ) ]
		ifFalse: [#(#('record computed instances' #menuRecordComputedInstances) ) ])
		do: [:item | item == #-
				ifTrue: [myMenu addLine]
				ifFalse: [myMenu
						add: item first
						target: self
						selector: item second]].
	menu
		add: 'step ...' 
		subMenu: myMenu
		target: self
		selector: nil
		argumentList: #().
	^ menu
! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 4/11/2006 09:50'!
stepFileIn: aFileName 
	| stream result |
	(stream := (Filename named: aFileName) readStream)
		ifNotNil: [[result := self parseStepStream: stream]
				ensure: [stream close].
			^ result]! !

!PlatypusModelContentsReference methodsFor: 'step file writing' stamp: 'apl 3/12/2005 11:39'!
stepWriteIntoStream: aStream 
	self stepWriteIntoStream: aStream useP21Syntax: true! !

!PlatypusModelContentsReference methodsFor: 'step file writing' stamp: 'apl 3/12/2005 11:37'!
stepWriteIntoStream: aStream useP21Syntax: aBoolean
	self modelContents stepWriteIntoStream: aStream useP21Syntax: aBoolean! !

!PlatypusModelContentsReference methodsFor: 'updating' stamp: 'apl 3/23/2006 12:05'!
validationResult: aBoolean 
	self modelContents validationResult: aBoolean! !

!PlatypusModelContentsReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 13:39'!
value
	^ self modelContents! !

PlatypusStepReference subclass: #PlatypusStepAttributeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepAttributeReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 12:16'!
shortName
	^ attrOrRuleOrValue name! !

PlatypusStepAttributeReference subclass: #PlatypusStepDerivedAttributeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepDerivedAttributeReference methodsFor: 'testing' stamp: 'apl 3/31/2006 13:15'!
canEvaluate
	^ true! !

!PlatypusStepDerivedAttributeReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 11:38'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/derived_attribute'! !

PlatypusStepAttributeReference subclass: #PlatypusStepExplicitAttributeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepExplicitAttributeReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 11:39'!
icon
^ TamIcons mimeIcon: '10x10/mimetypes/explicit_attribute'! !

!PlatypusStepExplicitAttributeReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 14:29'!
value
	^ self owner at: pos! !

PlatypusStepAttributeReference subclass: #PlatypusStepInverseAttributeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepInverseAttributeReference methodsFor: 'testing' stamp: 'apl 3/31/2006 13:15'!
canEvaluate
	^ true! !

!PlatypusStepInverseAttributeReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 11:39'!
icon
^ TamIcons mimeIcon: '10x10/mimetypes/inverse_attribute'! !

PlatypusStepReference subclass: #PlatypusStepInstanceReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusStepInstanceReference subclass: #PlatypusStepExternalInstanceReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepInstanceReference methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 5/8/2012 19:04'!
icon
	^ self value isComputed 
		ifTrue: [TamIcons mimeIcon: '10x10/mimetypes/gray_sphere']
		ifFalse: [TamIcons mimeIcon: '10x10/mimetypes/green_sphere']! !

!PlatypusStepInstanceReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 14:43'!
parserStartingState
	^ StepParser startingStateForDataEntity! !

!PlatypusStepInstanceReference methodsFor: 'accessing' stamp: 'apl 4/6/2006 17:13'!
shortName
	^ self codeText asString contractTo: 100! !

PlatypusStepInstanceReference subclass: #PlatypusStepInternalInstanceReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusStepInstanceReference subclass: #PlatypusStepUnresolvedInstanceReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusStepReference subclass: #PlatypusStepRecordReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepRecordReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 15:19'!
parserStartingState
	^ StepParser startingStateForSimpleRecordEntry! !

!PlatypusStepRecordReference methodsFor: 'accessing' stamp: 'apl 4/6/2006 17:13'!
shortName
	^ self codeText asString contractTo: 100! !

!PlatypusStepRecordReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 13:41'!
value
	^ self owner at: pos! !

!PlatypusStepReference class methodsFor: 'instance creation' stamp: 'apl 6/7/2004 22:27'!
owner: anotherRef position: anInteger 
	^ self
		owner: anotherRef
		position: anInteger
		attributeOrRule: nil! !

!PlatypusStepReference class methodsFor: 'instance creation' stamp: 'apl 6/7/2004 22:29'!
owner: anotherRef position: aPosition attributeOrRule: anAttribute 
	^ self new
		owner: anotherRef
		position: aPosition
		attributeOrRule: anAttribute! !

!PlatypusStepReference class methodsFor: 'instance creation' stamp: 'apl 6/25/2004 23:27'!
owner: anotherRef position: aPosition value: aValue 
	^ self new
		owner: anotherRef
		position: aPosition
		value: aValue
! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/31/2006 13:11'!
accept: input notifying: aRequestor 
	| result stream instancier |
	Cursor wait
		showWhile: [stream := ReadStream on: input.
			result := StepParser
						parseStream: stream
						startingAt: self parserStartingState
						onError: [:aString :position | 
							aRequestor notNil
								ifTrue: [aRequestor notify: aString at: position].
							^ nil].
			instancier := PlatypusRepositoryBuilder new.
			instancier modelContents: self modelContents.
			result := instancier doSingleToken: result.
			self modelContents changeDate: DateAndTime now asString.
			^ self replaceWithParserResult: result]! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/2/2004 15:50'!
at: position 
	^ self value at: position! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/25/2004 16:45'!
at: position put: newValue 
	self value at: position put: newValue.
! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 13:40'!
attrOrRuleOrValue
	^ attrOrRuleOrValue ! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/25/2004 23:29'!
attrOrRuleOrValue: anAttributeOrWhereRuleOrValue
	attrOrRuleOrValue := anAttributeOrWhereRuleOrValue! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/31/2006 17:21'!
buildSubReferences
	self removeSubReferences.
	subReferences := self value tamarisChildrenIntoOwner: self! !

!PlatypusStepReference methodsFor: 'testing' stamp: 'apl 3/31/2006 13:15'!
canEvaluate
	^ false! !

!PlatypusStepReference methodsFor: 'testing' stamp: 'apl 6/7/2004 14:51'!
canHaveCachedEditor
	"if true, my editor will be cached by the browser so that next editing  
	will reuse cached editor"
	^ false! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 6/3/2004 09:25'!
checks
	^ PlatypusModelContentsResolver new checks: self modelContents! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 14:24'!
children
	^ self subReferences
	! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 9/4/2006 12:22'!
codeText
	^ codeCache
		ifNil: [self  knownAsInvalid
				ifTrue: ['/*Express model must checked*/']
				ifFalse: [codeCache := self codeText: self useP21Syntax]]! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'AlainPlantec 5/4/2012 19:04'!
codeText: p21Syntax 
	| stream val |
	self isReleased
		ifTrue: [^ ''].
	"stream := PlatypusStepCodeStream on: Text new."
	stream := WriteStream on: String new.
	(val := self value) isPltValue
		ifTrue: [
			(val isPltGenericInstance)
				ifTrue: [^ val printableCode].
			PlatypusModelContentsStepWriter new
				stream: stream
				modelContents: self modelContents
				values: (Array with: val)
				p21Syntax: p21Syntax.
			^ stream contents]
		ifFalse: [^ val prettyPrintedExpressCode]! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/25/2004 12:28'!
editorClass
	^ PlatypusStepModelContentsCodeHolder! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'AlainPlantec 5/8/2012 14:05'!
evaluate
	self knownAsInvalid
		ifTrue: [self inform: 'Express model must checked']
		ifFalse: [Cursor wait
				showWhile: [| result int | 
					int := PlatypusExpressInterpretor new.
					self modelContents ifNotNil: [:mc | 
						mc recordComputedInstances
							ifTrue: [int modelContents: self modelContents]].
					 (result := int attributeOrRule: attrOrRuleOrValue instance: self owner value interpretingContext)
						ifNotNil: [self subReferences
								add: (result tamarisStepValueReferenceClass
										owner: self
										position: subReferences size + 1
										value: result).
							TamManager changed: self]]]! !

!PlatypusStepReference methodsFor: 'testing' stamp: 'apl 6/23/2004 23:32'!
hasContents
	^ subReferences notNil and: [subReferences notEmpty]! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 12:22'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/step_value'! !

!PlatypusStepReference methodsFor: 'testing' stamp: 'apl 4/4/2006 14:04'!
isModelContentsReference
	^ false! !

!PlatypusStepReference methodsFor: 'testing' stamp: 'apl 2/23/2005 22:22'!
isPltValue
	^ attrOrRuleOrValue notNil
		and: [attrOrRuleOrValue isPltValue]! !

!PlatypusStepReference methodsFor: 'testing' stamp: 'apl 3/31/2006 13:14'!
isRemoveable
	^ false! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 9/7/2006 14:23'!
knownAsInvalid
	| mdr |
	^ (mdr := self modelContentsReference) ifNil: [false] ifNotNil: [mdr owner knownAsInvalid]! !

!PlatypusStepReference methodsFor: 'file in/out' stamp: 'AlainPlantec 1/28/2011 14:04'!
menuStepWrite
	| stream fullFilename result |
	fullFilename := UITheme current
				fileSaveIn: World
				title: 'File name'
				extensions: #('step' )
				path: ''.
	fullFilename
		ifNotNil: [[stream := (Filename named: fullFilename) writeStream.
			result := self stepWriteIntoStream: stream]
				ensure: [stream close]].
	^ result	
! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 7/22/2004 12:43'!
metaData
	^ self value
! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 9/7/2006 14:25'!
modelContents
	| mdr |
	^ (mdr := self modelContentsReference) ifNotNil: [mdr  modelContents]! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 9/7/2006 14:27'!
modelContentsReference
	^ self owner modelContentsReference! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 5/10/2005 13:55'!
newEditor
	| editor |
	editor := self editorClass new buildTamarisWindow.
	editor model sourceHandler: self.
	^editor! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 6/7/2004 22:27'!
owner: anotherRef position: anInteger 
	self
		owner: anotherRef
		position: anInteger
		attributeOrRule: nil! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 6/25/2004 23:29'!
owner: anotherRef position: anInteger attributeOrRule: anAttributeOrARule 
	self owner: anotherRef;
		 pos: anInteger;
		 attrOrRuleOrValue: anAttributeOrARule.
	self updateListLabel! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/31/2006 16:23'!
owner: anotherRef position: anInteger value: aValue 
	self owner: anotherRef;
		 pos: anInteger;
		 attrOrRuleOrValue: aValue.
! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 17:11'!
parserStartingState
	^ StepParser startingStateForParameter! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/2/2004 12:20'!
pos
	^ pos! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/2/2004 12:20'!
pos: anObject 
	pos := anObject! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/12/2007 13:45'!
reinitializeEditor
	self removeSubReferences.
	codeCache := nil.
	listLabel := nil.
	super reinitializeEditor! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/31/2006 15:22'!
reinitializeLabel
	codeCache := nil.
	listLabel := nil.
	self owner reinitializeLabel! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/31/2006 14:17'!
removeAt: position 
	| sr |
	(self subReferences removeAt: position) destroy.
	position
		to: subReferences size
		do: [:p | (sr := subReferences at: p) pos: sr pos - 1]! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/23/2006 13:24'!
removeSilently
	pos
		ifNotNil: [(self owner removeAt: pos) ].
	^ super removeSilently! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 4/3/2006 15:42'!
removeSubReferences
	subReferences
		ifNotNil: [self removeSubReferencesSilently.
	
			TamManager changed: self]! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 4/3/2006 15:41'!
removeSubReferencesSilently
	subReferences
		ifNotNil: [subReferences
				do: [:instRef | instRef destroy].
			subReferences := nil.
			]! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/31/2006 15:17'!
replaceWithParserResult: result 
	result
		ifNotNil: [self isPltValue
				ifTrue: [self value: result]
				ifFalse: [self owner at: pos put: result.
					self removeSubReferences.
					self checks.
					self reinitializeLabel ].
			^ true].
	^ false! !

!PlatypusStepReference methodsFor: 'tam taxonomy browser' stamp: 'apl 4/3/2006 13:44'!
selectingFrom: aTaxonomyBrowser 
	subReferences
		ifNil: [self owner knownAsInvalid
				ifFalse: [self buildSubReferences]].
	super selectingFrom: aTaxonomyBrowser! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 5/10/2005 13:47'!
specificButtonsColumn: aTaxonomyBrowser inAlignment: aButtonsAlignment 
	aTaxonomyBrowser editorModel addButtonsinAlignment: aButtonsAlignment.
	^aButtonsAlignment! !

!PlatypusStepReference methodsFor: 'menus' stamp: 'apl 4/5/2006 18:57'!
specificMenu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring 
	the #shifted boolean"
	super specificMenu: menu shifted: b.
	menu
				add: 'code pane (p)'
				target: self
				selector: #menuCodePane.
	self canEvaluate
		ifTrue: [menu addLine.
			menu
				add: 'evaluate'
				target: self
				selector: #evaluate.
			menu addLine].
	^ menu! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 14:24'!
subReferences
	^ subReferences
		ifNil: [^ #()]! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 7/29/2004 10:34'!
updateListLabel
	listLabel := self shortName! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/25/2004 12:25'!
useP21Syntax
	^ useP21Syntax
		ifNil: [useP21Syntax := true]! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 7/27/2004 12:37'!
useP21Syntax: anObject 
	useP21Syntax := anObject.
	codeCache := nil.! !

!PlatypusStepReference methodsFor: 'updating' stamp: 'apl 3/23/2006 12:05'!
validationResult: aBoolean 
	self modelContentsReferences validationResult: aBoolean ! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 16:26'!
value
	^ self isPltValue
		ifTrue: [attrOrRuleOrValue]
		ifFalse: [self owner at: pos]! !

!PlatypusStepReference methodsFor: 'accessing' stamp: 'apl 6/25/2004 23:24'!
value: aValue
	attrOrRuleOrValue := aValue
! !

!PlatypusStepReference methodsFor: 'file in/out' stamp: 'apl 7/10/2004 16:42'!
writeIntoStream: aStream 
	| code |
	code := self codeText asString.
	aStream nextPutAll: code.
	aStream flush! !

PlatypusStepReference subclass: #PlatypusStepValueReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

PlatypusStepValueReference subclass: #PlatypusStepAggregateElementValueReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepAggregateElementValueReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 16:15'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/step_computed_value'! !

!PlatypusStepAggregateElementValueReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 16:08'!
value
	^ self owner at: pos! !

PlatypusStepValueReference subclass: #PlatypusStepSimpleValueReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepSimpleValueReference methodsFor: 'menus' stamp: 'apl 4/5/2006 19:02'!
embedClearTextIntoWindow

	TamStringHolder openLabel: self listLabel contents: self value asClearText! !

!PlatypusStepSimpleValueReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 11:42'!
icon
	
		^ TamIcons mimeIcon: '10x10/mimetypes/step_computed_value'! !

!PlatypusStepSimpleValueReference methodsFor: 'menus' stamp: 'apl 4/5/2006 19:06'!
keyStroke: aCharacter from: tamPluggableListMorph 
	self value computedDomain isPltStringType
		ifTrue: [aCharacter = $m
				ifTrue: [^ self embedClearTextIntoWindow]].
	super keyStroke: aCharacter from: tamPluggableListMorph! !

!PlatypusStepSimpleValueReference methodsFor: 'menus' stamp: 'apl 4/5/2006 19:07'!
specificMenu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring 
	the #shifted boolean"
	super specificMenu: menu shifted: b.
	self value computedDomain isPltStringType
		ifTrue: [menu addLine.
			menu
				add: 'open a window with this text (m)'
				target: self
				selector: #embedClearTextIntoWindow.
			menu addLine].
	^ menu! !

!PlatypusStepValueReference methodsFor: 'testing' stamp: 'apl 3/31/2006 13:14'!
isRemoveable
	^ true! !

!PlatypusStepValueReference methodsFor: 'accessing' stamp: 'apl 4/6/2006 17:17'!
shortName
	^ self codeText asString contractTo: 100! !

PlatypusStepReference subclass: #PlatypusStepWhereRuleReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusStepWhereRuleReference methodsFor: 'testing' stamp: 'apl 3/31/2006 13:15'!
canEvaluate
	^ true! !

!PlatypusStepWhereRuleReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 11:39'!
icon
	^ TamIcons mimeIcon: '10x10/mimetypes/where_rule'! !

!PlatypusStepWhereRuleReference methodsFor: 'accessing' stamp: 'apl 3/31/2006 12:19'!
shortName
			attrOrRuleOrValue label
				ifNotNil: [^ attrOrRuleOrValue label].
			^ 'rule #' , pos printString.
! !

TextStream subclass: #PlatypusCodeStream
	instanceVariableNames: 'tokensStyleMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-GenericTokens'!

!PlatypusCodeStream methodsFor: 'data get/put' stamp: 'apl 3/30/2006 14:29'!
nextPutAll: aCollection endingAt: aPosition
	"Optimized access to get around Text at:Put: overhead"
	| n |
	n := aCollection size min: aPosition.
	position + n > writeLimit
		ifTrue: [self growTo: position + n + 10].
	collection
		replaceFrom: position + 1
		to: position + n
		with: aCollection
		startingAt: 1.
	position := position + n! !

!PlatypusCodeStream methodsFor: 'color/style' stamp: 'apl 4/6/2006 20:23'!
tokensStyleMap
	"Answer the map to use to determine colors and styles"
	| colorAndEmphasis |
	^ tokensStyleMap
		ifNil: [tokensStyleMap := Dictionary new.
			#(#(#PlatypusIdentifierToken #()) #(#PlatypusPrimaryElementIdentifierToken #(#(#blue) #(#bold))) #(#PlatypusExpressNativeAlgorithmToken #(#red #(#bold))) #(#PlatypusLiteralToken #()) #(#PlatypusNumberToken #()) #(#PlatypusRemarkToken #(#brown #())) #(#PlatypusBuiltinProcedureToken #()) #(#PlatypusKeywordToken #()) #(#PlatypusBuiltinFunctionToken #()) #(#PlatypusOpenDelimToken #()) #(#PlatypusSemicolonToken #()) #(#PlatypusAssignToken #()) #(#PlatypusEolToken #()) #(#PlatypusWhiteSpaceToken #()) #(#PlatypusOperatorToken #()) #(#PlatypusLogicalToken #()) #(#PlatypusOneWhiteSpaceToken #()) #(#PlatypusStringToken #(#(#black) #(#bold))) #(#PlatypusIndentToken #()) #(#PlatypusCloseKeywordToken #()) #(#PlatypusCloseDelimToken #()) #(#PlatypusTailRemarkToken #(#brown #())) #(#PlatypusGroupKeywordToken #()) #(#PlatypusBuiltinDomainToken #()) #(#PlatypusEmbeddedRemarkToken #(#brown #())) #(#PlatypusDelimToken #()) #(#PlatypusOpenKeywordToken #()) #(#PlatypusPrimaryElementOpenKeywordToken #(#(#blue #muchDarker ) #(#bold))) #(#PlatypusPrimaryElementCloseKeywordToken #(#(#blue  #muchDarker) #(#bold))) #(#PlatypusUnresolvedReferenceToken #(#(#red) #(#bold))) )
				do: [:couple | | cls | (cls := Smalltalk
								at: (couple at: 1)
								ifAbsent: [])
						ifNotNil: [(couple at: 2)
								ifNotEmpty: [:colorSymbolAndEmphasis | 
									colorAndEmphasis := WriteStream
												on: (Array new: 3).
									colorAndEmphasis
										nextPut: (TextColor
												color: (Color colorFrom: colorSymbolAndEmphasis first)).
									colorAndEmphasis
										nextPutAll: (colorSymbolAndEmphasis second
												collect: [:emph | TextEmphasis perform: emph]).
									tokensStyleMap at: cls put: colorAndEmphasis contents]]].
			tokensStyleMap]! !

!PlatypusCodeStream methodsFor: 'color/style' stamp: 'apl 3/30/2006 11:36'!
withColor: color emphasis: emphasisSymbol do: aBlock 
	"Evaluate the given block with the given color and style text 
	attribute"
	| attributes |
	attributes := WriteStream
				on: (Array new: 3).
	attributes
		nextPut: (TextColor
				color: color).
	emphasisSymbol
		do: [:e | attributes
				nextPut: (TextEmphasis perform: e)].
	^ self withAttributes: attributes contents do: aBlock! !

!PlatypusCodeStream methodsFor: 'color/style' stamp: 'apl 3/30/2006 09:32'!
withStyleFor: aClass do: aBlock 
	"Evaluate aBlock with appropriate emphasis and color for the 
	given element"
	| colorsAndStylesMap |
	(colorsAndStylesMap := self tokensStyleMap)
		ifNil: [^ aBlock value].
	^ self
		withStyleInfo: (colorsAndStylesMap
				at: aClass
				ifAbsent: [#()])
		do: aBlock! !

!PlatypusCodeStream methodsFor: 'color/style' stamp: 'apl 3/30/2006 11:54'!
withStyleInfo: colorAndStyle do: aBlock 
	"Evaluate aBlock with appropriate emphasis and color for the given
	element"
	^ colorAndStyle
		ifNotEmpty: [:cas | self withAttributes: cas do: aBlock]
		ifEmpty: [aBlock value].! !

PlatypusCodeStream subclass: #PlatypusStepCodeStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-GenericTokens'!

Error subclass: #PlatypusParserResultAcceptAbort
	instanceVariableNames: 'requestor metaData position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusParserResultAcceptAbort class methodsFor: 'instance creation' stamp: 'apl 3/23/2006 10:11'!
requestor: aRequestor metaData: aMetaData message: aMessage position: aPosition 
	^ self new
		requestor: aRequestor
		metaData: aMetaData
		message: aMessage
		position: aPosition! !

!PlatypusParserResultAcceptAbort methodsFor: 'exceptionDescription' stamp: 'AlainPlantec 5/2/2012 17:32'!
defaultAction
	requestor
		ifNil: [^ super defaultAction]
		ifNotNil: [requestor notify: self messageText at: position]! !

!PlatypusParserResultAcceptAbort methodsFor: 'acessing' stamp: 'apl 3/23/2006 10:11'!
requestor: aRequestor metaData: aMetaData message: aMessage position: aPosition 
	requestor := aRequestor.
	metaData := aMetaData.
	self messageText: aMessage.
	position := aPosition! !

Error subclass: #PlatypusParserResultAcceptingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

WeakIdentityKeyDictionary subclass: #PlatypusWeakIdentityKeyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-VW-Compatibility'!

TamSubListReference subclass: #PlatypusExpressSubListReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusExpressSubListReference methodsFor: 'accessing' stamp: 'apl 5/26/2005 13:58'!
codeHolderClassName ^ #PlatypusExpressCodeHolder ! !

!PlatypusExpressSubListReference methodsFor: 'testing' stamp: 'apl 10/26/2006 19:13'!
isSchemaReference
	^ false! !

!PlatypusExpressSubListReference methodsFor: 'menus' stamp: 'apl 5/26/2005 14:29'!
keyStroke: aCharacter from: aListMorph super keyStroke: aCharacter from: aListMorph . aCharacter = $p ifTrue: [ ^ self menuCodePane ] ! !

!PlatypusExpressSubListReference methodsFor: 'accessing' stamp: 'apl 3/14/2006 09:22'!
schemaInstanceReference ^ self owner schemaInstanceReference ! !

!PlatypusExpressSubListReference methodsFor: 'accessing' stamp: 'apl 1/30/2007 11:37'!
startLevel
	^ 1! !

!PlatypusExpressSubListReference methodsFor: 'accessing' stamp: 'apl 1/30/2007 11:37'!
tokenList
	| tl |
	tl := PlatypusTokenList new.
	self children do: 
			[:hlsr | 
			tl addFrom: (hlsr tokenList beginningOfLineFrom: hlsr startNode)
				to: hlsr stopNode.
			tl add: PlatypusEolToken new.
			tl add: PlatypusEolToken new].
	^ tl! !

!TamManagerItem class methodsFor: '*sqplatypus-hw-creation' stamp: 'apl 1/4/2006 14:20'!
platypusMetaDefaultTaxon
	^ self defaultTaxonNamed: self platypusMetaDefaultTaxonName taxonClass: TamTaxonReference! !

!TamManagerItem class methodsFor: '*sqplatypus-hw-creation' stamp: 'apl 1/4/2006 14:24'!
platypusMetaDefaultTaxonName
	^ '<platypus-meta>'! !

!TamManagerItem class methodsFor: '*sqplatypus-hw-creation' stamp: 'apl 1/4/2006 14:23'!
platypusTranslatorsTaxon
	^ self defaultTaxonNamed: self platypusTranslatorsTaxonName taxonClass: TamTaxonReference! !

!TamManagerItem class methodsFor: '*sqplatypus-hw-creation' stamp: 'apl 1/4/2006 14:24'!
platypusTranslatorsTaxonName
	^ '<platypus-translators>'! !

Tamaris subclass: #Platypus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!Platypus class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/18/2010 10:10'!
menuCommandOn: aBuilder 
	<worldMenu>  
	(aBuilder item: #'Platypus')
		parent: #Tools;
		action: [self open];  
		icon: self taskbarIcon.  ! !

Object subclass: #Filename
	instanceVariableNames: 'publicName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-VW-Compatibility'!

!Filename class methodsFor: 'instance creation' stamp: 'apl 4/11/2006 09:40'!
named: str 
	^ self new publicName: str! !

!Filename methodsFor: 'accessing' stamp: 'apl 4/11/2006 09:39'!
publicName
	^publicName! !

!Filename methodsFor: 'accessing' stamp: 'apl 4/11/2006 09:40'!
publicName: aName 
	publicName := aName! !

!Filename methodsFor: 'stream creation' stamp: 'apl 4/11/2006 09:42'!
readStream
	^ FileStream fileNamed: self publicName! !

!Filename methodsFor: 'stream creation' stamp: 'apl 6/5/2006 10:51'!
writeStream

	^ FileStream forceNewFileNamed: self publicName! !

Object subclass: #Logical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-unimplemented'!

Logical subclass: #LFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-unimplemented'!

!LFalse class methodsFor: 'initialization' stamp: 'apl 3/4/2005 14:24'!
initializedInstance
	^ Smalltalk at: #Lfalse ifAbsentPut: [self basicNew]! !

!LFalse methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:15'!
& alternativeObject 
	"Evaluating conjunction -- answer false since receiver is false."

	^self! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:15'!
and: alternativeBlock 
	"Nonevaluating conjunction -- answer with false since the receiver is false."

	^self! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:15'!
ifFalse: alternativeBlock 
	"Answer the value of alternativeBlock. Execution does not actually
	reach here because the expression is compiled in-line."

	^alternativeBlock value! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:15'!
ifFalse: falseAlternativeBlock ifTrue: trueAlternativeBlock 
	"Answer the value of falseAlternativeBlock. Execution does not
	actually reach here because the expression is compiled in-line."

	^falseAlternativeBlock value! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/6/2005 21:53'!
ifFalse: falseAlternativeBlock ifTrue: trueAlternativeBlock ifUnknown: unknownAlternativeBlock
	"Answer the value of falseAlternativeBlock. Execution does not 
	actually reach here because the expression is compiled in-line."
	^ falseAlternativeBlock value! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:15'!
ifTrue: alternativeBlock 
	"Since the condition is false, answer the value of the false alternative, 
	which is nil. Execution does not actually reach here because the
	expression is compiled in-line."

	^nil! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:15'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock 
	"Answer the value of falseAlternativeBlock. Execution does not
	actually reach here because the expression is compiled in-line."

	^falseAlternativeBlock value! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/6/2005 21:53'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock ifUnknown: unknownAlternativeBlock 
	"Answer the value of falseAlternativeBlock. Execution does not 
	actually reach here because the expression is compiled in-line."
	^ falseAlternativeBlock value! !

!LFalse methodsFor: 'logical operations' stamp: 'AlainPlantec 4/26/2012 09:31'!
not
	"Negation -- answer true since the receiver is false."
	^ LTrue! !

!LFalse methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:15'!
or: alternativeBlock 
	"Nonevaluating disjunction -- answer value of alternativeBlock."

	^alternativeBlock value! !

!LFalse methodsFor: 'printing' stamp: 'apl 3/4/2005 14:26'!
printOn: aStream 
	aStream nextPutAll: 'Lfalse'! !

!LFalse methodsFor: 'logical operations' stamp: 'apl 3/6/2005 21:52'!
| aLogical
	"Evaluating disjunction (OR) -- answer with the argument, aBoolean."
	^ aLogical! !

Logical subclass: #LTrue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-unimplemented'!

!LTrue class methodsFor: 'initialization' stamp: 'apl 3/6/2005 21:49'!
initializedInstance

	^ Smalltalk
		at: #Ltrue
		ifAbsentPut: [self basicNew]! !

!LTrue methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:16'!
& alternativeObject 
	"Evaluating conjunction -- answer alternativeObject since receiver is true."

	^alternativeObject! !

!LTrue methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:16'!
and: alternativeBlock 
	"Nonevaluating conjunction -- answer the value of alternativeBlock since
	the receiver is true."

	^alternativeBlock value! !

!LTrue methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:16'!
ifFalse: alternativeBlock 
	"Since the condition is true, the value is the true alternative, which is nil. 
	Execution does not actually reach here because the expression is compiled 
	in-line."

	^nil! !

!LTrue methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:16'!
ifFalse: falseAlternativeBlock ifTrue: trueAlternativeBlock 
	"Answer the value of trueAlternativeBlock. Execution does not 
	actually reach here because the expression is compiled in-line."

	^trueAlternativeBlock value! !

!LTrue methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:16'!
ifTrue: alternativeBlock 
	"Answer the value of alternativeBlock. Execution does not actually 
	reach here because the expression is compiled in-line."

	^alternativeBlock value! !

!LTrue methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:16'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock 
	"Answer with the value of trueAlternativeBlock. Execution does not 
	actually reach here because the expression is compiled in-line."

	^trueAlternativeBlock value! !

!LTrue methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:16'!
not
	"Negation--answer false since the receiver is true."

	^false! !

!LTrue methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:16'!
or: alternativeBlock 
	"Nonevaluating disjunction -- answer true since the receiver is true."

	^self! !

!LTrue methodsFor: 'printing' stamp: 'apl 3/4/2005 14:16'!
printOn: aStream 

	aStream nextPutAll: 'true'! !

!LTrue methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:16'!
| aBoolean 
	"Evaluating disjunction (OR) -- answer true since the receiver is true."

	^self! !

Logical subclass: #LUnknown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-unimplemented'!

!LUnknown class methodsFor: 'initialization' stamp: 'apl 3/6/2005 21:50'!
initializedInstance
	^ Smalltalk
		at: #Lunknown
		ifAbsentPut: [self basicNew]! !

!LUnknown methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:17'!
& alternativeObject 
	"Evaluating conjunction -- answer false since receiver is false."

	^self! !

!LUnknown methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:17'!
and: alternativeBlock 
	"Nonevaluating conjunction -- answer with false since the receiver is false."

	^self! !

!LUnknown methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:17'!
ifFalse: alternativeBlock 
	"Answer the value of alternativeBlock. Execution does not actually
	reach here because the expression is compiled in-line."

	^alternativeBlock value! !

!LUnknown methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:17'!
ifFalse: falseAlternativeBlock ifTrue: trueAlternativeBlock 
	"Answer the value of falseAlternativeBlock. Execution does not
	actually reach here because the expression is compiled in-line."

	^falseAlternativeBlock value! !

!LUnknown methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:17'!
ifTrue: alternativeBlock 
	"Since the condition is false, answer the value of the false alternative, 
	which is nil. Execution does not actually reach here because the
	expression is compiled in-line."

	^nil! !

!LUnknown methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:17'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock 
	"Answer the value of falseAlternativeBlock. Execution does not
	actually reach here because the expression is compiled in-line."

	^falseAlternativeBlock value! !

!LUnknown methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:17'!
not
	"Negation -- answer true since the receiver is false."

	^true! !

!LUnknown methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:17'!
or: alternativeBlock 
	"Nonevaluating disjunction -- answer value of alternativeBlock."

	^alternativeBlock value! !

!LUnknown methodsFor: 'printing' stamp: 'apl 3/4/2005 14:17'!
printOn: aStream 

	aStream nextPutAll: 'false'! !

!LUnknown methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:17'!
| aBoolean 
	"Evaluating disjunction (OR) -- answer with the argument, aBoolean."

	^aBoolean! !

!Logical class methodsFor: 'instance creation' stamp: 'apl 3/4/2005 14:05'!
initializedInstance
	^ nil! !

!Logical class methodsFor: 'instance creation' stamp: 'apl 3/4/2005 14:19'!
new
	self error: 'You may not create any more Logical - this is three-valued logic'! !

!Logical methodsFor: 'logical operations' stamp: 'apl 3/6/2005 21:38'!
& aLogical 
	"Evaluating conjunction. Evaluate the argument. Then answer true if  
	both the receiver and the argument are true."
	self subclassResponsibility! !

!Logical methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:05'!
==> aBlock
	"this is material implication, a ==> b, also known as:
			b if a 
			a implies b
			if a then b
			b is a consequence of a
			a therefore b (but note: 'it is raining therefore it is cloudy' is implication; 'it is autumn therefore the leaves are falling' is equivalence).
		
	Here is the truth table for material implication (view in a monospaced font):
	
	   p   |   q   |   p ==> q
	-------|-------|-------------
	   T   |   T   |      T
	   T   |   F   |      F
	   F   |   T   |      T
	   F   |   F   |      T
	"

	^self not or: [aBlock value]! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
and: alternativeBlock 
	"Nonevaluating conjunction. If the receiver is true, answer the value of 
	the argument, alternativeBlock; otherwise answer false without 
	evaluating the argument."

	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
and: block1 and: block2
	"Nonevaluating conjunction without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as false, then return false immediately,
		without evaluating any further blocks.
	If all return true, then return true."

	self ifFalse: [^ false].
	block1 value ifFalse: [^ false].
	block2 value ifFalse: [^ false].
	^ true! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
and: block1 and: block2 and: block3
	"Nonevaluating conjunction without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as false, then return false immediately,
		without evaluating any further blocks.
	If all return true, then return true."

	self ifFalse: [^ false].
	block1 value ifFalse: [^ false].
	block2 value ifFalse: [^ false].
	block3 value ifFalse: [^ false].
	^ true! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
and: block1 and: block2 and: block3 and: block4
	"Nonevaluating conjunction without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as false, then return false immediately,
		without evaluating any further blocks.
	If all return true, then return true."

	self ifFalse: [^ false].
	block1 value ifFalse: [^ false].
	block2 value ifFalse: [^ false].
	block3 value ifFalse: [^ false].
	block4 value ifFalse: [^ false].
	^ true! !

!Logical methodsFor: 'printing' stamp: 'apl 3/6/2005 21:45'!
basicType
	"Answer a symbol representing the inherent type of the receiver"
	^ #Logical! !

!Logical methodsFor: 'copying' stamp: 'apl 3/4/2005 14:05'!
clone 
	"Receiver has two concrete subclasses, True and False.
	Only one instance of each should be made, so return self."! !

!Logical methodsFor: 'copying' stamp: 'apl 3/4/2005 14:05'!
deepCopy 
	"Receiver has two concrete subclasses, True and False.
	Only one instance of each should be made, so return self."! !

!Logical methodsFor: 'logical operations' stamp: 'apl 3/6/2005 21:39'!
eqv: aLogical
	"Answer true if the receiver is equivalent to aBoolean."
	^ self == aLogical! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
ifFalse: alternativeBlock 
	"If the receiver is true (i.e., the condition is true), then the value is the 
	true alternative, which is nil. Otherwise answer the result of evaluating 
	the argument, alternativeBlock. Create an error notification if the 
	receiver is nonBoolean. Execution does not actually reach here because 
	the expression is compiled in-line."

	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
ifFalse: falseAlternativeBlock ifTrue: trueAlternativeBlock 
	"Same as ifTrue:ifFalse:."

	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/6/2005 21:47'!
ifFalse: falseAlternativeBlock ifTrue: trueAlternativeBlock ifUnknown: unknownAlternativeBlock 
	"Same as ifTrue:ifFalse:."
	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
ifTrue: alternativeBlock 
	"If the receiver is false (i.e., the condition is false), then the value is the 
	false alternative, which is nil. Otherwise answer the result of evaluating 
	the argument, alternativeBlock. Create an error notification if the 
	receiver is nonBoolean. Execution does not actually reach here because 
	the expression is compiled in-line."

	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock
	"If the receiver is true (i.e., the condition is true), then answer the value 
	of the argument trueAlternativeBlock. If the receiver is false, answer the 
	result of evaluating the argument falseAlternativeBlock. If the receiver 
	is a nonBoolean then create an error notification. Execution does not 
	actually reach here because the expression is compiled in-line."

	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/6/2005 21:46'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock ifUnknown: unknownAlternativeBlock
	"If the receiver is true (i.e., the condition is true), then answer the value  
	of the argument trueAlternativeBlock. If the receiver is false, answer the 
	result of evaluating the argument falseAlternativeBlock. If the receiver  
	is a nonBoolean then create an error notification. Execution does not  
	actually reach here because the expression is compiled in-line."
	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/6/2005 21:46'!
ifUnknown: alternativeBlock 
	"If the receiver is true (i.e., the condition is true), then the value is the  
	true alternative, which is nil. Otherwise answer the result of evaluating  
	the argument, alternativeBlock. Create an error notification if the  
	receiver is nonBoolean. Execution does not actually reach here because  
	the expression is compiled in-line."
	self subclassResponsibility! !

!Logical methodsFor: 'misc' stamp: 'apl 3/4/2005 14:05'!
newTileMorphRepresentative
	^ TileMorph new addArrows; setLiteral: self
! !

!Logical methodsFor: 'logical operations' stamp: 'apl 3/4/2005 14:05'!
not
	"Negation. Answer true if the receiver is false, answer false if the 
	receiver is true."

	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
or: alternativeBlock 
	"Nonevaluating disjunction. If the receiver is false, answer the value of 
	the argument, alternativeBlock; otherwise answer true without 
	evaluating the argument."

	self subclassResponsibility! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
or: block1 or: block2
	"Nonevaluating alternation without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as true, then return true immediately,
		without evaluating any further blocks.
	If all return false, then return false."

	self ifTrue: [^ true].
	block1 value ifTrue: [^ true].
	block2 value ifTrue: [^ true].
	^ false! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
or: block1 or: block2 or: block3
	"Nonevaluating alternation without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as true, then return true immediately,
		without evaluating any further blocks.
	If all return false, then return false."

	self ifTrue: [^ true].
	block1 value ifTrue: [^ true].
	block2 value ifTrue: [^ true].
	block3 value ifTrue: [^ true].
	^ false! !

!Logical methodsFor: 'controlling' stamp: 'apl 3/4/2005 14:05'!
or: block1 or: block2 or: block3 or: block4
	"Nonevaluating alternation without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as true, then return true immediately,
		without evaluating any further blocks.
	If all return false, then return false."

	self ifTrue: [^ true].
	block1 value ifTrue: [^ true].
	block2 value ifTrue: [^ true].
	block3 value ifTrue: [^ true].
	block4 value ifTrue: [^ true].
	^ false! !

!Logical methodsFor: 'copying' stamp: 'apl 3/4/2005 14:05'!
shallowCopy 
	"Receiver has two concrete subclasses, True and False.
	Only one instance of each should be made, so return self."! !

!Logical methodsFor: 'printing-sixx' stamp: 'apl 3/4/2005 14:05'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !

!Logical methodsFor: 'printing' stamp: 'apl 3/4/2005 14:05'!
storeOn: aStream 
	"Refer to the comment in Object|storeOn:."

	self printOn: aStream! !

!Logical methodsFor: 'copying' stamp: 'apl 3/4/2005 14:05'!
veryDeepCopyWith: deepCopier
	"Return self.  I can't be copied.  Do not record me."! !

!Logical methodsFor: 'logical operations' stamp: 'apl 3/6/2005 21:39'!
xor: aLogical 
	"Exclusive OR. Answer true if the receiver is not equivalent to aBoolean."
	^ (self == aLogical) not! !

!Logical methodsFor: 'logical operations' stamp: 'apl 3/6/2005 21:39'!
| aLogical 
	"Evaluating disjunction (OR). Evaluate the argument. Then answer true  
	if either the receiver or the argument is true."
	self subclassResponsibility! !

Object subclass: #PlatypusExpressWrapper
	instanceVariableNames: 'owner wrapped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

!PlatypusExpressWrapper class methodsFor: 'instance creation' stamp: 'apl 3/12/2004 17:51'!
linked: anExpressReference ^ self new linked: anExpressReference owner: nil ! !

!PlatypusExpressWrapper class methodsFor: 'instance creation' stamp: 'apl 3/12/2004 17:46'!
linked: anExpressReference owner: anotherExpressReference ^ self new linked: anExpressReference owner: anotherExpressReference ! !

!PlatypusExpressWrapper methodsFor: 'visiting' stamp: 'apl 3/15/2004 10:46'!
accept: aVisitor ^ self linked accept: aVisitor ! !

!PlatypusExpressWrapper methodsFor: 'visiting' stamp: 'AlainPlantec 5/8/2012 20:29'!
acceptTry: aVisitor 
	^ self linkedMetaData ifNotNil: [ self linkedMetaData acceptTry: aVisitor ] ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 3/15/2004 10:20'!
asStringOrText ^ self linked asStringOrText ! !

!PlatypusExpressWrapper methodsFor: 'error handling' stamp: 'apl 4/7/2006 14:17'!
doesNotUnderstand: aMessage ^ wrapped perform: aMessage selector withArguments: aMessage arguments ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 6/10/2004 18:38'!
fullCodeString ^ self linked fullCodeString ! !

!PlatypusExpressWrapper methodsFor: 'testing' stamp: 'apl 3/15/2004 10:54'!
isLink ^ true ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 4/7/2006 14:17'!
linked ^ wrapped ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 4/7/2006 14:17'!
linked: anObject wrapped := anObject ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 3/12/2004 17:47'!
linked: anExpressReference owner: anotherExpressReference self linked: anExpressReference . self owner: anotherExpressReference ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 5/11/2004 23:29'!
linkedMetaData ^ self linked metaData ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 3/12/2004 17:45'!
owner ^ owner ! !

!PlatypusExpressWrapper methodsFor: 'accessing' stamp: 'apl 3/12/2004 17:45'!
owner: anObject owner := anObject ! !

PlatypusExpressWrapper subclass: #PlatypusSchemaWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-tamaris'!

Object subclass: #PlatypusVisitorErrorWrapper
	instanceVariableNames: 'wrapped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqPlatypus-HW-CodeHolder'!

!PlatypusVisitorErrorWrapper class methodsFor: 'instance creation' stamp: 'apl 4/18/2006 08:48'!
wrapped: aStepError
	^ self new wrapped: aStepError! !

!PlatypusVisitorErrorWrapper methodsFor: 'converting' stamp: 'apl 4/18/2006 08:49'!
asString
	^ wrapped asString! !

!PlatypusVisitorErrorWrapper methodsFor: 'accessing' stamp: 'apl 3/22/2007 19:51'!
icon
	| found |
	found := self path reversed
				detect: [:elem | (elem respondsTo: #tamarisItemRef) and: [elem  tamarisItemRef notNil]]
				ifNone: [^ nil].
	^ found tamarisItemRef icon! !

!PlatypusVisitorErrorWrapper methodsFor: 'accessing' stamp: 'apl 4/18/2006 09:37'!
message
	^ wrapped message! !

!PlatypusVisitorErrorWrapper methodsFor: 'accessing' stamp: 'apl 4/18/2006 09:39'!
metaData
	^ wrapped metaData
! !

!PlatypusVisitorErrorWrapper methodsFor: 'accessing' stamp: 'apl 4/18/2006 09:36'!
path
	^ wrapped path! !

!PlatypusVisitorErrorWrapper methodsFor: 'accessing' stamp: 'apl 9/19/2007 11:37'!
selectingFrom: aHierarchicalList 
	| editor firstIndex elem |
	editor := aHierarchicalList clientModel.
	(firstIndex := self path indexOf: editor sourceHandler metaData) > 0
		ifTrue: [editor
				selectionInterval: (1 to: 0).
			editor selectCode: ''.
			editor codeSelectionInterval: (self path at: firstIndex) selectionString startingAt: 1.
			firstIndex + 1
				to: self path size
				do: [:pos | 
					elem := self path at: pos.
					editor selectCode: elem selectionString startingAt: editor selectionInterval first.
					editor selectionInterval: editor selectionInterval]]! !

!PlatypusVisitorErrorWrapper methodsFor: 'accessing' stamp: 'apl 4/18/2006 09:38'!
unSelectingFrom: aHierarchicalList 
	| editor |
	editor := aHierarchicalList clientModel.
	editor selectFrom: editor selectionInterval first to: editor selectionInterval first - 1! !

!PlatypusVisitorErrorWrapper methodsFor: 'accessing' stamp: 'apl 4/18/2006 08:57'!
wrapped: aStepError
	wrapped := aStepError! !
PlatypusSchemaInstanceReference initialize!
PlatypusModelContentsReference initialize!
